# <#
#  .SYNOPSIS
#     Build solution for CDPx container.
#
#  .DESCRIPTION
#     Build solution for CDPx container.
# #>

$root = Split-Path $PSScriptRoot -Parent
$sln = "$root\Master.sln"
$buildExe = "$env:VS2017\MSBuild\15.0\Bin\msbuild.exe"
$buildConfiguration = "Release"
$buildPlatform = "x64"

# clean
& $buildExe $sln /m /t:"Clean" /p:platform=$buildPlatform /p:configuration=$buildConfiguration

if ($LASTEXITCODE -ne 0) {
    Write-Error "Failed to clean solution"
    exit $LASTEXITCODE
}

# build
& $buildExe $sln /m /p:platform=$buildPlatform /p:configuration=$buildConfiguration

if ($LASTEXITCODE -ne 0) {
    Write-Error "Failed to build solution"
    exit $LASTEXITCODE
}