# <#
#  .SYNOPSIS
#     Restore Nuget for CDPx container.
#  .DESCRIPTION
#     Restore Nuget for CDPx container.
# #>

# Personal Access Token used to authenticate package sources. CDPx stores it in CDP_DEFAULT_CLIENT_PACKAGE_PAT environment variable. 
# For local testing, lookup how to get your own VSTS PAT and create a local CDP_DEFAULT_CLIENT_PACKAGE_PAT environment variable
if (-not $env:CDP_DEFAULT_CLIENT_PACKAGE_PAT) {
    throw "CDP_DEFAULT_CLIENT_PACKAGE_PAT environment variable is not found. PAT is needed to access NuGet feeds. If testing locally, create a CDP_DEFAULT_CLIENT_PACKAGE_PAT with a VSTS PAT value."
}

$root = Split-Path $PSScriptRoot -Parent
$sln = "$root\Master.sln"

# Run restore
nuget restore -NonInteractive $sln -NoCache -Verbosity Normal

Write-Host "Nuget packages restored."