# <#
#  .SYNOPSIS
#     Run unit tests for CDPx container.
#
#  .DESCRIPTION
#     Run unit tests for CDPx container.
# #>

$root = Split-Path $PSScriptRoot -Parent
$testExe = "$env:VS2017\Common7\IDE\CommonExtensions\Microsoft\TestWindow\vstest.console.exe"
$testSettings = "$root\build\local.runsettings"

# Find the test assemblies. We find all Microsoft.Azure.LocationServices.*unittest*.dll's that are not in obj or packages.
$testAssemblies = @()
Get-ChildItem -Recurse -Filter "Microsoft.Azure.LocationServices.*unittest*.dll" -Path $root | Where-Object {$_.FullName -notmatch '.*\\obj\\.*' -and $_.FullName -notmatch '.*\\packages\\.*' } | foreach {
    $testFile = $_.FullName
    Write-Host "Adding '$testFile' to test assemblies"
    $testAssemblies += $testFile
}

& $testExe $testAssemblies /Settings:$testSettings /logger:trx

if ($LASTEXITCODE -ne 0) {
    Write-Error "Failed to run tests"
    exit $LASTEXITCODE
}