﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Controllers
{
    using System.Collections.Generic;
    using System.Net.Http;

    public class HeartbeatController : BaseProxyController
    {
        public HttpResponseMessage GetHeartbeat()
        {
            {
                try
                {
                    BaseProxyHeartbeat proxyObj = (BaseProxyHeartbeat)versionObject.GetProxyObj(this.Version, BaseProxy.ProxyType.Heartbeat, this.ProxyOperation);
                    if (proxyObj != null)
                    {
                        this.response = this.Request.CreateResponse(System.Net.HttpStatusCode.OK);
                    }
                    else
                    {
                        throw (new ProxyException(ProxyException.ExceptionType.ServerError, "failed to initialize proxy object failed"));
                    }
                }
                catch (ProxyException ex)
                {
                    this.response = this.BuildErrorResponseAndLog(ex);
                }

                return this.response;
            }
        }

        internal override void ClientValidateParameters()
        {
        }

        internal override void ClientOverrideRequest(string query, ref Dictionary<string, List<string>> querystrings)
        {
        }
    }
}