﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 
namespace Microsoft.Azure.LocationServices.Instrumentation
{
    using System;

    public interface IProxyOperation : IOperationAgent
    {
        string ResourceId { get; }

        BaseProxy.ProxyType ProxyType { get; set; }

        string OperationSourceName { get; set; }

        void Log_SubscriptionId(string SubscriptionId);

        void Log_TrackingId(string TrackingId);

        void Log_APIM_PROXY(string APIM_PROXY);

        void Log_PROXY_EXT(string PROXY_EXT);

        void Log_EXT_PROXY(string EXT_PROXY, int EXT_PROXY_ResponseCode);

        void Log_PROXY_APIM(string PROXY_APIM, int PROXY_APIM_ResponseCode);

        void Log_Proxy_ms(Int32 duration);

        void Log_EXT_ms(Int32 duration);

        /// <summary>
        /// Set resource id for account specific metrics and logging
        /// </summary>
        /// <param name="resourceId">The resource id for the account in Azure Resource Manager</param>
        void Log_ResourceId(string resourceId);

        void Log_ProxyOperationMetrics();

        void Log_ClientSessionId(string clientSessionId);
    }
}