﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
namespace Microsoft.Azure.LocationServices.Instrumentation.Models
{
    /// <summary>
    /// An interface for an MDM metric logger.
    /// Represents a metric and includes a method for appending its dimension values to Geneva.
    /// </summary>
    public interface IMetricLogger
    {
        /// <summary>
        /// Parse OperationDetails and log metric dimension values to Geneva
        /// </summary>
        /// <param name="operationDetails">Operation details containing information on dimension values</param>
        /// <param name="duration">Time taken for an operation in ms</param>
        void LogDimensionValues(OperationDetails operationDetails, int duration);
    }
}