﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Models
{
    using System;
    using System.Net.Http;
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.Instrumentation;

    public abstract class BaseProxyBatch : BaseProxy
    {
        protected BaseProxyBatch(IProxyOperation proxyOperation) : base(proxyOperation)
        {
        }

        public abstract Task<HttpResponseMessage> BatchProxyPost(Uri requestUri, string requestBody, string accountId);

        public abstract Task<HttpResponseMessage> BatchProxyGet(Uri requestUri, string batchId);

        internal override void ClientValidateReponse(ref HttpResponseMessage response)
        {
        }
    }
}