﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Models
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// This Interface defines the serialization methods required to convert a valid GeoJSON format to a custom format.
    /// Any service that accepts a custom format should implement this interface and provide the custom serialization logic 
    /// as part of the implementation. 
    /// </summary>
    interface IBatchCustomSerializationProvider
    {
        /// <summary>
        /// Serializes the input query list to a custom string object.
        /// </summary>
        /// <param name="requestUri">Request Uri</param>
        /// <param name="queryList">list of string queries</param>
        /// <returns>A custom serialized string</returns>
        string SerializeBatchQueryList(Uri requestUri, IList<string> queryList);
    }
}