﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
namespace Microsoft.Azure.LocationServices
{
    using System;
    using System.Net;
    using System.Net.Http;
    using System.Net.Http.Headers;
    using System.Threading.Tasks;
    using GeoAPI.Geometries;
    using Microsoft.Azure.LocationServices.Controllers;
    using Microsoft.Azure.LocationServices.Instrumentation;
    using Newtonsoft.Json;

    public abstract class BaseProxyGeofence : BaseProxy
    {
        public BaseProxyGeofence(IProxyOperation proxyOperation) : base(proxyOperation)
        {   
        }

        public static HttpResponseMessage CreateResponseMessage(GeofenceResponseBody responseBody)
        {
            var content = new StringContent(JsonConvert.SerializeObject(responseBody));

            content.Headers.ContentType = new MediaTypeHeaderValue("application/json");

            return new HttpResponseMessage(responseBody.response_code) { Content = content };
        }

        internal override void ClientValidateReponse(ref HttpResponseMessage response)
        {
        }

        internal abstract Task<HttpResponseMessage> SearchGeoFence(string formatstring, string accountId, string udid, IPoint userLocation, DateTime usertime, double searchRadiusInMeters, GeofenceResponseBody responseBody);
    }
}