﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="MicrosoftV1GeofenceProxy.cs" company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// --------------------------------------------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices
{
    using System;
    using System.Collections.Generic;
    using System.Net;

    public class GeofenceResponseBody
    {
        public List<Issue> issues { get; set; } = new List<Issue>();

        public HttpStatusCode response_code { get; set; }

        public List<Geometry> geometries { get; set; } = new List<Geometry>();
    }

    public class Issue
    {
        public string message { get; set; }

        public string type { get; set; }

        public Exception innerException { get; set; }
    }

    public class Geometry
    {
        public string geometryId { get; set; }

        public double distance { get; set; }

        public double nearestLat { get; set; }

        public double nearestLon { get; set; }
    }
}
