﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices
{
    using System;
    using System.Collections.Generic;
    using GeoJSON.Net.Geometry;

    /// <summary>
    /// This Interface defines the serialization methods required to convert the input query list to a custom string format.
    /// Any service that accepts a custom format should implement this interface and provide the custom serialization logic 
    /// as part of the implementation. 
    /// </summary>
    public interface IRouteCustomSerializationProvider
    {
        string ConvertLBSPositionsIntoTargetBody(List<Position> originList, List<Position> destinationList);

        List<int> GetMatrixResponseCodesFromClientResponse(string responseString);
    }
}