﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices
{
    using System;
    using System.Collections.Generic;
    using System.Net.Http;
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.Instrumentation;

    public abstract class BaseProxySearch : BaseProxy
    {
        public BaseProxySearch(IProxyOperation proxyOperation) : base(proxyOperation)
        {
        }

        public enum SearchType
        {
            Fuzzy,
            POI,
            POICategory,
            Address,
            AddressStructured,
            ReverseAddress,
            CrossStreet,            
            Nearby,
            LowBandWidth,
            AlongRoute,
            Geometry,
            PolygonData
        }

        public abstract Task<HttpResponseMessage> SearchProxy(
            SearchType searchType,
            string querystring,
            string formatstring,
            Dictionary<string, List<string>> querystrings,
            string requestBody = null);

        public abstract Task<HttpResponseMessage> SearchProxy(
            SearchType searchType,
            string querystring,
            string formatstring,
            Dictionary<string, List<string>> querystrings,
            string position,
            string heading,
            string requestBody = null);

        internal override void ClientValidateReponse(ref HttpResponseMessage response)
        {
        }
    }
}