﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices
{
    using System.Collections.Generic;
    using System.Net.Http;
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.Instrumentation;

    public abstract class BaseProxyTimezone : BaseProxy
    {
        public BaseProxyTimezone(IProxyOperation proxyOperation) : base(proxyOperation)
        {
        }

        public enum TimezoneType
        {
            ByID,
            ByCoordinates,
            IANAVersion,
            WindowsToIANA,
            EnumWindows,
            EnumIANA
        }

        public abstract Task<HttpResponseMessage> TimezoneProxy(
            TimezoneType searchType,
            string queryParam1,
            string formatstring,
            Dictionary<string, List<string>> headers,
            Dictionary<string, List<string>> querystrings);

        internal override void ClientValidateReponse(ref HttpResponseMessage response)
        {
        }
    }
}