﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Utility
{
    /// <summary>
    /// This class should contain all the constants that are 
    /// shared between the different classes in the solution 
    /// </summary>
    public static class Constants
    {
        // Media types
        public const string JsonMediaType = "application/json";

        // Request param keys - Common
        public const string SubscriptionKey = "subscription-key";
        public const string SubscriptionIdKey = "subscription-id";
        public const string TrackingIdKey = "tracking-id";
        public const string ApiVersionKey = "api-version";
        public const string QueryKey = "query";
        public const string AccountIdKey = "account-id";

        // Request param keys - Custom
        public const string BatchKey = "batch";
        public const string BatchApiQueryListKey = "queries";
        public const string RouteMatrixResponseUniqueIdKey = "matrixRequestId";
        public const string ForceAsyncKey = "forceAsync";
        public const string GeometryQueryParamKey = "geometry";
        public const string RouteQueryParamKey = "route";
        public const string LimitParamKey = "limit";
        public const string MaxDetourTimeParamKey = "maxDetourTime";
        public const string GeoJsonCircleRadiusKey = "radius";
        public const string GeoJsonSubTypeKey = "subType";
        public const string UserDataUploadFormatKey = "format";
        public const string GeometriesQueryParamKey = "geometries";
        public const string BatchIdKey = "batchId";
        public const string BatchQueryIndexKey = "bqi";

        public const char ForwardSlash  = '/';
        public const string DefaultHost = "atlas.microsoft.com";

        // Error Response Messages
        public const string ErrorMessageBadRequest = "Bad request: one or more parameters were incorrectly specified or are mutually exclusive.";
        public const string ErrorMessageUnauthorized = "Unauthorized: Access is denied due to invalid credentials.";
        public const string ErrorMessageForbidden = "Permission, capacity, or authentication issues.";
        public const string ErrorMessageNotFound = "Not Found: the requested resource could not be found, but it may be available again in the future.";
        public const string ErrorMessageServer = "An error occurred while processing the request. Please try again later.";
        public const string ErrorMessageUnknown = "Unknown Error. Please try again later.";
    }
}