﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Utility
{
    using Microsoft.Azure.LocationServices.Instrumentation;

    /// <summary>
    /// The development environment definition.
    /// </summary>
    public class ProxyHostDevSettings : ProxyHostSettings
    {
        /// <inheritdoc />
        public override string AADTenant => "azureiotsolutions.onmicrosoft.com";

        public override string HostName => "localhost";

        /// <inheritdoc />
        public override string AADAudience => "https://azureiotsolutions.onmicrosoft.com/d056850c-9f27-4a8b-9cd2-80369ab5b25f";

        /// <inheritdoc />
        public override bool EnableAADAuthentication => true;        

        /// <inheritdoc />
        public override InitParams MdmParameters
        {
            get
            {
                var p = new InitParams("DevTestIfx", "AzLocTest");
                p.SetLocalTracing(@"c:\ifxTrace");
                p.SetEtwProvider("DevTest", "DB25DB83-F4C7-4D76-9DBA-5D08A7DEC472");
                return p;
            }
        }

        /// <inheritdoc />
        public override string MdpApiScheme => "http";

        /// <inheritdoc />
        public override string MdpApiFqdn => "localhost";

        /// <inheritdoc />
        public override bool MdpApiEnabled => true;
    }
}
