﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Utility
{
    using Microsoft.Azure.LocationServices.Instrumentation;

    /// <summary>
    /// The production environment definition.
    /// </summary>
    public class ProxyHostProdSettings : ProxyHostSettings
    {
        /// <inheritdoc />
        public override string AADTenant => "azureiotsolutions.onmicrosoft.com";

        public override string HostName => "atlas.microsoft.com";

        /// <inheritdoc />
        public override string AADAudience => "https://azureiotsolutions.onmicrosoft.com/23775bc9-ed13-4942-8a1d-c536ccf6a231";

        /// <inheritdoc />
        public override bool EnableAADAuthentication => true;

        /// <inheritdoc />
        public override InitParams MdmParameters => new InitParams("AzLocSvcIfx", "AzLocSvc");

        /// <inheritdoc />
        public override string MdpApiScheme => "http";

        /// <inheritdoc /> 
        public override string MdpApiFqdn => "mdp.maps.azure.com";

        /// <inheritdoc />
        public override bool MdpApiEnabled => false;
    }
}
