﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Utility
{
    using Microsoft.Azure.LocationServices.Instrumentation;

    /// <summary>
    /// The staging environment definition.
    /// </summary>
    public class ProxyHostStagingSettings : ProxyHostSettings
    {
        /// <inheritdoc />
        public override string AADTenant => "azureiotsolutions.onmicrosoft.com";

        public override string HostName => "s-atlas.azure-api.net";

        /// <inheritdoc />
        public override string AADAudience => "https://azureiotsolutions.onmicrosoft.com/8cb543ff-3533-4665-9bed-c418f4eb8620";

        /// <inheritdoc />
        public override bool EnableAADAuthentication => true;

        /// <inheritdoc />
        public override InitParams MdmParameters => new InitParams("AzLocStgIfx", "AzLocStg");

        /// <inheritdoc />
        public override string MdpApiScheme => "http";

        /// <inheritdoc /> 
        public override string MdpApiFqdn => "mdp.maps.azure.com";

        /// <inheritdoc />
        public override bool MdpApiEnabled => true;
    }
}
