﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Utility
{
    using Microsoft.Azure.LocationServices.Instrumentation;

    /// <summary>
    /// The Integration/Test environment definition.
    /// </summary>
    public class ProxyHostTestSettings : ProxyHostSettings
    {
        /// <inheritdoc />
        public override string AADTenant => "azureiotsolutions.onmicrosoft.com";

        public override string HostName => "t-atlas.azure-api.net";

        /// <inheritdoc />
        public override string AADAudience => "https://azureiotsolutions.onmicrosoft.com/4f8f92fa-1c42-49aa-960b-8a42e5aef433";

        /// <inheritdoc />
        public override bool EnableAADAuthentication => true;

        /// <inheritdoc />
        public override InitParams MdmParameters
        {
            get
            {
                var p = new InitParams("DevTestIfx", "AzLocTest");
                return p;
            }
        }

        /// <inheritdoc />
        public override string MdpApiScheme => "http";

        /// <inheritdoc /> 
        public override string MdpApiFqdn => "mdp.maps.azure.com";

        /// <inheritdoc />
        public override bool MdpApiEnabled => true;
    }
}
