﻿// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common.Models
{
    using System.Collections.Generic;
    using Microsoft.Azure.LocationServices.Common.Validation;
    using Newtonsoft.Json;

    [JsonObject]
    public class BatchRequestBody
    {
        public BatchRequestBody(List<string> queries)
        {
            Assert.ParamIsNotNull(queries, nameof(queries));

            this.Queries = queries;
        }

        [JsonProperty("queries")]
        public List<string> Queries { get; set; }
    }
}