﻿// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common.Models
{
    using System.Collections.Generic;
    using Newtonsoft.Json;

    [JsonObject]
    public class Geometry
    {
        public Geometry(string type, List<double> point)
        {
            this.Type = type;
            this.Coordinate = point;
        }

        [JsonProperty("type")]
        public string Type { get; set; }

        [JsonProperty("coordinates")]
        public IEnumerable<double> Coordinate { get; set; }
    }

    [JsonObject]
    public class Polygon
    {
        public Polygon(List<List<double>> coords)
        {
            this.Type = "Polygon";
            this.Coordinates = new List<List<List<double>>>() { coords };
        }

        [JsonProperty("type")]
        public string Type { get; set; }

        [JsonProperty("coordinates")]
        public List<List<List<double>>> Coordinates { get; set; }
    }
}
