﻿// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common.Models
{
    using System.Collections.Generic;
    using Newtonsoft.Json;

    [JsonObject]
    public class GeometryCollection
    {
        public GeometryCollection(List<List<double>> coordinateList)
        {
            this.Type = "GeometryCollection";
            this.Geometries = new List<Polygon>() { new Polygon(coordinateList) };
        }

        [JsonProperty("type")]
        public string Type { get; set; }

        [JsonProperty("geometries")]
        public List<Polygon> Geometries { get; set; }
    }
}
