﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common
{
    using System.Net.Http;
    using System.Threading.Tasks;

    public partial class MapsClient
    {
        #region Batch Controller - SearchAddressBatch
        
        public Task<HttpResponseMessage> PostSearchAddressBatch(string format, StringContent httpContent)
        {
            var url = MapsUriBuilder.PostSearchAddressBatchUrl(format);
            return this.PostAsync(url, httpContent);
        }

        #endregion

        #region Batch Controller - SearchAddressReverseBatch

        public Task<HttpResponseMessage> PostSearchAddressReverseBatch(string format, StringContent httpContent)
        {
            var url = MapsUriBuilder.PostSearchAddressReverseBatchUrl(format);
            return this.PostAsync(url, httpContent);
        }

        #endregion

        #region Batch Controller - SearchFuzzyBatch

        public Task<HttpResponseMessage> PostSearchFuzzyBatch(string format, StringContent httpContent)
        {
            var url = MapsUriBuilder.PostSearchFuzzyBatchUrl(format);
            return this.PostAsync(url, httpContent);
        }

        #endregion

        #region Batch Controller - RouteDirectionsBatch

        public Task<HttpResponseMessage> PostRouteDirectionsBatch(string format, StringContent httpContent)
        {
            var url = MapsUriBuilder.PostRouteDirectionsBatchUrl(format);
            return this.PostAsync(url, httpContent);
        }

        #endregion
    }
}