﻿// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common
{
    using System.Net.Http;
    using System.Threading.Tasks;

    public partial class MapsClient
    {
        #region MapCopyright Controller

        public Task<HttpResponseMessage> GetCopyRightCaption(string format = Constants.Json)
        {
            var url = MapsUriBuilder.GetCopyRightCaptionUrl(format);
            return this.GetAsync(url);
        }

        public Task<HttpResponseMessage> GetCopyRightBounding(
            string mincoordinates,
            string maxcoordinates,
            string text = null,
            string format = Constants.Json)
        {
            var url = MapsUriBuilder.GetCopyRightBoundingUrl(mincoordinates, maxcoordinates, text, format);
            return this.GetAsync(url);
        }

        public Task<HttpResponseMessage> GetCopyrightTile(
            int zoom,
            int x,
            int y,
            string text = null,
            string format = Constants.Json)
        {
            var url = MapsUriBuilder.GetCopyrightTileUrl(zoom, x, y, text, format);
            return this.GetAsync(url);
        }

        public Task<HttpResponseMessage> GetCopyrightWorld(string format = Constants.Json)
        {
            var url = MapsUriBuilder.GetCopyrightWorldUrl(format);
            return this.GetAsync(url);
        }

        #endregion

        #region MapTile Controller

        public Task<HttpResponseMessage> GetMapTile(
            string layer,
            string style,
            int zoom,
            int x,
            int y,
            int? tileSize = null,
            string language = null,
            string format = Constants.Pbf)
        {
            var url = MapsUriBuilder.GetMapTileUrl(layer, style, zoom, x, y, tileSize, language, format);
            return this.GetAsync(url);
        }

        public Task<HttpResponseMessage> GetMapTileStatic(
            string layer = null,
            string style = null,
            int? zoom = null,
            string bbox = null,
            string center = null,
            int? height = null,
            int? width = null,
            string language = null,
            string format = Constants.Png)
        {
            var url = MapsUriBuilder.GetMapTileStaticUrl(layer, style, zoom, bbox, center, height, width, language, format);
            return this.GetAsync(url);
        }

        #endregion
    }
}
