﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.GeoLocation
{
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common;
    using Microsoft.VisualStudio.TestTools.UnitTesting;
    using Newtonsoft.Json.Linq;

    [TestClass]
    public class GeoLocationIPIntegrationTests : ApimTestBase
    {
        [Ignore("The test is being ignored for now as the Azure_LBS_All product doesn't contain the API. Once it's added, we can remove the attribute.")]
        [TestMethod, TestCategory("L3")]
        public async Task GetIpLocation_ValidRequest_OK()
        {
            var result = await this.MapsClient.GetIpLocation(ip: "127.0.0.1").ConfigureAwait(false);

            var json = await ParseJson(result).ConfigureAwait(false);
            var ip = json.SelectToken("IPAddress")?.Value<string>();
            Assert.IsNotNull(ip, "invalid response");
            Assert.AreEqual("127.0.0.1", ip);
        }
    }
}
