﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Map
{
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common;
    using Microsoft.VisualStudio.TestTools.UnitTesting;

    [TestClass]
    public class MapTileIntegrationTests : ApimTestBase
    {
        [TestMethod, TestCategory("L3")]
        public async Task GetMapTile_ValidRequest_OK()
        {
            var httpResponse = await this.MapsClient.GetMapTile(layer: "basic", style: "main", zoom: 6, x: 10, y: 22, tileSize: 512).ConfigureAwait(false);
            var content = await httpResponse.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
            Assert.IsNotNull(content, "Http response content cannot be null");
        }

        [TestMethod, TestCategory("L3")]
        public async Task GetMapTileStatic_ValidRequest_OK()
        {
            var httpResponse = await this.MapsClient.GetMapTileStatic(layer: "basic", style: "main", zoom: 2, bbox: "1.355233,42.982261,24.980233,56.526017")
                                         .ConfigureAwait(false);
            var content = await httpResponse.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
            Assert.IsNotNull(content, "Http response content cannot be null");
        }
    }
}
