﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Route
{
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common;
    using Microsoft.VisualStudio.TestTools.UnitTesting;

    [TestClass]
    public class RouteReachableRangeIntegrationTests : ApimTestBase
    {
        [TestMethod, TestCategory("L3")]
        public async Task GetRouteReachableRange_ValidRequest_OK()
        {
            var result = await this.MapsClient.GetRouteReachableRange(query: "50.97452,5.86605", timeBudgetInSec: "6000").ConfigureAwait(false);
            var json = await ParseJson(result).ConfigureAwait(false);
            EnsureTokenExists(json, "reachableRange");
        }
    }
}
