﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Search
{
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common;
    using Microsoft.VisualStudio.TestTools.UnitTesting;
    using Newtonsoft.Json.Linq;

    [TestClass]
    public class SearchFuzzyIntegrationTests : ApimTestBase
    {
        [TestMethod, TestCategory("L3")]
        public async Task GetSearchFuzzy_ValidRequest_OK()
        {
            var result = await this.MapsClient.GetSearchFuzzy(query: "redmond").ConfigureAwait(false);

            var json = await ParseJson(result).ConfigureAwait(false);
            var query = json.SelectToken("summary.query")?.Value<string>();
            Assert.IsNotNull(query, "Cannot find 'summary.query' value in the response");
            Assert.IsTrue(query.Contains("redmond"));
        }
    }
}
