﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Search
{
    using System;
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common;
    using Microsoft.VisualStudio.TestTools.UnitTesting;
    using Newtonsoft.Json.Linq;

    [TestClass]
    public class SearchNearbyIntegrationTests : ApimTestBase
    {
        [TestMethod, TestCategory("L3")]
        public async Task GetSearchNearby_ValidRequest_OK()
        {
            var result = await this.MapsClient.GetSearchNearby(lat: 40.706270, lon: -74.011454, radius: 8046, limit: 10).ConfigureAwait(false);
            var json = await ParseJson(result).ConfigureAwait(false);
            var queryType = json.SelectToken("summary.queryType")?.Value<string>();
            Assert.IsNotNull(queryType, "Cannot find 'summary.queryType' value in the response");
            Assert.IsTrue(queryType.Equals("NEARBY", StringComparison.InvariantCultureIgnoreCase));
        }
    }
}
