﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Search
{
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common;
    using Microsoft.VisualStudio.TestTools.UnitTesting;

    [TestClass]
    public class SearchReverseAddressIntegrationTests : ApimTestBase
    {
        [TestMethod, TestCategory("L3")]
        public async Task GetAddressReverse_ValidRequest_OK()
        {
            var result = await this.MapsClient.GetSearchAddressReverse(query: "37.337,-121.89").ConfigureAwait(false);
            var json = await ParseJson(result).ConfigureAwait(false);
            EnsureTokenExists(json, "summary");
        }

        [TestMethod, TestCategory("L3")]
        public async Task GetAddressCrossStreet_ValidRequest_OK()
        {
            var result = await this.MapsClient.GetSearchAddressReverseCrossStreet(query: "37.337,-121.89").ConfigureAwait(false);
            var json = await ParseJson(result).ConfigureAwait(false);
            EnsureTokenExists(json, "summary");
        }
    }
}
