﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Timezone
{
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common;
    using Microsoft.VisualStudio.TestTools.UnitTesting;
    using Newtonsoft.Json.Linq;

    [TestClass]
    public class TimezoneVersionIntegrationTests : ApimTestBase
    {
        [TestMethod, TestCategory("L3")]
        public async Task GetTimezoneIanaVersion_ValidRequest_OK()
        {
            var result = await this.MapsClient.GetTimezoneIanaVersion().ConfigureAwait(false);
            var json = await ParseJson(result).ConfigureAwait(false);
            var query = json.SelectToken("Version")?.Value<string>();
            Assert.IsTrue(!string.IsNullOrWhiteSpace(query));
        }
    }
}
