﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Traffic
{
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common;
    using Microsoft.VisualStudio.TestTools.UnitTesting;

    [TestClass]
    public class TrafficFlowSegmentIntegrationTests : ApimTestBase
    {
        [TestMethod, TestCategory("L3")]
        public async Task GetTrafficFlowSegment_ValidRequest_OK()
        {
            var result = await this.MapsClient.GetTrafficFlowSegment(style: "absolute", zoom: 10, query: "52.41072,4.84239").ConfigureAwait(false);
            var json = await ParseJson(result).ConfigureAwait(false);
            EnsureTokenExists(json, "flowSegmentData");
        }
    }
}
