﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Traffic
{
    using System.Threading.Tasks;
    using Microsoft.Azure.LocationServices.ProxyServerIntegrationTests.Common;
    using Microsoft.VisualStudio.TestTools.UnitTesting;

    [TestClass]
    public class TrafficFlowTileIntegrationTests : ApimTestBase
    {
        [TestMethod, TestCategory("L3")]
        public async Task GetTrafficFlowTile_ValidRequest_OK()
        {
            var httpResponse = await this.MapsClient.GetTrafficFlowTile(style: "absolute", zoom: 12, x: 2044, y: 1360).ConfigureAwait(false);
            var content = await httpResponse.Content.ReadAsByteArrayAsync().ConfigureAwait(false);
            Assert.IsNotNull(content, "Http response content cannot be null");
        }
    }
}
