﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="RouteMatrixControllerTests.cs" company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// <summary>
//   Summary description for RouteMatrixControllerTests
// </summary>
// --------------------------------------------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Controllers
{
    using System.Collections.Generic;
    using Microsoft.Azure.LocationServices.Shared;
    using Microsoft.VisualStudio.TestTools.UnitTesting;

    /// <summary>
    /// Summary description for RouteMatrixControllerTests
    /// </summary>
    [TestClass]
    public class RouteMatrixControllerTests
    {
        [TestMethod, TestCategory("L0")]
        public void TestResponseParserForResponseCodes()
        {
            var expectedList = new List<int> { 200, 222, 200, 200 };
            var responseString =
                "{\"formatVersion\":\"0.0.1\",\"matrix\":[[{\"statusCode\":200,\"response\":{\"routeSummary\":{\"lengthInMeters\":495,\"travelTimeInSeconds\":153,\"trafficDelayInSeconds\":0,\"departureTime\":\"2018-03-21T15:33:33-07:00\",\"arrivalTime\":\"2018-03-21T15:36:06-07:00\"}}},{\"statusCode\":222,\"response\":{\"routeSummary\":{\"lengthInMeters\":647940,\"travelTimeInSeconds\":36152,\"trafficDelayInSeconds\":3,\"departureTime\":\"2018-03-21T15:33:33-07:00\",\"arrivalTime\":\"2018-03-22T01:36:04-07:00\"}}}],[{\"statusCode\":200,\"response\":{\"routeSummary\":{\"lengthInMeters\":338,\"travelTimeInSeconds\":104,\"trafficDelayInSeconds\":0,\"departureTime\":\"2018-03-21T15:33:33-07:00\",\"arrivalTime\":\"2018-03-21T15:35:17-07:00\"}}},{\"statusCode\":200,\"response\":{\"routeSummary\":{\"lengthInMeters\":647783,\"travelTimeInSeconds\":36103,\"trafficDelayInSeconds\":3,\"departureTime\":\"2018-03-21T15:33:33-07:00\",\"arrivalTime\":\"2018-03-22T01:35:16-07:00\"}}}]],\"summary\":{\"successfulRoutes\":4,\"totalRoutes\":4}}";

            var responseCodes = SharedUtilities.GetResponseCodesFromTomTomRouteMatrixResponseContent(responseString);

            Assert.AreEqual(expectedList.Count, responseCodes.Count);

            for (var i = 0; i < expectedList.Count; i++)
            {
                Assert.AreEqual(expectedList[i], responseCodes[i], $"Item at index {i} doesn't match the expected value.");
            }
        }
    }
}
