﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="RouteMatrixRetryInfo.cs" company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// --------------------------------------------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Shared
{
    using System;

    /// <summary>
    /// Information required to retry the long running Route Matrix calls.
    /// </summary>
    public class RouteMatrixRetryInfo
    {
        public RouteMatrixRetryInfo(Uri baseUri, Uri relativeUri, string accountId, string trackingId)
        {
            this.BaseUri = baseUri;
            this.RelativeURi = relativeUri;
            this.AccountId = accountId;
            this.TrackingId = trackingId;
        }

        public Uri BaseUri { get; }

        public Uri RelativeURi { get; }

        public string AccountId { get; }

        public string TrackingId { get; }
    }
}
