﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
namespace Microsoft.Azure.LocationServices.BillingAPI
{
    using System;
    using System.Diagnostics;
    using System.Threading;

    using Microsoft.Azure.LocationServices.BillingAPI.Utility;
    using Microsoft.ServiceFabric.Services.Runtime;

    internal static class Program
    {
        /// <summary>
        /// This is the entry point of the service host process.
        /// </summary>
        private static void Main()
        {
            BillingHostSettings billingHost = BillingHostSettings.CreateFromEnvironment();            
            Instrumentation.Agent.CreateInstance(billingHost.MdmParameters);
            try
            {
                ServiceRuntime.RegisterServiceAsync("BillingAPIType",
                                                    context => new BillingAPI(context)).GetAwaiter().GetResult();
                Instrumentation.Agent.Instance.LogServiceTypeRegistered(Process.GetCurrentProcess().Id, typeof(BillingAPI).Name);
                Thread.Sleep(Timeout.Infinite);
            }
            catch (Exception e)
            {
                Instrumentation.Agent.Instance.LogException(e, "billing", "initialization");
                throw;
            }
        }
    }
}
