﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace BillingUnitTest
{
    using System;
    using Microsoft.Azure.LocationServices.BillingAPI;
    using Microsoft.VisualStudio.TestTools.UnitTesting;

    [TestClass]
    public class BillingHelperTest
    {
        [TestMethod]
        public void TransactionCacheTableTest()
        {
            BillingHelper.TryParsePartition("201701110000", out DateTime partition1);
            BillingHelper.TryParsePartition("201702110000", out DateTime partition2);
            var c1 = BillingHelper.GetCurrentTransactionCacheTable(partition1);
            var c2 = BillingHelper.GetCurrentTransactionCacheTable(partition2);
            Assert.AreNotEqual(c1, c2);
            Assert.AreEqual(BillingHelper.TRANSACTION_CACHE_TABLE_BASE + "1", c1);
            Assert.AreEqual(BillingHelper.TRANSACTION_CACHE_TABLE_BASE + "0", c2);
            var cp1 = BillingHelper.GetPreviousTransactionCacheTable(partition1);
            var cp2 = BillingHelper.GetPreviousTransactionCacheTable(partition2);
            Assert.AreNotEqual(c1, c2);
            Assert.AreEqual(BillingHelper.TRANSACTION_CACHE_TABLE_BASE + "1", cp2);
            Assert.AreEqual(BillingHelper.TRANSACTION_CACHE_TABLE_BASE + "0", cp1);
        }
    }
}
