﻿# ---------------------------------------------------------------------------------------------------------------------------------------------
# remove SSL certificates
# ---------------------------------------------------------------------------------------------------------------------------------------------

$modulePath = $PSScriptRoot + "\..\..\Utils\lbsSetupSupport.psd1"
Import-Module -Name $modulePath -Force

$ErrorActionPreference = "Stop"

$environments = Get-lbsEnvironments
$sfClusters = Get-lbsServiceFabricClusters
$certType = 'auth'

foreach ($env in $environments)
{
    $subscriptionId = Get-lbsEnvironmentSubscriptionId -env $env;
    $subscription = Select-lbsSubscriptionWithQuickLogin -subscriptionId $subscriptionId

    foreach ($sfCluster in $sfClusters) 
    {
		$regions = Get-lbsEnvironmentRegions -env $env -sfCluster $sfCluster
        foreach ($region in $regions) 
        {
            $vaultName = Get-lbsVaultName -env $env -sfCluster $sfCluster -region $region
            $certName = Get-lbsCertificateName -env $env -sfCluster $sfCluster -region $region -certType $certType
            Write-Host "Removing" $certName "from" $vaultName 
            Remove-AzureKeyVaultCertificate -VaultName $vaultName -Name $certName -Force 
        }
    }
}

# $vaultName = "s-rp-eastus"
# Remove-AzureKeyVaultCertificate -VaultName $vaultName -Name srp-cluster-eastus
# Remove-AzureKeyVaultCertificate -VaultName $vaultName -Name srp-client-eastus
# Remove-AzureKeyVaultCertificate -VaultName $vaultName -Name srp-secrets-eastus
# Remove-AzureKeyVaultCertificate -VaultName $vaultName -Name srp-ma-eastus
# Remove-AzureKeyVaultCertificate -VaultName $vaultName -Name srp-auth-eastus
