﻿# ##########################################################################################################################################################
# Calls CopySFSettings.ps1 to generate the EV2 parameters for SF applications. Invoked by the build agent.
# ##########################################################################################################################################################

$deployAndSetup = Split-Path (Split-Path $PSScriptRoot -Parent) -Parent
$src = Split-Path $deployAndSetup -Parent
$script  = $deployAndSetup + "\Utils\CopySFSettings.ps1"

# Proxy
& $script `
-srcSFApplicationManifestFile "$src\ALSProxy\SF\pkg\$Env:BuildConfiguration\ApplicationManifest.xml" `
-srcSFtoDestEv2 @{
	"$src\ALSProxy\SF\ApplicationParameters\p-svc-eastus-cloud.xml" = "$src\DeployAndSetup\Provision\PROD_BN\Parameters\SFAPI.svc.eastus.Parameters.json";
	"$src\ALSProxy\SF\ApplicationParameters\p-svc-westeurope-cloud.xml" = "$src\DeployAndSetup\Provision\PROD_BN\Parameters\SFAPI.svc.westeurope.Parameters.json";
	"$src\ALSProxy\SF\ApplicationParameters\p-svc-westus2-cloud.xml" = "$src\DeployAndSetup\Provision\PROD_BN\Parameters\SFAPI.svc.westus2.Parameters.json";
}

# RP
& $script `
-srcSFApplicationManifestFile "$src\ResourceProvider\AzureLocationServicesResourceProvider\pkg\$Env:BuildConfiguration\ApplicationManifest.xml" `
-srcSFtoDestEv2 @{
	"$src\ResourceProvider\AzureLocationServicesResourceProvider\ApplicationParameters\p-rp-eastus-cloud.xml" = "$src\DeployAndSetup\Provision\PROD_BN\Parameters\AzureLocationServicesResourceProvider.rp.eastus.Parameters.json"
	"$src\ResourceProvider\AzureLocationServicesResourceProvider\ApplicationParameters\p-rp-westeurope-cloud.xml" = "$src\DeployAndSetup\Provision\PROD_BN\Parameters\AzureLocationServicesResourceProvider.rp.westeurope.Parameters.json"
	"$src\ResourceProvider\AzureLocationServicesResourceProvider\ApplicationParameters\p-rp-westus2-cloud.xml" = "$src\DeployAndSetup\Provision\PROD_BN\Parameters\AzureLocationServicesResourceProvider.rp.westus2.Parameters.json"
}

# Billing
& $script `
-srcSFApplicationManifestFile "$src\Billing\AzureLBSBilling\pkg\$Env:BuildConfiguration\ApplicationManifest.xml" `
-srcSFtoDestEv2 @{
	"$src\Billing\AzureLBSBilling\ApplicationParameters\p-rp-eastus-cloud.xml" = "$src\DeployAndSetup\Provision\PROD_BN\Parameters\AzureLBSBilling.rp.eastus.Parameters.json"
	"$src\Billing\AzureLBSBilling\ApplicationParameters\p-rp-westeurope-cloud.xml" = "$src\DeployAndSetup\Provision\PROD_BN\Parameters\AzureLBSBilling.rp.westeurope.Parameters.json"
	"$src\Billing\AzureLBSBilling\ApplicationParameters\p-rp-westus2-cloud.xml" = "$src\DeployAndSetup\Provision\PROD_BN\Parameters\AzureLBSBilling.rp.westus2.Parameters.json"
}

# Jobs
& $script `
-srcSFApplicationManifestFile "$src\LBSJobs\LBSJobsApp\pkg\$Env:BuildConfiguration\ApplicationManifest.xml" `
-srcSFtoDestEv2 @{
	"$src\LBSJobs\LBSJobsApp\ApplicationParameters\p-jobs-eastus-cloud.xml" = "$src\DeployAndSetup\Provision\PROD_BN\Parameters\LBSJobsApp.jobs.eastus.Parameters.json"
}