<#
 .SYNOPSIS
    Allows for setting of windows update on the machine which it runs.

 .PARAMETER notificationLevel 
    0="Not configured" 1="Disabled" 2="Notify before download" 3="Notify before installation" 4="Scheduled installation"

#>

param(
	[Parameter(Mandatory=$True)]
	[ValidateRange(0 , 4)]
	[int]
	$notificationLevel 
)

 $AUSettings = (New-Object -com "Microsoft.Update.AutoUpdate").Settings
 $AUSettings.NotificationLevel = $notificationLevel
 $AUSettings.Save()