﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Instrumentation.Apim
{
    using System.Net;

    public static class APIMLoggerHelper
    {
        /// <summary>
        /// Gets operation result from response status code.
        /// </summary>
        public static string GetResultFromStatusCode(ResponseInfo responseInfo)
        {
            if (!string.IsNullOrEmpty(responseInfo.LastError))
            {
                return "APIMError";
            }

            var statusCode = (HttpStatusCode)responseInfo.Response.statusCode;

            if (statusCode >= HttpStatusCode.OK && statusCode < HttpStatusCode.BadRequest)
            {
                return "Success";
            }
            else if (statusCode >= HttpStatusCode.BadRequest && statusCode < HttpStatusCode.InternalServerError)
            {
                return "ClientError";
            }
            else
            {
                return "Failure";
            }
        }
    }
}
