﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 
namespace Microsoft.Azure.LocationServices.Instrumentation
{
    /// <summary> * * * NOTE * * *
    /// to avoid maintaining the list of types NOT handled by LogEvent(EventType eventType, string message)
    /// a check is made for anything LT EventType.Exception
    /// Insert new enums accordingly.
    /// </summary>
    public enum EventType
    {
        /// <summary>A trace</summary>
        Verbose = 0,

        /// <summary>Information</summary>
        Information,

        /// <summary>A warning</summary>
        Warning,

        /// <summary>A user error</summary>
        UserError,

        /// <summary>An unexpected condition - but not an exception</summary>
        ProgramError,

        /// <summary>private use only: must be the last defined element</summary>
        _max
    }
}