﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 
namespace Microsoft.Azure.LocationServices.Instrumentation
{
    using System;

    public interface IOperationAgent : IDisposable
    {
        /// <summary>
        /// Although supported by Operation, consider using SetResultFailure instead.
        /// This call appears to just write the type and message in the resultSignature and resultDescription fields.
        /// Instead, SetResultFailure can write some or all of the callstack
        /// </summary>
        /// <param name="ex"></param>
        void SetException(Exception ex);

        void SetResultSuccess();

        void SetResultClientError(string resultSignature, string resultDetails);

        void SetResultFailure(string resultSignature, string resultDetails);
    }
}