﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Instrumentation
{
    using System;
    using System.Collections.Generic;

    public class Deployment
    {
        public string Region { get; set; }

        public string ServiceName { get; set; }
    }

    public class Operation
    {
        public string Id { get; set; }

        public string Method { get; set; }

        public string Name { get; set; }

        public string UrlTemplate { get; set; }
    }

    public class Product
    {
        public string Id { get; set; }

        public string Name { get; set; }
    }

    public class Request
    {
        public string Content { get; set; }

        public string Method { get; set; }

        public string OriginalUrl { get; set; }

        public string Url { get; set; }
    }

    public class Subscription
    {
        public string Id { get; set; }

        public string Name { get; set; }
    }

    public class Group
    {
        public string Id { get; set; }

        public string Name { get; set; }
    }

    public class Identity
    {
        public string Provider { get; set; }

        public string Id { get; set; }
    }

    public class User
    {
        public string AccountResourceFirstName { get; set; }

        public string AccountResourceLastName { get; set; }
    }

    public class RequestInfo
    {
        public string Type { get; set; }

        public string TrackingId { get; set; }

        public string Api { get; set; }

        public Deployment Deployment { get; set; }

        public Operation Operation { get; set; }

        public Product Product { get; set; }

        public Request Request { get; set; }

        public Subscription Subscription { get; set; }

        public User User { get; set; }

        public DateTime StartTime { get; set; }
    }
}