﻿Param
(
    [Parameter(Mandatory = $true)]
    [string]
    [ValidateSet('p', 's', 't', 'c')]
    $env,

    [string]
    [ValidateSet('rp', 'svc', 'jobs')]
    $selectedSfCluster
)

$modulePath = $PSScriptRoot + "\..\..\..\..\..\..\DeployAndSetup\Utils\lbsSetupSupport.psd1"
Import-Module -Name $modulePath -Force

#Write-Host "Re-Installing Monitoring Agent to all " $env " clusters\regions"
#Debug-lbsPromptToContinue;

$sfClusters = Get-lbsServiceFabricClusters

if ($selectedSfCluster) {
    $sfClusters = $sfClusters | where { $_ -match $selectedSfCluster}
}

foreach ($sfCluster in $sfClusters) {
    $regions = Get-lbsEnvironmentRegions -env $env -sfCluster $sfCluster

    foreach ($region in $regions) {
        $profileFile = $env + "-" + $sfCluster + "-" + $region + ".xml"
        $scriptPath = (Split-Path $MyInvocation.MyCommand.Path) + "\MonitorInstaller.ps1" 
		
        Write-Host "-----------------------------------------------------------------------"
        Write-Host "=> Installing: " $profileFile " ..."
        try {
            $args = "-m i -p " + $profileFile
            Invoke-Expression "& `"$scriptPath`" $args"
        }
        catch {
            Write-Error $_.Exception.ToString()
            Exit
        }
    }
}