﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 
namespace Microsoft.Azure.LocationServices
{
    using System;
    using System.Threading.Tasks;

    /// <summary>
    /// Defines an interface for a CSV format reader.
    /// </summary>
    public interface ICsvFormatReader : IDisposable
    {
        /// <summary>
        /// Returns the next set of fields.
        /// </summary>
        Task<string[]> ReadNextAsync();

        /// <summary>
        /// Returns the next set of fields.
        /// </summary>
        string[] ReadNext();
    }
}