﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices
{
    using System;

    public interface IGeoLocationLogger
    {
        void SetNumberOfRecordsParsed(int number, string source);

        void OnFailedToAddNetworkAssigment(Exception ex, string recordStartAddress, string recordRegistry);

        void OnFailedToParseRirDataSource(string sourceName, Exception exception);

        void OnNetworkAssignmentRebuildCompleted(bool replaced, long stopwatchElapsedMilliseconds, string fingerprint);

        void OnNetworkAssignmentsContentUpdated(Uri blobClientUri, long bufferLength, string leaseToken, string fingerprint);

        void OnNetworkAssignmentBlobUpdateError(Exception exception, Uri blobClientUri, string fingerprint);

        void OnNetworkAssignmentRefreshError(Exception exception);

        void OnNetworkAssignmentsReloaded(string latestFingerprint);
    }
}