﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 
namespace Microsoft.Azure.LocationServices.Iana
{
    /// <summary>
    /// Status of record.
    /// </summary>
    public enum RirRecordStatus
    {
        /// <summary>
        /// Record status is not recognized.
        /// </summary>
        Unknown,

        /// <summary>
        /// The resource has not been allocated or assigned to any entity.
        /// </summary>
        Available,

        /// <summary>
        /// An allocation made by the registry producing the file.
        /// </summary>
        Allocated,

        /// <summary>
        /// An assignment made by the registry producing the file.
        /// </summary>
        Assigned,

        /// <summary>
        /// The resource has not been allocated or assigned to any entity, and is not available for allocation or assignment for some reason.
        /// </summary>
        Reserved
    }
}