﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 
namespace Microsoft.Azure.LocationServices.Iana
{
    /// <summary>
    /// Type of Internet number resource represented in this record.
    /// </summary>
    public enum RirRecordType
    {
        /// <summary>
        /// Record type is unknown.
        /// </summary>
        Unknown,

        /// <summary>
        /// Record contains IPv4 address range.
        /// </summary>
        Ipv4,

        /// <summary>
        /// Record contains IPv6 address range.
        /// </summary>
        Ipv6,

        /// <summary>
        /// Record contain Asn number assignment.
        /// </summary>
        Asn
    }
}