﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 
namespace Microsoft.Azure.LocationServices
{
    using System;

    /// <summary>
    /// Contains mapping of the IP network to the country code.
    /// </summary>
    public class NetworkAssignment
    {
        public NetworkAssignment(IPNetwork network, string isoCountryCode, DateTimeOffset changeDate, string registry)
        {
            this.Network = network;
            this.IsoCountryCode = isoCountryCode;
            this.ChangeDate = changeDate;
            this.Registry = registry;
        }

        public IPNetwork Network { get; set; }

        public string IsoCountryCode { get; set; }

        public DateTimeOffset ChangeDate { get; set; }

        public string Registry { get; set; }

        public override string ToString()
        {
            return $"{this.IsoCountryCode} {this.Network}";
        }
    }
}