﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.GeoLocation.Storage
{
    using System;
    using System.IO;
    using System.Threading;
    using System.Threading.Tasks;

    public interface IContentSource
    {
        string Name { get; }

        Task<Stream> GetSourceAsync(CancellationToken cancellationToken);

        Task<DateTimeOffset> GetLastModifiedDateTime(CancellationToken cancellationToken);
    }
}