﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.GeoLocation
{
    using System;
    using System.IO;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Defines operations for the target container.
    /// </summary>
    public interface IContentTarget
    {
        /// <summary>
        /// Sets the content for the target container.
        /// </summary>
        Task SetTargetAsync(Stream contents, CancellationToken cancellationToken);

        /// <summary>
        /// Gets the timestamp of last update.
        /// </summary>
        Task<DateTimeOffset> GetLastModifiedDateTime(CancellationToken cancellationToken);

        /// <summary>
        /// Checks if the target container exists.
        /// </summary>
        Task<bool> ExistsAsync(CancellationToken cancellationToken);
    }
}