﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 
namespace Microsoft.Azure.LocationServices.GeoLocation.Storage
{
    using System;
    using System.Runtime.Serialization;

    /// <summary>
    /// Defines structure for the network assignment record in LBS storage
    /// </summary>
    [DataContract]
    public class NetworkAssignmentRecord
    {
        [DataMember]
        public byte[] StartAddress { get; set; }

        [DataMember]
        public byte CidrMaskLength { get; set; }

        [DataMember]
        public ulong NodeNumber { get; set; }

        [DataMember]
        public string CountryCode { get; set; }

        [DataMember]
        public string RegistryName { get; set; }

        [DataMember]
        public DateTimeOffset ChangeDate { get; set; }
    }
}