﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.GeoLocation.Tests.TestDataBuilders
{
    using System;
    using System.Net;

    using Microsoft.Azure.LocationServices.Common.UnitTests;

    /// <summary>
    /// Creates an instance of NetworkAssignment filled with random data
    /// </summary>
    public class NetworkAssignmentDataBuilder : TestDataBuilder<NetworkAssignment>
    {
        private IPNetwork defaultNetwork = new IPNetwork(IPAddress.Loopback, 32);

        public NetworkAssignmentDataBuilder WithNetwork(IPNetwork network)
        {
            this.defaultNetwork = network;
            return this;
        }

        protected override NetworkAssignment CreateNewObject()
        {
            return new NetworkAssignment(this.defaultNetwork, TestHelpers.GetRandomString(2), DateTimeOffset.UtcNow, TestHelpers.GetRandomString(4));
        }
    }
}