﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.APIMLogToGeneva
{
    using System;
    using System.Diagnostics;
    using System.Threading;

    using Microsoft.Azure.LocationServices.APIMLogToGeneva.Configuration;
    using Microsoft.Azure.LocationServices.Instrumentation;
    using Microsoft.ServiceFabric.Services.Runtime;

    internal static class Program
    {
        /// <summary>
        /// This is the entry point of the service host process.
        /// </summary>
        private static void Main()
        {
            ApimLogHostSettings apimLogHost = ApimLogHostSettings.CreateFromEnvironment();
            Agent.CreateInstance(apimLogHost.MdmParameters);

            try
            {
                ServiceRuntime.RegisterServiceAsync("APIMLogToGenevaType",
                                                    context => new APIMLogToGeneva(context)).GetAwaiter().GetResult();
                FabricRuntimeHelper.ServiceFabricInstrumentInstance.LogServiceTypeRegistered(Process.GetCurrentProcess().Id, typeof(APIMLogToGeneva).Name);
                Thread.Sleep(Timeout.Infinite);
            }
            catch (Exception e)
            {
                FabricRuntimeHelper.ServiceFabricInstrumentInstance.LogException(e, "apimLogToGeneva", "initialization");
                throw;
            }
        }
    }
}
