﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.IPDataImport
{
    using System.Fabric;
    using Microsoft.Azure.LocationServices.IPDataImport.Configuration;
    using Microsoft.Azure.LocationServices.ServiceFabricHosting;

    internal class Program : StatelessServiceRuntimeBase<IPDataImport>
    {
        /// <summary>
        /// This is the entry point of the service host process.
        /// </summary>
        public static void Main()
        {
            var config = IPDataImportHostSettings.CreateFromEnvironment();

            var p = new Program();
            p.InitializeMonitoringAgent(config.MdmSessionName, config.MdmAccountName, config.EnableLocalMdmOutput);
            p.Run("IPDataImportType");
        }

        protected override IPDataImport CreateStatelessSerivceInstance(StatelessServiceContext context)
        {
            return new IPDataImport(context);
        }
    }
}