﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.LBSBatchService
{
    using System;

    public interface IBatchServiceLogger
    {
        /// <summary>
        /// Logs information on a debug level.
        /// </summary>
        /// <param name="message">The message associated with the logging.</param>
        void LogVerbose(string message);

        /// <summary>
        /// Logs information on an info level.
        /// </summary>
        /// <param name="message">The message associated with the logging.</param>
        void LogInfo(string message);

        /// <summary>
        /// Logs information on a warn level.
        /// </summary>
        /// <param name="message">The message associated with the logging.</param>
        void LogWarning(string message);

        /// <summary>
        /// Logs information on an error level.
        /// </summary>
        /// <param name="exception">The exception to log information about.</param>
        /// <param name="message">The message associated with the logging.</param>
        void LogError(Exception exception, string message);

        /// <summary>
        /// Logs aggregate error.
        /// </summary>
        /// <param name="aggregateException">The exception to log information about.</param>
        void LogAggregateError(AggregateException aggregateException);
    }
}
