﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="MessageHandlerConfig.cs" company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// <summary>
//   Defines the MessageHandlerConfig type.
// </summary>
// --------------------------------------------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.LBSBatchService
{
    public class MessageHandlerConfig
    {
        public MessageHandlerConfig(int maxAttempts, int maxPartitions, int httpClientTimeoutInMinutes)
        {
            this.MaxAttempts = maxAttempts;
            this.MaxPartitions = maxPartitions;
            this.HttpClientTimeoutInMinutes = httpClientTimeoutInMinutes;
        }

        public int MaxAttempts { get; private set; }

        public int MaxPartitions { get; private set; }

        public int HttpClientTimeoutInMinutes { get; private set; }
    }
}
