﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="PollingQueueConfig.cs" company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// <summary>
//   Defines the PollingQueueConfig type.
// </summary>
// --------------------------------------------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.LBSBatchService
{
    public class PollingQueueConfig
    {
        public PollingQueueConfig(int maxQueueMessagesToProcessInParallel, int queueMessageVisibilityTimeoutInMinutes, int queueWorkerDefaultSleepTimeInSeconds, int queueWorkerMaxSleepTimeInSeconds)
        {
            this.MaxQueueMessagesToProcessInParallel = maxQueueMessagesToProcessInParallel;
            this.QueueMessageVisibilityTimeoutInMinutes = queueMessageVisibilityTimeoutInMinutes;
            this.QueueWorkerDefaultSleepTimeInSeconds = queueWorkerDefaultSleepTimeInSeconds;
            this.QueueWorkerMaxSleepTimeInSeconds = queueWorkerMaxSleepTimeInSeconds;
        }

        // Max number of queue messages to fetch and process in parallel
        public int MaxQueueMessagesToProcessInParallel { get; private set; }

        // Time in minutes for which a queue message will be invisible once it's fetched
        public int QueueMessageVisibilityTimeoutInMinutes { get; private set; }

        // Default time in seconds that the queue worker waits for (after receiving no messages) before querying the queue again
        public int QueueWorkerDefaultSleepTimeInSeconds { get; private set; }

        // Max time in seconds that the queue worker waits for (after receiving no messages) before querying the queue again
        public int QueueWorkerMaxSleepTimeInSeconds { get; private set; }
    }
}
