﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.LBSBatchService
{
    using System.Fabric;
    using Microsoft.Azure.LocationServices.ServiceFabricHosting;

    internal class Program : StatelessServiceRuntimeBase<LBSBatchService>
    {
        /// <summary>
        /// This is the entry point of the service host process.
        /// </summary>
        public static void Main()
        {
            LbsBatchServiceHostSettings config = LbsBatchServiceHostSettings.CreateFromEnvironment();
            
            Program program = new Program();
            program.InitializeMonitoringAgent(config.MdmSessionName, config.MdmAccountName, config.EnableLocalMdmOutput);
            program.Run("LBSBatchServiceType");
        }

        protected override LBSBatchService CreateStatelessSerivceInstance(StatelessServiceContext context)
        {
            return new LBSBatchService(context);
        }
    }
}
