﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="OSMMirrorOnAzure.cs" company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// <summary>
//   An instance of this class is created for each service instance by the Service Fabric runtime.
// </summary>
// --------------------------------------------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.OSMMirrorOnAzure.Configuration
{
    using Microsoft.Azure.LocationServices.Instrumentation;

    /// <summary>
    /// The development environment definition.
    /// </summary>
    public class OSMMirrorHostDevSettings : OSMMirrorHostSettings
    {
        /// <inheritdoc />
        public override InitParams MdmParameters
        {
            get
            {
                InitParams p = new InitParams("DevTestIfx", "AzLocTest");
                p.SetLocalTracing(@"c:\ifxTrace");
                p.SetEtwProvider("DevTest", "DB25DB83-F4C7-4D76-9DBA-5D08A7DEC472");
                return p;
            }
        }
    }
}
