﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="ControllerFileInfo.cs" company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// <summary>
//   Defines the ControllerFileInfo type.
// </summary>
// --------------------------------------------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.OSMMirrorOnAzure
{
    using System;

    public class ControllerFileInfo
    {
        public ControllerFileInfo(DateTimeOffset modifieDateTimeOffset, long sizeInBytes, int blockSize)
        {
            this.LastModifDateTimeOffset = modifieDateTimeOffset;
            this.LengthInBytes = sizeInBytes;
            this.PreviousBlockSize = blockSize;
        }

        public DateTimeOffset LastModifDateTimeOffset { get; private set; }

        public long LengthInBytes { get; private set; }

        public int PreviousBlockSize { get; private set; }
    }
}
