﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.OSMMirrorOnAzure
{
    using System;
    using Microsoft.WindowsAzure.Storage.Blob;
    
    public class OsmNewBlobFileInfo
    {
        public OsmNewBlobFileInfo(bool success, string newBlobFileName, DateTimeOffset modifiedDateTime, long fileSizeInBytes, CloudBlobDirectory newFileDirectory)
        {
            this.MoveSuccessful = success;
            this.NewBlobFileName = newBlobFileName;
            this.ModifiedDateTime = modifiedDateTime;
            this.FileSizeInBytes = fileSizeInBytes;
            this.NewBlobDirectory = newFileDirectory;
        }

        public bool MoveSuccessful { get; private set; }

        public DateTimeOffset ModifiedDateTime { get; private set; }

        public long FileSizeInBytes { get; private set; }

        public CloudBlobDirectory NewBlobDirectory { get; private set; }

        public string NewBlobFileName { get; private set; }
    }
}
