﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.OsmMirrorUnitTests
{
    using System;

    using Microsoft.Azure.LocationServices.OSMMirrorOnAzure;
    using Microsoft.VisualStudio.TestTools.UnitTesting;

    [TestClass]
    public class OSMDownloadUploadManagerTests
    {
        [TestMethod]
        public void GetDestinationBlobName_GetTheRightName()
        {
            var dateTime = DateTime.Parse("2/21/2018 14:27");
            var expectedValue = "pbf/archives/2018/planet-02_21_2018_14_27.osm.pbf";
            var returnValue = OSMDownloadUploadManager.GetDestinationBlobName("pbf/planet-latest.osm.pbf", dateTime);
            Assert.AreEqual(expectedValue, returnValue);
        }
    }
}
