﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Portal.Extensions.LocSvcExtension.DataModels
{
    using System.Collections.Generic;
    using Microsoft.Portal.TypeMetadata;

    [TypeMetadataModel(typeof(ResourceBase), "LocSvcExtension.DataModels", true)]
    public abstract class ResourceBase
    {
        /// <summary>
        /// Gets or sets the unique identifier of the resource .
        /// </summary>
        [Id]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the resource name.
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Type of resource provider
        /// </summary>
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets location
        /// </summary>
        public string Location { get; set; }

        /// <summary>
        /// Etag
        /// </summary>
        public string Etag { get; set; }

        /// <summary>
        /// Gets or sets classicStorage account tags (key-value pairs)
        /// </summary>
        [Ignore]
        public IDictionary<string, string> Tags { get; set; }
    }
}
