declare module "ClientResources" {
    export = ClientResources;
    const ClientResources: {
        readonly resourceBladeSubtitle: string;
        readonly propertiesBladeTitle: string;
        readonly subscriptionId: string;
        readonly loadingText: string;
        readonly resourceNameColumn: string;
        readonly resourceLocationColumn: string;
        readonly extensionName: string;
        readonly subscription: string;
        readonly status: string;
        readonly settings: string;
        readonly resourceName: string;
        readonly AssetPropertyNames: {
            readonly Resource: {
                readonly resourceGroup: string;
            };
            readonly CloudService: {
                readonly location: string;
            };
        };
        readonly selectResourceGroup: string;
        readonly selectSubscription: string;
        readonly enterTheName: string;
        readonly selectLocation: string;
        readonly CreateBlade: {
            readonly Error: {
                readonly resourceNameRequired: string;
                readonly resourceNameUnavailable: string;
                readonly resourceNameAndResourceGroupNameTooLong: string;
                readonly resourceNameInvalidCharacters: string;
            };
            readonly title: string;
            readonly PricingTier: {
                readonly validation: string;
                readonly Groups: {
                    readonly all: string;
                };
                readonly labelFormat: string;
                readonly linkText: string;
            };
            readonly Legal: {
                readonly acceptTerms: string;
                readonly Checkbox: {
                    readonly Label: {
                        readonly format: string;
                        readonly license: string;
                        readonly privacy: string;
                    };
                };
            };
            readonly Validation: {
                readonly specMessage: string;
            };
        };
        readonly monitoringLensTitle: string;
        readonly MyResourceBladePartBlade: {
            readonly title: string;
            readonly subtitle: string;
        };
        readonly MyResourceBladeOverviewBladeBlade: {
            readonly title: string;
            readonly subtitle: string;
        };
        readonly MyResourceBladeAsset: {
            readonly singularDisplayName: string;
            readonly pluralDisplayName: string;
            readonly lowerSingularDisplayName: string;
            readonly lowerPluralDisplayName: string;
            readonly description: string;
            readonly link: string;
            readonly keywords: string;
        };
        readonly KeysBladeBlade: {
            readonly title: string;
            readonly subtitle: string;
        };
        readonly AboutBlade: {
            readonly title: string;
            readonly text: string;
        };
        readonly GettingStartedBlade: {
            readonly GettingStarted: {
                readonly title: string;
                readonly description: string;
            };
            readonly title: string;
            readonly AdditionalResources: {
                readonly description: string;
                readonly RegionAvailability: {
                    readonly title: string;
                };
                readonly SupportOptions: {
                    readonly title: string;
                };
                readonly title: string;
            };
            readonly Documentation: {
                readonly description: string;
                readonly UseAzureMaps: {
                    readonly title: string;
                };
                readonly title: string;
            };
        };
        readonly KeysBlade: {
            readonly primaryKeyLabel: string;
            readonly regenerateKeyConfirmation: string;
            readonly regeneratePrimaryKeyCommandLabel: string;
            readonly regeneratePrimaryKeyDialogTitle: string;
            readonly regenerateSecondaryKeyCommandLabel: string;
            readonly regenerateSecondaryKeyDialogTitle: string;
            readonly regeneratingAction: string;
            readonly secondaryKeyLabel: string;
            readonly description: string;
            readonly Grid: {
                readonly Columns: {
                    readonly Key: {
                        readonly label: string;
                    };
                    readonly Name: {
                        readonly label: string;
                    };
                };
            };
        };
        readonly OverviewBlade: {
            readonly deleteCommandLabel: string;
        };
        readonly ResourceBlade: {
            readonly aboutCommandLabel: string;
            readonly aboutSearchKeywords: string;
            readonly gettingStartedCommandLabel: string;
            readonly gettingStartedSearchKeywords: string;
            readonly helpGroupLabel: string;
            readonly keysCommandLabel: string;
            readonly keysSearchKeywords: string;
            readonly overviewSearchKeywords: string;
            readonly settingsGroupLabel: string;
            readonly Keywords: {
                readonly metrics: string;
                readonly preview: string;
            };
            readonly MetricsV2: {
                readonly displayText: string;
            };
        };
        readonly Account: {
            readonly pricingTier: string;
        };
        readonly Pricing: {
            readonly costTemplate: string;
            readonly PromotedFeature: {
                readonly Maps: {
                    readonly free: string;
                };
                readonly Other: {
                    readonly free: string;
                };
            };
            readonly Sku: {
                readonly Tier: {
                    readonly standard: string;
                };
            };
        };
        readonly PricingBlade: {
            readonly subtitle: string;
            readonly title: string;
            readonly description: string;
        };
        readonly Overview: {
            readonly Delete: {
                readonly Notification: {
                    readonly Error: {
                        readonly description: string;
                        readonly title: string;
                    };
                    readonly InProgress: {
                        readonly description: string;
                        readonly title: string;
                    };
                    readonly Success: {
                        readonly description: string;
                        readonly title: string;
                    };
                };
            };
        };
        readonly Keys: {
            readonly Regenerate: {
                readonly Notification: {
                    readonly Error: {
                        readonly description: string;
                        readonly title: string;
                    };
                    readonly InProgress: {
                        readonly description: string;
                        readonly title: string;
                    };
                    readonly Success: {
                        readonly description: string;
                        readonly title: string;
                    };
                };
            };
        };
        readonly MyResourceBladePart: {
            readonly GalleryMetadata: {
                readonly category: string;
                readonly title: string;
            };
        };
        readonly resourceGroupLocation: string;
        readonly MyResourceBladeOverviewBlade: {
            readonly Charts: {
                readonly oneHour: string;
                readonly sevenDays: string;
                readonly thirtyDays: string;
                readonly twelveHours: string;
                readonly oneDay: string;
                readonly OptionsGroup: {
                    readonly label: string;
                };
                readonly sixHours: string;
            };
        };
    };
}