﻿import * as TemplateBlade from "Fx/Composition/TemplateBlade";
import * as Section from "Fx/Controls/Section";
import { DataContext } from "./MyResourceArea";
import * as ClientResources from "ClientResources";

export interface AboutParameters {
    id: string;
}

@TemplateBlade.Decorator({
    htmlTemplate: 
`
    <div data-bind="html: aboutHtml" style="margin:20px"></div>
`
})
export class AboutBlade {
    public title = ClientResources.AboutBlade.title;
    public subtitle = ClientResources.MyResourceBladeAsset.singularDisplayName;
    public context: TemplateBlade.Context<AboutParameters, DataContext>;

    public aboutHtml = ko.observable();

    public onInitialize() {

        this.aboutHtml = ko.observable(ClientResources.AboutBlade.text);

        return Q();
    }
}
