﻿import { DataContext } from "./MyResourceArea";
import * as ClientResources from "ClientResources";
import ExtensionDefinition = require("../_generated/ExtensionDefinition");
import Def = ExtensionDefinition.ViewModels.MyResource.AccountDeletionConfirmationPart;

export class AccountDeletionConfirmationPart 
extends MsPortalFx.ViewModels.DeleteAssetConfirmation.PartViewModel<any, any> 
implements Def.Contract {
	constructor(container: MsPortalFx.ViewModels.PartContainerContract, initialState: any, dataContext: DataContext) {
		super(container, {
			assetTypeDisplayName: ClientResources.MyResourceBladeAsset.lowerSingularDisplayName
		});
	}

	public onInputsSet(inputs: Def.InputsContract): MsPortalFx.Base.Promise {
		const resourceDescriptor = MsPortalFx.ViewModels.Services.ResourceTypes.parseResourceDescriptor(inputs.data);
		return super.onInputsSet({
			 data: {
				  assetName: resourceDescriptor.resource
			 }
		});
	}

	public _onPopulateGrid(data: MsPortalFx.ViewModels.DeleteAssetConfirmation.InputData): void {
	}
}
 