﻿import { DataContext } from "./MyResourceArea";
import * as ClientResources from "ClientResources";
import * as ExtensionDefinition from "../_generated/ExtensionDefinition";
import Def = ExtensionDefinition.ViewModels.MyResource.QuickStartInfoListViewModel;
import Link = MsPortalFx.ViewModels.Parts.InfoList.Link;

export class QuickStartBladeViewModel extends MsPortalFx.ViewModels.Blade {
    constructor(contianer: MsPortalFx.ViewModels.ContainerContract, initialState: any, dataContext: DataContext) {
        super();
        this.title(ClientResources.GettingStartedBlade.title);
        this.subtitle(ClientResources.MyResourceBladeAsset.singularDisplayName);
    }
}

export class QuickStartInfoListViewModel extends MsPortalFx.ViewModels.Parts.InfoList.ViewModel {
    constructor(container: MsPortalFx.ViewModels.PartContainerContract, initialState: any, dataContext: DataContext) {
        super(initialState);

        // Sections are blocks of text.
        // They can have an icon or number (if no icon is provided).
        // They can be a link or bladeLink via the selection property
        //         or: If they are neither, then the links property can show many links & bladeLinks.

        const gettingStartedResources = ClientResources.GettingStartedBlade;

        this.addSection(
            gettingStartedResources.GettingStarted.title,
            gettingStartedResources.GettingStarted.description,
            [],
            MsPortalFx.Base.Images.AzureQuickstart());

        const documentationResources = gettingStartedResources.Documentation;
        this.addSection(
            documentationResources.title,
            documentationResources.description,
            [
                new Link(documentationResources.UseAzureMaps.title, "https://go.microsoft.com/fwlink/?linkid=862272"),
            ],
            MsPortalFx.Base.Images.Book());

        const additionalResources = gettingStartedResources.AdditionalResources;
        this.addSection(
            additionalResources.title,
            additionalResources.description,
            [
                new Link(additionalResources.RegionAvailability.title, "https://go.microsoft.com/fwlink/?linkid=848309"),
                new Link(additionalResources.SupportOptions.title, "https://azure.microsoft.com/en-us/support/plans/")
            ],
            MsPortalFx.Base.Images.Attachment());
    }

    public onInputsSet(inputs: Def.InputsContract): MsPortalFx.Base.Promise {
        return Q();
    }
}
