import Definition = require("../_generated/ExtensionDefinition");
import * as ClientResources from "ClientResources";

export const resourceProvider = "Microsoft." + Definition.AssetTypes.Maps.name;
export const resourceType = "accounts";
export const resourceProviderType = resourceProvider + "/" + resourceType;

export const ArmServiceEndpoint = window.fx.environment && window.fx.environment.armEndpoint && window.fx.environment.armEndpoint.replace(/\/$/, "");
export const ArmServiceVersion = "api-version=2018-05-01";

export interface ServiceTierDefinition {
    id: string;
    name: string;
}
export const serviceTiers = {
    standard: <ServiceTierDefinition>{
        id: "S0",
        name: ClientResources.Pricing.Sku.Tier.standard
    }
}