﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Portal.Extensions.LocSvcExtension.Controllers
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.Composition;
    using System.Web;
    using Microsoft.Portal.Framework;

    [Export(typeof(ExtensionDefinition))]
    internal class Definition : ExtensionDefinition
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Definition"/> class.
        /// </summary>
        /// <param name="applicationConfiguration">The application configuration.</param>
        [ImportingConstructor]
        public Definition(ApplicationConfiguration applicationConfiguration)
        {
            this.ExtensionConfiguration = new Dictionary<string, object>()
            {
                { "armEndpoint", applicationConfiguration.ArmEndpoint }
            };
        }

        public override bool TraceAjaxErrors
        {
            get
            {
                return true;
            }
        }

        public override string GetTitle(PortalRequestContext context)
        {
            return Client.ClientResources.ExtensionName;
        }
    }
}