﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Portal.Extensions.LocSvcExtension.Controllers
{
    using System.ComponentModel.Composition;
    using System.Web;
    using System.Web.Mvc;
    using Microsoft.Portal.Framework;

    /// <summary>
    /// Home controller
    /// </summary>
    [Export]
    [PartCreationPolicy(CreationPolicy.NonShared)]
    public class HomeController : ExtensionControllerBase
    {
        private ApplicationConfiguration settings;

        /// <summary>
        /// Initializes a new instance of the HomeController class.
        /// </summary>
        [ImportingConstructor]
        public HomeController(ExtensionDefinition definition, ApplicationConfiguration settings)
            : base(definition)
        {
            this.settings = settings;
        }

#if DEBUG
        protected override void OnActionExecuted(ActionExecutedContext filterContext)
        {
            if (settings.IsDevelopmentMode && Request.QueryString.Count == 0 && filterContext.ActionDescriptor.ActionName == "Index")
            {
                // IIS Express and the VS debug are shutdown when using a redirect to side load the extension using Test in Prod (TiP) functionality.
                // Instead of using a redirect keep the original window open on localhost:<port> and open a new one for TiP
                //
                // note the microsoft_azure_marketplace_ItemHideKey=LocSvcExtensionHidden allows the use of the gallery item for Azure Maps
                var keepDebuggerAttached = string.Format(
                    "<script>window.open('{0}/?feature.customportal=false&microsoft_azure_marketplace_ItemHideKey=LocSvcExtensionHidden&feature.canmodifyextensions=true#?testExtensions={{\"Microsoft_Azure_LocationServices\":\"{1}\"}}');</script>",
                    this.settings.TestInProdEnvironment,
                    HttpUtility.HtmlEncode(Request.Url.ToString()));
                filterContext.HttpContext.Response.Write(keepDebuggerAttached);
                base.OnActionExecuted(filterContext);
            }
        }
#endif
    }
}