﻿$localizationDropPath = "\\simpleloc\drops\Drops\IoT-LocationServices_2060"

$versionName = (Get-ChildItem $localizationDropPath | Select-Object -Last 1).Name

function GetLocaleCode([string] $s)
{
    Switch($s)
    {
        "pt-BR"    { return $s.ToLowerInvariant() }
        "pt-PT"    { return $s.ToLowerInvariant() }
        "zh-CN"    { return "zh-hans" }
        "zh-TW"    { return "zh-hant" }
        "qps-ploc" { return $s; }
        default    { return $s.Split('-')[0] }
    }
}


function CopyToDestination([string] $directoryName)
{
    $localeCode = GetLocaleCode $directoryName
    $extensionSrcPath = $PSScriptRoot
    $root = "$localizationDropPath\$versionName\BinDrops\Windows\bin\$directoryName\src\LocSvcExtension\LocSvcExtension"
    $srcResx = "$root\Client\ClientResources.resx"
    $dstResx = "$extensionSrcPath\Client\ClientResources.$localeCode.resx"
    Write-Host Copying $srcResx to $dstResx
    Copy-Item $srcResx $dstResx

    $srcResjson = "$root\GalleryPackages\Create\strings\resources.resjson"
    $dstResjson = "$extensionSrcPath\GalleryPackages\Create\strings\$localeCode\resources.resjson"
    Write-Host Copying $srcResjson to $dstResjson
    Copy-Item $srcResjson $dstResjson
}

Get-ChildItem $localizationDropPath\$versionName\BinDrops\Windows\bin\ | % { CopyToDestination $_.Name }