﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderPermissions.Authorization
{
    using System.Security.Cryptography.X509Certificates;
    using System.Threading.Tasks;

    /// <summary>
    /// We have this interface to abstract away the ability to retrieve a certificate.
    /// </summary>
    public interface ICertificateResolver
    {
        Task<X509Certificate2> ResolveCertificateAsync(string subjectName);        
    }
}
