﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderPermissions.Authorization
{
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    public interface IRoleAssignments
    {
        List<RoleAssignment> Assignments { get; }

        bool IsLoaded { get; }

        string SubscriptionId { get; }

        Task LoadAsync(Subscription subscription, CancellationToken cancellationToken);

        Task SaveAsync();

        List<CheckAccessAssignment> ToCheckAccessAssignments();
    }
}