﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderPermissions.Authorization
{    
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    class MockRoleAssignments : IRoleAssignments
    {
        public List<RoleAssignment> Assignments { get; }

        public bool IsLoaded { get; }

        public string SubscriptionId { get; }

        public Task LoadAsync(Subscription subscription, CancellationToken cancellationToken)
        {
            return Task.CompletedTask;
        }

        public Task SaveAsync()
        {
            return Task.CompletedTask;
        }

        public List<CheckAccessAssignment> ToCheckAccessAssignments()
        {
            return new List<CheckAccessAssignment>();
        }
    }
}
