﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderPermissions.Authorization
{
    using System;
    using Newtonsoft.Json;    

    public class RoleAssignment
    {
        [JsonProperty(PropertyName = "properties", Required = Required.Always)]
        public RoleAssignmentProperties Properties { get; private set; }

        [JsonProperty(PropertyName = "id", Required = Required.Always)]
        public string Id { get; private set; }

        [JsonProperty(PropertyName = "name", Required = Required.Always)]
        public string Name { get; private set; }

        public CheckAccessAssignment ToCheckAccessAssignment()
        {            
            CheckAccessAssignment checkAccessAssignment = new CheckAccessAssignment();
            checkAccessAssignment.Id = Name;
            checkAccessAssignment.PrincipalId = Properties.PrincipalId;

            // /subscriptions/{guid}/providers/Microsoft.Authorization/roleDefinitions/{roleDefinitionId}
            // this will be recreated during authorization check.
            checkAccessAssignment.RoleDefinitionId = Properties.RoleDefinitionId.Split('/')[6];
            checkAccessAssignment.Scope = Properties.Scope;

            return checkAccessAssignment;
        }
    }
}
