﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderPermissions.Configuration
{    
    using System.Collections.ObjectModel;
    using Microsoft.Azure.LocationServices.Instrumentation;

    /// <summary>
    /// The development environment definition.
    /// </summary>
    public class PermissionsJobHostDevSettings : PermissionsJobHostSettings
    {
        /// <inheritdoc />
        public override InitParams MdmParameters
        {
            get
            {
                var p = new InitParams("DevTestIfx", "AzLocTest");
                p.SetLocalTracing(@"c:\ifxTrace");
                p.SetEtwProvider("DevTest", "DB25DB83-F4C7-4D76-9DBA-5D08A7DEC472");
                return p;
            }
        }

        /// <inheritdoc />
        public override Collection<string> CosmosDbPrefferedLocations
        {
            get
            {                
                return CosmosDbConstants.CI_PreferredEastUsLocations;
            }            
        }

        /// <inheritdoc />
        public override bool EnableAccountReplication => true;

        /// <inheritdoc />
        protected override string GlobalKeyVaultName => "c-global";

        /// <inheritdoc />
        protected override string RegionalKeyVaultName
        {
            get
            {
                switch (CurrentRegion)
                {
                    default: return "c-rp-eastus";
                }
            }
        }

        /// <inheritdoc />
        protected override string MapsFrontEndCosmosDbAccountName => CosmosDbConstants.CI_CosmosDbAccountName;
    }
}
