﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderPermissions.Configuration
{    
    using System.Collections.ObjectModel;
    using Microsoft.Azure.LocationServices.Instrumentation;

    /// <summary>
    /// The Integration/Test environment definition.
    /// </summary>
    public class PermissionsJobHostTestSettings : PermissionsJobHostSettings
    {        
        /// <inheritdoc />
        public override InitParams MdmParameters
        {
            get
            {
                InitParams p = new InitParams("DevTestIfx", "AzLocTest");
                return p;
            }
        }

        /// <inheritdoc />
        public override Collection<string> CosmosDbPrefferedLocations
        {
            get
            {
                return CosmosDbConstants.Test_PreferredEastUsLocations;
            }
        }

        /// <inheritdoc />
        public override bool EnableAccountReplication => false;

        /// <inheritdoc />
        protected override string GlobalKeyVaultName => "t-global";

        /// <inheritdoc />
        protected override string RegionalKeyVaultName
        {
            get
            {
                return "t-rp-eastus";
            }
        }

        /// <inheritdoc />
        protected override string MapsFrontEndCosmosDbAccountName => CosmosDbConstants.Test_CosmosDbAccountName;
    }
}
