﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace RpPermissions
{
    using System;
    using System.Diagnostics;
    using System.Threading;
    using Microsoft.Azure.LocationServices.Instrumentation;
    using Microsoft.Azure.LocationServices.ResourceProviderPermissions;
    using Microsoft.Azure.LocationServices.ResourceProviderPermissions.Configuration;
    using Microsoft.ServiceFabric.Services.Runtime;

    internal static class Program
    {
        /// <summary>
        /// This is the entry point of the service host process.
        /// </summary>
        private static void Main()
        {
            PermissionsJobHostSettings settings = PermissionsJobHostSettings.CreateFromEnvironment();
            Agent.CreateInstance(settings.MdmParameters);
            try
            {                
                ServiceRuntime.RegisterServiceAsync("ResourceProviderPermissionsType",
                    context => new PermissionsService(context)).GetAwaiter().GetResult();

                Agent.Instance.LogServiceTypeRegistered(Process.GetCurrentProcess().Id, typeof(PermissionsService).Name);
                Thread.Sleep(Timeout.Infinite);
            }
            catch (Exception ex)
            {
                Agent.Instance.LogException(ex, "resourceProvider", "initialization");
                throw;
            }
        }
    }
}
