﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderPermissions
{
    using System.Threading;
    using System.Threading.Tasks;

    public class SubscriptionQueueObserver
    {        
        private readonly ISubscriptions subcriptions;

        public SubscriptionQueueObserver(ISubscriptions subcriptions)
        {
            this.subcriptions = subcriptions;
        }

        public async Task RunAsync(CancellationToken cancellationToken)
        {
            await subcriptions.LoadAsync(cancellationToken);
            await subcriptions.PruneStaleAsync(cancellationToken);
            await subcriptions.UpdatePermissionsAsync(cancellationToken);            
        }
    }
}
