﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.ResourceProviderUnitTests
{
    using System;

    using FsCheck;

    using Generators;

    internal static class ArbitraryMoveRequest
    {
        public static Arbitrary<Tuple<string, string, string, string>> Strings()
        {
            var subs = ArmStringGenerator.SubscriptionIds;
            var rgs = ArmStringGenerator.ResourceGroups;

            return (
                from sub1 in subs
                from sub2 in subs
                from rg1 in rgs
                from rg2 in rgs
                select new Tuple<string, string, string, string>(sub1, rg1, sub2, rg2))
                .ToArbitrary();
        }
    }
}
