﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 
namespace Microsoft.Azure.LocationServices.ResourceProviderUnitTests.Generators
{
    internal static class ArmStringRegex
    {
        internal const string SubscriptionRegex = @"[a-zA-Z0-9]{8}-([a-zA-Z0-9]{4}-){3}[a-zA-Z0-9]{12}";

        internal const string ResourceGroupRegex = @"[a-zA-Z0-9()._]{0,63}[a-zA-Z0-9()_]";

        internal const string AccountNameRegex = @"[^\p{C}%&:\\/\?]{1,154}";

        internal static readonly string ResourceIdRegex = $"/subscriptions/{SubscriptionRegex}/resourceGroups/{ResourceGroupRegex}/providers/{ResourceProviderType}/{AccountNameRegex}";

        private const string ResourceProviderType = "c/accounts";
    }
}