// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderUnitTests
{
    using System.Linq;

    using Fare;

    using FsCheck;

    /// <summary>
    /// Based on https://github.com/moodmosaic/FsCheck.Regex/blob/master/README.md
    /// </summary>
    internal static class StringGenerator
    {
        internal static Gen<string> Matching(string pattern)
        {
            return Gen.Sized(size =>
                {
                    Xeger gen = new Xeger(pattern);
                    var count = size < 1 ? 1 : size;
                    var entries = Enumerable.Range(0, count).Select(_ => gen.Generate());
                    return Gen.Elements(entries).Resize(count);
                });
        }
    }
}