﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderUnitTests
{
    using System.Net.Http;
    using System.Threading.Tasks;

    internal static class HttpClientExtensions
    {
        internal static HttpResponseMessage Delete(this HttpClient client, string requestUri)
        {
            return client.DeleteAsync(requestUri).GetAwaiter().GetResult();
        }

        internal static HttpResponseMessage Get(this HttpClient client, string requestUri)
        {
            return client.GetAsync(requestUri).GetAwaiter().GetResult();
        }

        internal static async Task<HttpResponseMessage> PatchAsync(this HttpClient client, string requestUri, HttpContent content)
        {
            var method = new HttpMethod("PATCH");

            var request = new HttpRequestMessage(method, requestUri)
                              {
                                  Content = content
                              };

            return await client.SendAsync(request);
        }

        internal static HttpResponseMessage Post(this HttpClient client, string requestUri, HttpContent content = null)
        {
            return client.PostAsync(requestUri, content).GetAwaiter().GetResult();
        }

        internal static HttpResponseMessage Put(this HttpClient client, string requestUri, HttpContent content)
        {
            return client.PutAsync(requestUri, content).GetAwaiter().GetResult();
        }
    }
}