﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 
namespace Microsoft.Azure.LocationServices.ResourceProviderUnitTests.Mocks
{
    using System.Security.Cryptography.X509Certificates;

    using Microsoft.Azure.LocationServices.ResourceProviderWebAPI;

    using Moq;

    internal class MockClientCertificateResolverFactory : IClientCertificateResolverFactory
    {
        public IClientCertificateResolver GetClientCertificateResolver()
        {
            var mockClientCertificateResolver = new Mock<IClientCertificateResolver>();
            mockClientCertificateResolver.Setup(resolver => resolver.ValidateClientCertificate(It.IsAny<X509Certificate2>())).Returns(true);
            return mockClientCertificateResolver.Object;
        }
    }
}