﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.ResourceProviderWebAPI.ApiManagement.Contracts.RequestContract
{
    /// <summary>
    ///     The Product class
    /// </summary>
    public class Product
    {
        /// <summary>
        ///     Gets or sets the name.
        /// </summary>
        /// <value>
        ///     The name.
        /// </value>
        public string Name { get; set; }

        /// <summary>
        ///     Gets or sets the description.
        /// </summary>
        /// <value>
        ///     The description.
        /// </value>
        public string Description { get; set; }

        /// <summary>
        ///     Gets or sets the terms.
        /// </summary>
        /// <value>
        ///     The terms.
        /// </value>
        public string Terms { get; set; }

        /// <summary>
        ///     Gets or sets a value indicating whether [subscription required].
        /// </summary>
        /// <value>
        ///     <c>true</c> if [subscription required]; otherwise, <c>false</c>.
        /// </value>
        public bool SubscriptionRequired { get; set; }

        /// <summary>
        ///     Gets or sets a value indicating whether [approval required].
        /// </summary>
        /// <value>
        ///     <c>true</c> if [approval required]; otherwise, <c>false</c>.
        /// </value>
        public bool ApprovalRequired { get; set; }

        /// <summary>
        ///     Gets or sets the subscriptions limit.
        /// </summary>
        /// <value>
        ///     The subscriptions limit.
        /// </value>
        public int? SubscriptionsLimit { get; set; }

        /// <summary>
        ///     Gets or sets the state.
        /// </summary>
        /// <value>
        ///     The state.
        /// </value>
        public ProductState State { get; set; }
    }
}