﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderWebAPI.ApiManagement.Contracts.ResponseContract
{
    using System.Collections.ObjectModel;

    /// <summary>
    /// The API class
    /// </summary>
    public class Api
    {
        /// <summary>
        /// Gets or sets the identifier.
        /// </summary>
        /// <value>
        /// The identifier.
        /// </value>
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        /// <value>
        /// The name.
        /// </value>
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the description.
        /// </summary>
        /// <value>
        /// The description.
        /// </value>
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets the service URL.
        /// </summary>
        /// <value>
        /// The service URL.
        /// </value>
        public string ServiceUrl { get; set; }

        /// <summary>
        /// Gets or sets the path.
        /// </summary>
        /// <value>
        /// The path.
        /// </value>
        public string Path { get; set; }

        /// <summary>
        /// Gets or sets the protocols.
        /// </summary>
        /// <value>
        /// The protocols.
        /// </value>
        public Collection<string> Protocols { get; set; }

        /// <summary>
        /// Gets or sets the authentication settings.
        /// </summary>
        /// <value>
        /// The authentication settings.
        /// </value>
        public AuthenticationSettings AuthenticationSettings { get; set; }

        /// <summary>
        /// Gets or sets the subscription key parameter names.
        /// </summary>
        /// <value>
        /// The subscription key parameter names.
        /// </value>
        public SubscriptionKeyParameterNames SubscriptionKeyparameterNames { get; set; }
    }
}
