﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.ResourceProviderWebAPI.ApiManagement.Contracts.ResponseContract
{
    /// <summary>
    ///     The Product class
    /// </summary>
    public class Product
    {
        /// <summary>
        ///     Gets or sets the identifier.
        /// </summary>
        /// <value>
        ///     The identifier.
        /// </value>
        public string Id { get; set; }

        /// <summary>
        ///     Gets or sets the name.
        /// </summary>
        /// <value>
        ///     The name.
        /// </value>
        public string Name { get; set; }

        /// <summary>
        ///     Gets or sets the description.
        /// </summary>
        /// <value>
        ///     The description.
        /// </value>
        public string Description { get; set; }

        /// <summary>
        ///     Gets or sets the terms.
        /// </summary>
        /// <value>
        ///     The terms.
        /// </value>
        public string Terms { get; set; }

        /// <summary>
        ///     Gets or sets the subscription required.
        /// </summary>
        /// <value>
        ///     The subscription required.
        /// </value>
        public bool? SubscriptionRequired { get; set; }

        /// <summary>
        ///     Gets or sets the approval required.
        /// </summary>
        /// <value>
        ///     The approval required.
        /// </value>
        public bool? ApprovalRequired { get; set; }

        /// <summary>
        ///     Gets or sets the subscriptions limit.
        /// </summary>
        /// <value>
        ///     The subscriptions limit.
        /// </value>
        public int? SubscriptionsLimit { get; set; }

        /// <summary>
        ///     Gets or sets the subscription period.
        /// </summary>
        /// <value>
        ///     The subscription period.
        /// </value>
        public SubscriptionPeriod SubscriptionPeriod { get; set; }

        /// <summary>
        ///     Gets or sets the notification period.
        /// </summary>
        /// <value>
        ///     The notification period.
        /// </value>
        public NotificationPeriod NotificationPeriod { get; set; }

        /// <summary>
        ///     Gets or sets the state.
        /// </summary>
        /// <value>
        ///     The state.
        /// </value>
        public ProductState State { get; set; }
    }
}