﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.ResourceProviderWebAPI.ApiManagement.Contracts.ResponseContract
{
    /// <summary>
    ///     The Report class
    /// </summary>
    public class Report
    {
        /// <summary>
        ///     Gets or sets the name.
        /// </summary>
        /// <value>
        ///     The name.
        /// </value>
        public string Name { get; set; }

        /// <summary>
        ///     Gets or sets the user identifier.
        /// </summary>
        /// <value>
        ///     The user identifier.
        /// </value>
        public string UserId { get; set; }

        /// <summary>
        ///     Gets or sets the call count success.
        /// </summary>
        /// <value>
        ///     The call count success.
        /// </value>
        public int CallCountSuccess { get; set; }

        /// <summary>
        ///     Gets or sets the call count blocked.
        /// </summary>
        /// <value>
        ///     The call count blocked.
        /// </value>
        public int CallCountBlocked { get; set; }

        /// <summary>
        ///     Gets or sets the call count failed.
        /// </summary>
        /// <value>
        ///     The call count failed.
        /// </value>
        public int CallCountFailed { get; set; }

        /// <summary>
        ///     Gets or sets the call count other.
        /// </summary>
        /// <value>
        ///     The call count other.
        /// </value>
        public int CallCountOther { get; set; }

        /// <summary>
        ///     Gets or sets the call count total.
        /// </summary>
        /// <value>
        ///     The call count total.
        /// </value>
        public int CallCountTotal { get; set; }

        /// <summary>
        ///     Gets or sets the call match count.
        /// </summary>
        /// <value>
        ///     The call match count.
        /// </value>
        public int CallMatchCount { get; set; }

        /// <summary>
        ///     Gets or sets the bandwidth.
        /// </summary>
        /// <value>
        ///     The bandwidth.
        /// </value>
        public long Bandwidth { get; set; }

        /// <summary>
        ///     Gets or sets the cache hit count.
        /// </summary>
        /// <value>
        ///     The cache hit count.
        /// </value>
        public int CacheHitCount { get; set; }

        /// <summary>
        ///     Gets or sets the cache miss count.
        /// </summary>
        /// <value>
        ///     The cache miss count.
        /// </value>
        public int CacheMissCount { get; set; }

        /// <summary>
        ///     Gets or sets the API time average.
        /// </summary>
        /// <value>
        ///     The API time average.
        /// </value>
        public double ApiTimeAvg { get; set; }

        /// <summary>
        ///     Gets or sets the API time minimum.
        /// </summary>
        /// <value>
        ///     The API time minimum.
        /// </value>
        public double ApiTimeMin { get; set; }

        /// <summary>
        ///     Gets or sets the API time maximum.
        /// </summary>
        /// <value>
        ///     The API time maximum.
        /// </value>
        public double ApiTimeMax { get; set; }

        /// <summary>
        ///     Gets or sets the service time average.
        /// </summary>
        /// <value>
        ///     The service time average.
        /// </value>
        public double ServiceTimeAvg { get; set; }

        /// <summary>
        ///     Gets or sets the service time minimum.
        /// </summary>
        /// <value>
        ///     The service time minimum.
        /// </value>
        public double ServiceTimeMin { get; set; }

        /// <summary>
        ///     Gets or sets the service time maximum.
        /// </summary>
        /// <value>
        ///     The service time maximum.
        /// </value>
        public double ServiceTimeMax { get; set; }
    }
}