﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.ResourceProviderWebAPI.ApiManagement.Contracts.ResponseContract
{
    /// <summary>
    ///     The Subscription class
    /// </summary>
    public class Subscription
    {
        /// <summary>
        ///     Gets or sets the identifier.
        /// </summary>
        /// <value>
        ///     The identifier.
        /// </value>
        public string Id { get; set; }

        /// <summary>
        ///     Gets or sets the user identifier.
        /// </summary>
        /// <value>
        ///     The user identifier.
        /// </value>
        public string UserId { get; set; }

        /// <summary>
        ///     Gets or sets the product identifier.
        /// </summary>
        /// <value>
        ///     The product identifier.
        /// </value>
        public string ProductId { get; set; }

        /// <summary>
        ///     Gets or sets the state.
        /// </summary>
        /// <value>
        ///     The state.
        /// </value>
        public SubscriptionState State { get; set; }

        /// <summary>
        ///     Gets or sets the created date.
        /// </summary>
        /// <value>
        ///     The created date.
        /// </value>
        public string CreatedDate { get; set; }

        /// <summary>
        ///     Gets or sets the primary key.
        /// </summary>
        /// <value>
        ///     The primary key.
        /// </value>
        public string PrimaryKey { get; set; }

        /// <summary>
        ///     Gets or sets the secondary key.
        /// </summary>
        /// <value>
        ///     The secondary key.
        /// </value>
        public string SecondaryKey { get; set; }

        /// <summary>
        ///     Gets or sets the start date.
        /// </summary>
        /// <value>
        ///     The start date.
        /// </value>
        public string StartDate { get; set; }

        /// <summary>
        ///     Gets or sets the state comment.
        /// </summary>
        /// <value>
        ///     The state comment.
        /// </value>
        public string StateComment { get; set; }

        /// <summary>
        ///     Gets or sets the name.
        /// </summary>
        /// <value>
        ///     The name.
        /// </value>
        public string Name { get; set; }
    }
}