﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.ResourceProviderWebAPI.ApiManagement.Contracts.ResponseContract
{
    /// <summary>
    ///     The User class
    /// </summary>
    public class User
    {
        /// <summary>
        ///     Gets or sets the identifier.
        /// </summary>
        /// <value>
        ///     The identifier.
        /// </value>
        public string Id { get; set; }

        /// <summary>
        ///     Gets or sets the first name.
        /// </summary>
        /// <value>
        ///     The first name.
        /// </value>
        public string FirstName { get; set; }

        /// <summary>
        ///     Gets or sets the last name.
        /// </summary>
        /// <value>
        ///     The last name.
        /// </value>
        public string LastName { get; set; }

        /// <summary>
        ///     Gets or sets the email.
        /// </summary>
        /// <value>
        ///     The email.
        /// </value>
        public string Email { get; set; }

        /// <summary>
        ///     Gets or sets the state.
        /// </summary>
        /// <value>
        ///     The state.
        /// </value>
        public UserState State { get; set; }

        /// <summary>
        ///     Gets or sets the registration date.
        /// </summary>
        /// <value>
        ///     The registration date.
        /// </value>
        public string RegistrationDate { get; set; }

        /// <summary>
        ///     Gets or sets the note.
        /// </summary>
        /// <value>
        ///     The note.
        /// </value>
        public string Note { get; set; }

        /// <summary>
        ///     Gets or sets the groups.
        /// </summary>
        /// <value>
        ///     The groups.
        /// </value>
        public Group[] Groups { get; set; }
    }
}