﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderWebAPI.ApiManagement.Models
{
    /// <summary>
    /// The APIMPolicy class
    /// </summary>
    public class ApimPolicy
    {
        /// <summary>
        /// Gets or sets the rate limit calls.
        /// </summary>
        /// <value>
        /// The rate limit calls.
        /// </value>
        public int RateLimitCalls { get; set; }

        /// <summary>
        /// Gets or sets the rate limit renewal period.
        /// </summary>
        /// <value>
        /// The rate limit renewal period.
        /// </value>
        public int RateLimitRenewalPeriod { get; set; }

        /// <summary>
        /// Gets or sets the quota calls.
        /// </summary>
        /// <value>
        /// The quota calls.
        /// </value>
        public int QuotaCalls { get; set; }

        /// <summary>
        /// Gets or sets the quota renewal period.
        /// </summary>
        /// <value>
        /// The quota renewal period.
        /// </value>
        public int QuotaRenewalPeriod { get; set; }
    }
}
