﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.ResourceProviderWebAPI
{
    using System.Web.Http.Dependencies;
    using Validation;

    internal class ClientCertificateResolverFactory : IClientCertificateResolverFactory
    {
        private readonly IDependencyResolver _resolver;

        public ClientCertificateResolverFactory(IDependencyResolver resolver)
        {
            Requires.NotNull(resolver, nameof(resolver));
            _resolver = resolver;
        }

        public IClientCertificateResolver GetClientCertificateResolver()
        {
            return (IClientCertificateResolver)_resolver.GetService(typeof(IClientCertificateResolver));
        }
    }
}