﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.ResourceProviderWebAPI.ExternalContracts
{
    using System;

    using Microsoft.Azure.LocationServices.ResourceProviderWebAPI.ApiManagement;
    using Newtonsoft.Json;

    internal class Keys
    {
        internal Keys(AccountIdentifier id, ApiManagementKeys keys, string providerName)
        {
            Validation.Requires.NotNull(id, nameof(id));
            Validation.Requires.NotNull(keys, nameof(keys));

            this.Id = Account.BuildExternalId(id, providerName);
            this.PrimaryKey = keys.PrimaryKey.Key;
            this.SecondaryKey = keys.SecondaryKey.Key;
            this.PrimaryKeyLastUpdated = keys.PrimaryKey.LastUpdated;
            this.SecondaryKeyLastUpdated = keys.SecondaryKey.LastUpdated;
        }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("primaryKey")]
        public string PrimaryKey { get; private set; }

        [JsonProperty("secondaryKey")]
        public string SecondaryKey { get; private set; }

        [JsonProperty("primaryKeyLastUpdated")]
        public DateTime PrimaryKeyLastUpdated { get; private set; }

        [JsonProperty("secondaryKeyLastUpdated")]
        public DateTime SecondaryKeyLastUpdated { get; private set; }
    }
}