﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 
namespace Microsoft.Azure.LocationServices.ResourceProviderWebAPI
{
    using System;
    using System.Collections.Generic;
    using System.Linq;

    internal static class ResourceProviderWebApiExtensions
    {
        public static IEnumerable<TSource> DistinctBy<TSource, TKey>(this IEnumerable<TSource> enumerable, Func<TSource, TKey> keySelector)
        {
            return enumerable.GroupBy(keySelector).Select(x => x.FirstOrDefault());
        }
    }
}