﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.ResourceProviderWebAPI
{
    using System;
    using System.Dynamic;

    public class Subscription
    {
        public Subscription(string subscriptionId, ExternalContracts.Subscription externalSubscription)
        {
            Validation.Requires.NotNull(subscriptionId, nameof(subscriptionId));
            Validation.Requires.NotNull(externalSubscription, "Subscription");

            SubscriptionStateType result;
            if (!Enum.TryParse(externalSubscription.State, true, out result))
            {
                Validation.Requires.Fail(null, "Subscription.state");
            }
            else
            {
                State = result;
            }

            Id = subscriptionId;
            Properties = externalSubscription.Properties;
        }

        public string Id { get; }

        public SubscriptionStateType State { get; }

        public ExpandoObject Properties { get; }
    }
}