/**
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package lbs;

import com.microsoft.rest.RestException;
import com.microsoft.rest.ServiceCallback;
import com.microsoft.rest.ServiceFuture;
import com.microsoft.rest.ServiceResponse;
import java.io.IOException;
import rx.Observable;

/**
 * An instance of this class provides access to all the operations defined
 * in Searchs.
 */
public interface Searchs {
    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchFuzzy(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchFuzzyAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchFuzzyAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchFuzzyWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);
    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param minFuzzyLevel Minimum fuzzyness level to be used.  E.g. 1 - 4
     * @param maxFuzzyLevel Maximum fuzzyness level to be used E.g. 2 - 4
     * @param idxSet A comma separated list of indexes which should be utilized for the search. Item order does not matter. Available indexes are: Addr = Address range interpolation, Geo = Geographies, PAD = Point Addresses, POI = Points of interest, Str = Streets, Xstr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchFuzzy(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, String minFuzzyLevel, String maxFuzzyLevel, String idxSet);

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param minFuzzyLevel Minimum fuzzyness level to be used.  E.g. 1 - 4
     * @param maxFuzzyLevel Maximum fuzzyness level to be used E.g. 2 - 4
     * @param idxSet A comma separated list of indexes which should be utilized for the search. Item order does not matter. Available indexes are: Addr = Address range interpolation, Geo = Geographies, PAD = Point Addresses, POI = Points of interest, Str = Streets, Xstr = Cross Streets (intersections)
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchFuzzyAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, String minFuzzyLevel, String maxFuzzyLevel, String idxSet, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param minFuzzyLevel Minimum fuzzyness level to be used.  E.g. 1 - 4
     * @param maxFuzzyLevel Maximum fuzzyness level to be used E.g. 2 - 4
     * @param idxSet A comma separated list of indexes which should be utilized for the search. Item order does not matter. Available indexes are: Addr = Address range interpolation, Geo = Geographies, PAD = Point Addresses, POI = Points of interest, Str = Streets, Xstr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchFuzzyAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, String minFuzzyLevel, String maxFuzzyLevel, String idxSet);

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param minFuzzyLevel Minimum fuzzyness level to be used.  E.g. 1 - 4
     * @param maxFuzzyLevel Maximum fuzzyness level to be used E.g. 2 - 4
     * @param idxSet A comma separated list of indexes which should be utilized for the search. Item order does not matter. Available indexes are: Addr = Address range interpolation, Geo = Geographies, PAD = Point Addresses, POI = Points of interest, Str = Streets, Xstr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchFuzzyWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, String minFuzzyLevel, String maxFuzzyLevel, String idxSet);

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchPOI(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchPOIAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchPOIAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchPOIWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);
    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchPOI(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor);

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchPOIAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchPOIAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor);

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchPOIWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor);

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchPOICategory(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchPOICategoryAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchPOICategoryAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchPOICategoryWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);
    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchPOICategory(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor);

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchPOICategoryAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchPOICategoryAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor);

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchPOICategoryWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor);

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchAddress(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchAddressAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchAddressAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchAddressWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);
    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchAddress(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor);

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchAddressAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchAddressAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor);

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchAddressWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor);

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchAddressReverse(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchAddressReverseAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchAddressReverseAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchAddressReverseWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);
    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param returnSpeedLimit true or false string.  To enable return of the posted speedlimit
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param number If a number is sent in along with the request, the response may include the side of the street (Left/Right) and also an offset position for that number
     * @param returnRoadUse true or false string.  To enable return of the road use array for reversegeocodes at street level
     * @param roadUse To restrict reversegeocodes to a certain type of roaduse. The road use array for reversegeocodes can be one or more of LimitedAccess, Arterial, Terminal, Ramp, Rotary, LocalStreet
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchAddressReverse(String format, String apiVersion, String subscriptionKey, String spatialKeys, String returnSpeedLimit, String heading, String radius, String number, String returnRoadUse, String roadUse);

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param returnSpeedLimit true or false string.  To enable return of the posted speedlimit
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param number If a number is sent in along with the request, the response may include the side of the street (Left/Right) and also an offset position for that number
     * @param returnRoadUse true or false string.  To enable return of the road use array for reversegeocodes at street level
     * @param roadUse To restrict reversegeocodes to a certain type of roaduse. The road use array for reversegeocodes can be one or more of LimitedAccess, Arterial, Terminal, Ramp, Rotary, LocalStreet
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchAddressReverseAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String returnSpeedLimit, String heading, String radius, String number, String returnRoadUse, String roadUse, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param returnSpeedLimit true or false string.  To enable return of the posted speedlimit
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param number If a number is sent in along with the request, the response may include the side of the street (Left/Right) and also an offset position for that number
     * @param returnRoadUse true or false string.  To enable return of the road use array for reversegeocodes at street level
     * @param roadUse To restrict reversegeocodes to a certain type of roaduse. The road use array for reversegeocodes can be one or more of LimitedAccess, Arterial, Terminal, Ramp, Rotary, LocalStreet
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchAddressReverseAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String returnSpeedLimit, String heading, String radius, String number, String returnRoadUse, String roadUse);

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param returnSpeedLimit true or false string.  To enable return of the posted speedlimit
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param number If a number is sent in along with the request, the response may include the side of the street (Left/Right) and also an offset position for that number
     * @param returnRoadUse true or false string.  To enable return of the road use array for reversegeocodes at street level
     * @param roadUse To restrict reversegeocodes to a certain type of roaduse. The road use array for reversegeocodes can be one or more of LimitedAccess, Arterial, Terminal, Ramp, Rotary, LocalStreet
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchAddressReverseWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String returnSpeedLimit, String heading, String radius, String number, String returnRoadUse, String roadUse);

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchAddressReverseCrossStreet(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchAddressReverseCrossStreetAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchAddressReverseCrossStreetAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchAddressReverseCrossStreetWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);
    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchAddressReverseCrossStreet(String format, String apiVersion, String subscriptionKey, String spatialKeys, String heading, String radius, String language);

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchAddressReverseCrossStreetAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String heading, String radius, String language, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchAddressReverseCrossStreetAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String heading, String radius, String language);

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchAddressReverseCrossStreetWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String heading, String radius, String language);

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchAddressStructured(String format, String apiVersion, String subscriptionKey, String countryCode);

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchAddressStructuredAsync(String format, String apiVersion, String subscriptionKey, String countryCode, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchAddressStructuredAsync(String format, String apiVersion, String subscriptionKey, String countryCode);

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchAddressStructuredWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String countryCode);
    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @param limit Maximum number of responses that will be returned
     * @param ofs Starting offset of the returned results within the full result set
     * @param streetNumber The street number portion of an address
     * @param streetName The street name portion of an address
     * @param crossStreet The cross street name for the structured address
     * @param municipality The municipality portion of an address
     * @param municipalitySubdivision The municipality subdivision (sub/super city) for the structured address
     * @param countryTertiarySubdivision The named area for the structured address
     * @param countrySecondarySubdivision The county for the structured address
     * @param countrySubdivision The country subdividion portion of an address
     * @param postalCode The postal code portion of an address
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getSearchAddressStructured(String format, String apiVersion, String subscriptionKey, String countryCode, String limit, String ofs, String streetNumber, String streetName, String crossStreet, String municipality, String municipalitySubdivision, String countryTertiarySubdivision, String countrySecondarySubdivision, String countrySubdivision, String postalCode, String extendedPostalCodesFor);

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @param limit Maximum number of responses that will be returned
     * @param ofs Starting offset of the returned results within the full result set
     * @param streetNumber The street number portion of an address
     * @param streetName The street name portion of an address
     * @param crossStreet The cross street name for the structured address
     * @param municipality The municipality portion of an address
     * @param municipalitySubdivision The municipality subdivision (sub/super city) for the structured address
     * @param countryTertiarySubdivision The named area for the structured address
     * @param countrySecondarySubdivision The county for the structured address
     * @param countrySubdivision The country subdividion portion of an address
     * @param postalCode The postal code portion of an address
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getSearchAddressStructuredAsync(String format, String apiVersion, String subscriptionKey, String countryCode, String limit, String ofs, String streetNumber, String streetName, String crossStreet, String municipality, String municipalitySubdivision, String countryTertiarySubdivision, String countrySecondarySubdivision, String countrySubdivision, String postalCode, String extendedPostalCodesFor, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @param limit Maximum number of responses that will be returned
     * @param ofs Starting offset of the returned results within the full result set
     * @param streetNumber The street number portion of an address
     * @param streetName The street name portion of an address
     * @param crossStreet The cross street name for the structured address
     * @param municipality The municipality portion of an address
     * @param municipalitySubdivision The municipality subdivision (sub/super city) for the structured address
     * @param countryTertiarySubdivision The named area for the structured address
     * @param countrySecondarySubdivision The county for the structured address
     * @param countrySubdivision The country subdividion portion of an address
     * @param postalCode The postal code portion of an address
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getSearchAddressStructuredAsync(String format, String apiVersion, String subscriptionKey, String countryCode, String limit, String ofs, String streetNumber, String streetName, String crossStreet, String municipality, String municipalitySubdivision, String countryTertiarySubdivision, String countrySecondarySubdivision, String countrySubdivision, String postalCode, String extendedPostalCodesFor);

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @param limit Maximum number of responses that will be returned
     * @param ofs Starting offset of the returned results within the full result set
     * @param streetNumber The street number portion of an address
     * @param streetName The street name portion of an address
     * @param crossStreet The cross street name for the structured address
     * @param municipality The municipality portion of an address
     * @param municipalitySubdivision The municipality subdivision (sub/super city) for the structured address
     * @param countryTertiarySubdivision The named area for the structured address
     * @param countrySecondarySubdivision The county for the structured address
     * @param countrySubdivision The country subdividion portion of an address
     * @param postalCode The postal code portion of an address
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getSearchAddressStructuredWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String countryCode, String limit, String ofs, String streetNumber, String streetName, String crossStreet, String municipality, String municipalitySubdivision, String countryTertiarySubdivision, String countrySecondarySubdivision, String countrySubdivision, String postalCode, String extendedPostalCodesFor);

}
