/**
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package lbs;

import com.microsoft.rest.RestException;
import com.microsoft.rest.ServiceCallback;
import com.microsoft.rest.ServiceFuture;
import com.microsoft.rest.ServiceResponse;
import java.io.IOException;
import rx.Observable;

/**
 * An instance of this class provides access to all the operations defined
 * in Timezones.
 */
public interface Timezones {
    /**
     * Returns the timezone info for an IANA ID.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getTimezoneByID(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the timezone info for an IANA ID.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getTimezoneByIDAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the timezone info for an IANA ID.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getTimezoneByIDAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the timezone info for an IANA ID.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getTimezoneByIDWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the timezone info for a coordinates.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getTimezoneByCoordinates(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the timezone info for a coordinates.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getTimezoneByCoordinatesAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the timezone info for a coordinates.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getTimezoneByCoordinatesAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the timezone info for a coordinates.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getTimezoneByCoordinatesWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns all the Windows timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getTimezoneEnumWindows(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns all the Windows timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getTimezoneEnumWindowsAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns all the Windows timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getTimezoneEnumWindowsAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns all the Windows timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getTimezoneEnumWindowsWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns all the IANA timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getTimezoneEnumIANA(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns all the IANA timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getTimezoneEnumIANAAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns all the IANA timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getTimezoneEnumIANAAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns all the IANA timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getTimezoneEnumIANAWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the current IANA version.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getTimezoneIANAVersion(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the current IANA version.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getTimezoneIANAVersionAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Returns the current IANA version.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getTimezoneIANAVersionAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Returns the current IANA version.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getTimezoneIANAVersionWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Get the IANA timezone from a Windows timezone.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    Object getTimezoneWindowsToIANA(String format, String apiVersion, String subscriptionKey);

    /**
     * Get the IANA timezone from a Windows timezone.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    ServiceFuture<Object> getTimezoneWindowsToIANAAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback);

    /**
     * Get the IANA timezone from a Windows timezone.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<Object> getTimezoneWindowsToIANAAsync(String format, String apiVersion, String subscriptionKey);

    /**
     * Get the IANA timezone from a Windows timezone.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    Observable<ServiceResponse<Object>> getTimezoneWindowsToIANAWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey);

}
