/**
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package lbs.implementation;

import retrofit2.Retrofit;
import lbs.Searchs;
import lbs.models.Error;
import lbs.models.Searchaddress200;
import lbs.models.Searchaddressreverse200;
import lbs.models.Searchaddressreversecrossstreet200;
import lbs.models.Searchaddressstructured200;
import lbs.models.Searchfuzzy200;
import lbs.models.Searchpoi200;
import lbs.models.Searchpoicategory200;
import com.google.common.reflect.TypeToken;
import com.microsoft.rest.RestException;
import com.microsoft.rest.ServiceCallback;
import com.microsoft.rest.ServiceFuture;
import com.microsoft.rest.ServiceResponse;
import java.io.IOException;
import okhttp3.ResponseBody;
import retrofit2.http.GET;
import retrofit2.http.Headers;
import retrofit2.http.Path;
import retrofit2.http.Query;
import retrofit2.Response;
import rx.functions.Func1;
import rx.Observable;

/**
 * An instance of this class provides access to all the operations defined
 * in Searchs.
 */
public class SearchsImpl implements Searchs {
    /** The Retrofit service to perform REST calls. */
    private SearchsService service;
    /** The service client containing this operation class. */
    private AzureLocationBasedServicesImpl client;

    /**
     * Initializes an instance of Searchs.
     *
     * @param retrofit the Retrofit instance built from a Retrofit Builder.
     * @param client the instance of the service client containing this operation class.
     */
    public SearchsImpl(Retrofit retrofit, AzureLocationBasedServicesImpl client) {
        this.service = retrofit.create(SearchsService.class);
        this.client = client;
    }

    /**
     * The interface defining all the services for Searchs to be
     * used by Retrofit to perform actually REST calls.
     */
    interface SearchsService {
        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Searchs getSearchFuzzy" })
        @GET("search/fuzzy/{format}")
        Observable<Response<ResponseBody>> getSearchFuzzy(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey, @Query("query") String query, @Query("typeahead") String typeahead, @Query("limit") String limit, @Query("ofs") String ofs, @Query("countrySet") String countrySet, @Query("lat") String lat, @Query("lon") String lon, @Query("radius") String radius, @Query("topLeft") String topLeft, @Query("btmRight") String btmRight, @Query("language") String language, @Query("extendedPostalCodesFor") String extendedPostalCodesFor, @Query("minFuzzyLevel") String minFuzzyLevel, @Query("maxFuzzyLevel") String maxFuzzyLevel, @Query("idxSet") String idxSet);

        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Searchs getSearchPOI" })
        @GET("search/poi/{format}")
        Observable<Response<ResponseBody>> getSearchPOI(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey, @Query("query") String query, @Query("typeahead") String typeahead, @Query("limit") String limit, @Query("ofs") String ofs, @Query("countrySet") String countrySet, @Query("lat") String lat, @Query("lon") String lon, @Query("radius") String radius, @Query("topLeft") String topLeft, @Query("btmRight") String btmRight, @Query("language") String language, @Query("extendedPostalCodesFor") String extendedPostalCodesFor);

        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Searchs getSearchPOICategory" })
        @GET("search/poi/category/{format}")
        Observable<Response<ResponseBody>> getSearchPOICategory(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey, @Query("query") String query, @Query("typeahead") String typeahead, @Query("limit") String limit, @Query("ofs") String ofs, @Query("countrySet") String countrySet, @Query("lat") String lat, @Query("lon") String lon, @Query("radius") String radius, @Query("topLeft") String topLeft, @Query("btmRight") String btmRight, @Query("language") String language, @Query("extendedPostalCodesFor") String extendedPostalCodesFor);

        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Searchs getSearchAddress" })
        @GET("search/address/{format}")
        Observable<Response<ResponseBody>> getSearchAddress(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey, @Query("query") String query, @Query("typeahead") String typeahead, @Query("limit") String limit, @Query("ofs") String ofs, @Query("countrySet") String countrySet, @Query("lat") String lat, @Query("lon") String lon, @Query("radius") String radius, @Query("topLeft") String topLeft, @Query("btmRight") String btmRight, @Query("language") String language, @Query("extendedPostalCodesFor") String extendedPostalCodesFor);

        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Searchs getSearchAddressReverse" })
        @GET("search/address/reverse/{format}")
        Observable<Response<ResponseBody>> getSearchAddressReverse(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey, @Query("query") String query, @Query("spatialKeys") String spatialKeys, @Query("returnSpeedLimit") String returnSpeedLimit, @Query("heading") String heading, @Query("radius") String radius, @Query("number") String number, @Query("returnRoadUse") String returnRoadUse, @Query("roadUse") String roadUse);

        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Searchs getSearchAddressReverseCrossStreet" })
        @GET("search/address/reverse/crossStreet/{format}")
        Observable<Response<ResponseBody>> getSearchAddressReverseCrossStreet(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey, @Query("query") String query, @Query("spatialKeys") String spatialKeys, @Query("heading") String heading, @Query("radius") String radius, @Query("language") String language);

        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Searchs getSearchAddressStructured" })
        @GET("search/address/structured/{format}")
        Observable<Response<ResponseBody>> getSearchAddressStructured(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey, @Query("countryCode") String countryCode, @Query("limit") String limit, @Query("ofs") String ofs, @Query("streetNumber") String streetNumber, @Query("streetName") String streetName, @Query("crossStreet") String crossStreet, @Query("municipality") String municipality, @Query("municipalitySubdivision") String municipalitySubdivision, @Query("countryTertiarySubdivision") String countryTertiarySubdivision, @Query("countrySecondarySubdivision") String countrySecondarySubdivision, @Query("countrySubdivision") String countrySubdivision, @Query("postalCode") String postalCode, @Query("extendedPostalCodesFor") String extendedPostalCodesFor);

    }

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchFuzzy(String format, String apiVersion, String subscriptionKey) {
        return getSearchFuzzyWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchFuzzyAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchFuzzyWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchFuzzyAsync(String format, String apiVersion, String subscriptionKey) {
        return getSearchFuzzyWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchFuzzyWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        final String typeahead = null;
        final String limit = null;
        final String ofs = null;
        final String countrySet = null;
        final String lat = null;
        final String lon = null;
        final String radius = null;
        final String topLeft = null;
        final String btmRight = null;
        final String language = null;
        final String extendedPostalCodesFor = null;
        final String minFuzzyLevel = null;
        final String maxFuzzyLevel = null;
        final String idxSet = null;
        return service.getSearchFuzzy(format, apiVersion, subscriptionKey, this.client.query(), typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor, minFuzzyLevel, maxFuzzyLevel, idxSet)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchFuzzyDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param minFuzzyLevel Minimum fuzzyness level to be used.  E.g. 1 - 4
     * @param maxFuzzyLevel Maximum fuzzyness level to be used E.g. 2 - 4
     * @param idxSet A comma separated list of indexes which should be utilized for the search. Item order does not matter. Available indexes are: Addr = Address range interpolation, Geo = Geographies, PAD = Point Addresses, POI = Points of interest, Str = Streets, Xstr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchFuzzy(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, String minFuzzyLevel, String maxFuzzyLevel, String idxSet) {
        return getSearchFuzzyWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor, minFuzzyLevel, maxFuzzyLevel, idxSet).toBlocking().single().body();
    }

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param minFuzzyLevel Minimum fuzzyness level to be used.  E.g. 1 - 4
     * @param maxFuzzyLevel Maximum fuzzyness level to be used E.g. 2 - 4
     * @param idxSet A comma separated list of indexes which should be utilized for the search. Item order does not matter. Available indexes are: Addr = Address range interpolation, Geo = Geographies, PAD = Point Addresses, POI = Points of interest, Str = Streets, Xstr = Cross Streets (intersections)
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchFuzzyAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, String minFuzzyLevel, String maxFuzzyLevel, String idxSet, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchFuzzyWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor, minFuzzyLevel, maxFuzzyLevel, idxSet), serviceCallback);
    }

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param minFuzzyLevel Minimum fuzzyness level to be used.  E.g. 1 - 4
     * @param maxFuzzyLevel Maximum fuzzyness level to be used E.g. 2 - 4
     * @param idxSet A comma separated list of indexes which should be utilized for the search. Item order does not matter. Available indexes are: Addr = Address range interpolation, Geo = Geographies, PAD = Point Addresses, POI = Points of interest, Str = Streets, Xstr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchFuzzyAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, String minFuzzyLevel, String maxFuzzyLevel, String idxSet) {
        return getSearchFuzzyWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor, minFuzzyLevel, maxFuzzyLevel, idxSet).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a fuzzy search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param minFuzzyLevel Minimum fuzzyness level to be used.  E.g. 1 - 4
     * @param maxFuzzyLevel Maximum fuzzyness level to be used E.g. 2 - 4
     * @param idxSet A comma separated list of indexes which should be utilized for the search. Item order does not matter. Available indexes are: Addr = Address range interpolation, Geo = Geographies, PAD = Point Addresses, POI = Points of interest, Str = Streets, Xstr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchFuzzyWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, String minFuzzyLevel, String maxFuzzyLevel, String idxSet) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        return service.getSearchFuzzy(format, apiVersion, subscriptionKey, this.client.query(), typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor, minFuzzyLevel, maxFuzzyLevel, idxSet)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchFuzzyDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getSearchFuzzyDelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Searchfuzzy200>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchPOI(String format, String apiVersion, String subscriptionKey) {
        return getSearchPOIWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchPOIAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchPOIWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchPOIAsync(String format, String apiVersion, String subscriptionKey) {
        return getSearchPOIWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchPOIWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        final String typeahead = null;
        final String limit = null;
        final String ofs = null;
        final String countrySet = null;
        final String lat = null;
        final String lon = null;
        final String radius = null;
        final String topLeft = null;
        final String btmRight = null;
        final String language = null;
        final String extendedPostalCodesFor = null;
        return service.getSearchPOI(format, apiVersion, subscriptionKey, this.client.query(), typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchPOIDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchPOI(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor) {
        return getSearchPOIWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor).toBlocking().single().body();
    }

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchPOIAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchPOIWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor), serviceCallback);
    }

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchPOIAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor) {
        return getSearchPOIWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a POI search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchPOIWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        return service.getSearchPOI(format, apiVersion, subscriptionKey, this.client.query(), typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchPOIDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getSearchPOIDelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Searchpoi200>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchPOICategory(String format, String apiVersion, String subscriptionKey) {
        return getSearchPOICategoryWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchPOICategoryAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchPOICategoryWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchPOICategoryAsync(String format, String apiVersion, String subscriptionKey) {
        return getSearchPOICategoryWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchPOICategoryWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        final String typeahead = null;
        final String limit = null;
        final String ofs = null;
        final String countrySet = null;
        final String lat = null;
        final String lon = null;
        final String radius = null;
        final String topLeft = null;
        final String btmRight = null;
        final String language = null;
        final String extendedPostalCodesFor = null;
        return service.getSearchPOICategory(format, apiVersion, subscriptionKey, this.client.query(), typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchPOICategoryDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchPOICategory(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor) {
        return getSearchPOICategoryWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor).toBlocking().single().body();
    }

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchPOICategoryAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchPOICategoryWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor), serviceCallback);
    }

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchPOICategoryAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor) {
        return getSearchPOICategoryWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a POI Category search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchPOICategoryWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        return service.getSearchPOICategory(format, apiVersion, subscriptionKey, this.client.query(), typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchPOICategoryDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getSearchPOICategoryDelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Searchpoicategory200>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchAddress(String format, String apiVersion, String subscriptionKey) {
        return getSearchAddressWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchAddressAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchAddressWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchAddressAsync(String format, String apiVersion, String subscriptionKey) {
        return getSearchAddressWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchAddressWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        final String typeahead = null;
        final String limit = null;
        final String ofs = null;
        final String countrySet = null;
        final String lat = null;
        final String lon = null;
        final String radius = null;
        final String topLeft = null;
        final String btmRight = null;
        final String language = null;
        final String extendedPostalCodesFor = null;
        return service.getSearchAddress(format, apiVersion, subscriptionKey, this.client.query(), typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchAddressDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchAddress(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor) {
        return getSearchAddressWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor).toBlocking().single().body();
    }

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchAddressAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchAddressWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor), serviceCallback);
    }

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchAddressAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor) {
        return getSearchAddressWithServiceResponseAsync(format, apiVersion, subscriptionKey, typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a Address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param typeahead true or false.  If the typeahead flag is set, the query will be interpreted as a partial input and the search will enter�predictive�mode
     * @param limit Maximum number of responses that will be returned.  Max value is 100
     * @param ofs Starting offset of the returned results within the full result set.  Max value is 1900
     * @param countrySet Comma separated string of country codes, e.g. FR, ES. This will limit the search to the specified countries
     * @param lat Latitude where results should be biased.  E.g. 37.337
     * @param lon Longitude where results should be biased.  E.g. -121.89
     * @param radius The radius in meters to for the results to be constrained to the defined area
     * @param topLeft Top left position of the bounding box.  E.g. 37.553,-122.453
     * @param btmRight Bottom right position of the bounding box. E.g. 37.553,-122.453
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchAddressWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String typeahead, String limit, String ofs, String countrySet, String lat, String lon, String radius, String topLeft, String btmRight, String language, String extendedPostalCodesFor) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        return service.getSearchAddress(format, apiVersion, subscriptionKey, this.client.query(), typeahead, limit, ofs, countrySet, lat, lon, radius, topLeft, btmRight, language, extendedPostalCodesFor)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchAddressDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getSearchAddressDelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Searchaddress200>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchAddressReverse(String format, String apiVersion, String subscriptionKey) {
        return getSearchAddressReverseWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchAddressReverseAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchAddressReverseWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchAddressReverseAsync(String format, String apiVersion, String subscriptionKey) {
        return getSearchAddressReverseWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchAddressReverseWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        final String spatialKeys = null;
        final String returnSpeedLimit = null;
        final String heading = null;
        final String radius = null;
        final String number = null;
        final String returnRoadUse = null;
        final String roadUse = null;
        return service.getSearchAddressReverse(format, apiVersion, subscriptionKey, this.client.query(), spatialKeys, returnSpeedLimit, heading, radius, number, returnRoadUse, roadUse)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchAddressReverseDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param returnSpeedLimit true or false string.  To enable return of the posted speedlimit
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param number If a number is sent in along with the request, the response may include the side of the street (Left/Right) and also an offset position for that number
     * @param returnRoadUse true or false string.  To enable return of the road use array for reversegeocodes at street level
     * @param roadUse To restrict reversegeocodes to a certain type of roaduse. The road use array for reversegeocodes can be one or more of LimitedAccess, Arterial, Terminal, Ramp, Rotary, LocalStreet
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchAddressReverse(String format, String apiVersion, String subscriptionKey, String spatialKeys, String returnSpeedLimit, String heading, String radius, String number, String returnRoadUse, String roadUse) {
        return getSearchAddressReverseWithServiceResponseAsync(format, apiVersion, subscriptionKey, spatialKeys, returnSpeedLimit, heading, radius, number, returnRoadUse, roadUse).toBlocking().single().body();
    }

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param returnSpeedLimit true or false string.  To enable return of the posted speedlimit
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param number If a number is sent in along with the request, the response may include the side of the street (Left/Right) and also an offset position for that number
     * @param returnRoadUse true or false string.  To enable return of the road use array for reversegeocodes at street level
     * @param roadUse To restrict reversegeocodes to a certain type of roaduse. The road use array for reversegeocodes can be one or more of LimitedAccess, Arterial, Terminal, Ramp, Rotary, LocalStreet
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchAddressReverseAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String returnSpeedLimit, String heading, String radius, String number, String returnRoadUse, String roadUse, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchAddressReverseWithServiceResponseAsync(format, apiVersion, subscriptionKey, spatialKeys, returnSpeedLimit, heading, radius, number, returnRoadUse, roadUse), serviceCallback);
    }

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param returnSpeedLimit true or false string.  To enable return of the posted speedlimit
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param number If a number is sent in along with the request, the response may include the side of the street (Left/Right) and also an offset position for that number
     * @param returnRoadUse true or false string.  To enable return of the road use array for reversegeocodes at street level
     * @param roadUse To restrict reversegeocodes to a certain type of roaduse. The road use array for reversegeocodes can be one or more of LimitedAccess, Arterial, Terminal, Ramp, Rotary, LocalStreet
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchAddressReverseAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String returnSpeedLimit, String heading, String radius, String number, String returnRoadUse, String roadUse) {
        return getSearchAddressReverseWithServiceResponseAsync(format, apiVersion, subscriptionKey, spatialKeys, returnSpeedLimit, heading, radius, number, returnRoadUse, roadUse).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a Reverse address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param returnSpeedLimit true or false string.  To enable return of the posted speedlimit
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param number If a number is sent in along with the request, the response may include the side of the street (Left/Right) and also an offset position for that number
     * @param returnRoadUse true or false string.  To enable return of the road use array for reversegeocodes at street level
     * @param roadUse To restrict reversegeocodes to a certain type of roaduse. The road use array for reversegeocodes can be one or more of LimitedAccess, Arterial, Terminal, Ramp, Rotary, LocalStreet
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchAddressReverseWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String returnSpeedLimit, String heading, String radius, String number, String returnRoadUse, String roadUse) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        return service.getSearchAddressReverse(format, apiVersion, subscriptionKey, this.client.query(), spatialKeys, returnSpeedLimit, heading, radius, number, returnRoadUse, roadUse)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchAddressReverseDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getSearchAddressReverseDelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Searchaddressreverse200>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchAddressReverseCrossStreet(String format, String apiVersion, String subscriptionKey) {
        return getSearchAddressReverseCrossStreetWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchAddressReverseCrossStreetAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchAddressReverseCrossStreetWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchAddressReverseCrossStreetAsync(String format, String apiVersion, String subscriptionKey) {
        return getSearchAddressReverseCrossStreetWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchAddressReverseCrossStreetWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        final String spatialKeys = null;
        final String heading = null;
        final String radius = null;
        final String language = null;
        return service.getSearchAddressReverseCrossStreet(format, apiVersion, subscriptionKey, this.client.query(), spatialKeys, heading, radius, language)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchAddressReverseCrossStreetDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchAddressReverseCrossStreet(String format, String apiVersion, String subscriptionKey, String spatialKeys, String heading, String radius, String language) {
        return getSearchAddressReverseCrossStreetWithServiceResponseAsync(format, apiVersion, subscriptionKey, spatialKeys, heading, radius, language).toBlocking().single().body();
    }

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchAddressReverseCrossStreetAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String heading, String radius, String language, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchAddressReverseCrossStreetWithServiceResponseAsync(format, apiVersion, subscriptionKey, spatialKeys, heading, radius, language), serviceCallback);
    }

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchAddressReverseCrossStreetAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String heading, String radius, String language) {
        return getSearchAddressReverseCrossStreetWithServiceResponseAsync(format, apiVersion, subscriptionKey, spatialKeys, heading, radius, language).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a Cross Street address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param spatialKeys true or false string.  If the spatialKeys flag is set, the response will also contain the deCarta proprietary geo-spatial key information for a specified location
     * @param heading The directional heading of the vehicle in degrees, for travel along a segment of roadway. 0 is North, 90 is East and so on, values range from -360 to 360. The precision can include upto one decimal place
     * @param radius The maximum distance in meters from the specified position for the reversegeocode to consider.  E.g. 10000 (10km)
     * @param language Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchAddressReverseCrossStreetWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String spatialKeys, String heading, String radius, String language) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        return service.getSearchAddressReverseCrossStreet(format, apiVersion, subscriptionKey, this.client.query(), spatialKeys, heading, radius, language)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchAddressReverseCrossStreetDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getSearchAddressReverseCrossStreetDelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Searchaddressreversecrossstreet200>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchAddressStructured(String format, String apiVersion, String subscriptionKey, String countryCode) {
        return getSearchAddressStructuredWithServiceResponseAsync(format, apiVersion, subscriptionKey, countryCode).toBlocking().single().body();
    }

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchAddressStructuredAsync(String format, String apiVersion, String subscriptionKey, String countryCode, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchAddressStructuredWithServiceResponseAsync(format, apiVersion, subscriptionKey, countryCode), serviceCallback);
    }

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchAddressStructuredAsync(String format, String apiVersion, String subscriptionKey, String countryCode) {
        return getSearchAddressStructuredWithServiceResponseAsync(format, apiVersion, subscriptionKey, countryCode).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchAddressStructuredWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String countryCode) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (countryCode == null) {
            throw new IllegalArgumentException("Parameter countryCode is required and cannot be null.");
        }
        final String limit = null;
        final String ofs = null;
        final String streetNumber = null;
        final String streetName = null;
        final String crossStreet = null;
        final String municipality = null;
        final String municipalitySubdivision = null;
        final String countryTertiarySubdivision = null;
        final String countrySecondarySubdivision = null;
        final String countrySubdivision = null;
        final String postalCode = null;
        final String extendedPostalCodesFor = null;
        return service.getSearchAddressStructured(format, apiVersion, subscriptionKey, countryCode, limit, ofs, streetNumber, streetName, crossStreet, municipality, municipalitySubdivision, countryTertiarySubdivision, countrySecondarySubdivision, countrySubdivision, postalCode, extendedPostalCodesFor)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchAddressStructuredDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @param limit Maximum number of responses that will be returned
     * @param ofs Starting offset of the returned results within the full result set
     * @param streetNumber The street number portion of an address
     * @param streetName The street name portion of an address
     * @param crossStreet The cross street name for the structured address
     * @param municipality The municipality portion of an address
     * @param municipalitySubdivision The municipality subdivision (sub/super city) for the structured address
     * @param countryTertiarySubdivision The named area for the structured address
     * @param countrySecondarySubdivision The county for the structured address
     * @param countrySubdivision The country subdividion portion of an address
     * @param postalCode The postal code portion of an address
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getSearchAddressStructured(String format, String apiVersion, String subscriptionKey, String countryCode, String limit, String ofs, String streetNumber, String streetName, String crossStreet, String municipality, String municipalitySubdivision, String countryTertiarySubdivision, String countrySecondarySubdivision, String countrySubdivision, String postalCode, String extendedPostalCodesFor) {
        return getSearchAddressStructuredWithServiceResponseAsync(format, apiVersion, subscriptionKey, countryCode, limit, ofs, streetNumber, streetName, crossStreet, municipality, municipalitySubdivision, countryTertiarySubdivision, countrySecondarySubdivision, countrySubdivision, postalCode, extendedPostalCodesFor).toBlocking().single().body();
    }

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @param limit Maximum number of responses that will be returned
     * @param ofs Starting offset of the returned results within the full result set
     * @param streetNumber The street number portion of an address
     * @param streetName The street name portion of an address
     * @param crossStreet The cross street name for the structured address
     * @param municipality The municipality portion of an address
     * @param municipalitySubdivision The municipality subdivision (sub/super city) for the structured address
     * @param countryTertiarySubdivision The named area for the structured address
     * @param countrySecondarySubdivision The county for the structured address
     * @param countrySubdivision The country subdividion portion of an address
     * @param postalCode The postal code portion of an address
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getSearchAddressStructuredAsync(String format, String apiVersion, String subscriptionKey, String countryCode, String limit, String ofs, String streetNumber, String streetName, String crossStreet, String municipality, String municipalitySubdivision, String countryTertiarySubdivision, String countrySecondarySubdivision, String countrySubdivision, String postalCode, String extendedPostalCodesFor, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getSearchAddressStructuredWithServiceResponseAsync(format, apiVersion, subscriptionKey, countryCode, limit, ofs, streetNumber, streetName, crossStreet, municipality, municipalitySubdivision, countryTertiarySubdivision, countrySecondarySubdivision, countrySubdivision, postalCode, extendedPostalCodesFor), serviceCallback);
    }

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @param limit Maximum number of responses that will be returned
     * @param ofs Starting offset of the returned results within the full result set
     * @param streetNumber The street number portion of an address
     * @param streetName The street name portion of an address
     * @param crossStreet The cross street name for the structured address
     * @param municipality The municipality portion of an address
     * @param municipalitySubdivision The municipality subdivision (sub/super city) for the structured address
     * @param countryTertiarySubdivision The named area for the structured address
     * @param countrySecondarySubdivision The county for the structured address
     * @param countrySubdivision The country subdividion portion of an address
     * @param postalCode The postal code portion of an address
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getSearchAddressStructuredAsync(String format, String apiVersion, String subscriptionKey, String countryCode, String limit, String ofs, String streetNumber, String streetName, String crossStreet, String municipality, String municipalitySubdivision, String countryTertiarySubdivision, String countrySecondarySubdivision, String countrySubdivision, String postalCode, String extendedPostalCodesFor) {
        return getSearchAddressStructuredWithServiceResponseAsync(format, apiVersion, subscriptionKey, countryCode, limit, ofs, streetNumber, streetName, crossStreet, municipality, municipalitySubdivision, countryTertiarySubdivision, countrySecondarySubdivision, countrySubdivision, postalCode, extendedPostalCodesFor).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the search results from a Structured address search.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param countryCode The 2 or 3 letter country code portion of an address.  E.g. US
     * @param limit Maximum number of responses that will be returned
     * @param ofs Starting offset of the returned results within the full result set
     * @param streetNumber The street number portion of an address
     * @param streetName The street name portion of an address
     * @param crossStreet The cross street name for the structured address
     * @param municipality The municipality portion of an address
     * @param municipalitySubdivision The municipality subdivision (sub/super city) for the structured address
     * @param countryTertiarySubdivision The named area for the structured address
     * @param countrySecondarySubdivision The county for the structured address
     * @param countrySubdivision The country subdividion portion of an address
     * @param postalCode The postal code portion of an address
     * @param extendedPostalCodesFor Indexes for which extended postal codes should be included in the results. Available indexes are: Addr = Address ranges, Geo = Geographies, PAD = Point Addresses, POI = Points of Interest, Str = Streets, XStr = Cross Streets (intersections)
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getSearchAddressStructuredWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey, String countryCode, String limit, String ofs, String streetNumber, String streetName, String crossStreet, String municipality, String municipalitySubdivision, String countryTertiarySubdivision, String countrySecondarySubdivision, String countrySubdivision, String postalCode, String extendedPostalCodesFor) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (countryCode == null) {
            throw new IllegalArgumentException("Parameter countryCode is required and cannot be null.");
        }
        return service.getSearchAddressStructured(format, apiVersion, subscriptionKey, countryCode, limit, ofs, streetNumber, streetName, crossStreet, municipality, municipalitySubdivision, countryTertiarySubdivision, countrySecondarySubdivision, countrySubdivision, postalCode, extendedPostalCodesFor)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getSearchAddressStructuredDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getSearchAddressStructuredDelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Searchaddressstructured200>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

}
