/**
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package lbs.implementation;

import retrofit2.Retrofit;
import lbs.Timezones;
import lbs.models.Error;
import lbs.models.Timezonebycoordinates200;
import lbs.models.Timezonebyid200;
import lbs.models.Timezoneianaversion200;
import com.google.common.reflect.TypeToken;
import com.microsoft.rest.RestException;
import com.microsoft.rest.ServiceCallback;
import com.microsoft.rest.ServiceFuture;
import com.microsoft.rest.ServiceResponse;
import java.io.IOException;
import okhttp3.ResponseBody;
import retrofit2.http.GET;
import retrofit2.http.Headers;
import retrofit2.http.Path;
import retrofit2.http.Query;
import retrofit2.Response;
import rx.functions.Func1;
import rx.Observable;

/**
 * An instance of this class provides access to all the operations defined
 * in Timezones.
 */
public class TimezonesImpl implements Timezones {
    /** The Retrofit service to perform REST calls. */
    private TimezonesService service;
    /** The service client containing this operation class. */
    private AzureLocationBasedServicesImpl client;

    /**
     * Initializes an instance of Timezones.
     *
     * @param retrofit the Retrofit instance built from a Retrofit Builder.
     * @param client the instance of the service client containing this operation class.
     */
    public TimezonesImpl(Retrofit retrofit, AzureLocationBasedServicesImpl client) {
        this.service = retrofit.create(TimezonesService.class);
        this.client = client;
    }

    /**
     * The interface defining all the services for Timezones to be
     * used by Retrofit to perform actually REST calls.
     */
    interface TimezonesService {
        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Timezones getTimezoneByID" })
        @GET("timezone/byId/{format}")
        Observable<Response<ResponseBody>> getTimezoneByID(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey, @Query("query") String query);

        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Timezones getTimezoneByCoordinates" })
        @GET("timezone/byCoordinates/{format}")
        Observable<Response<ResponseBody>> getTimezoneByCoordinates(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey, @Query("query") String query);

        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Timezones getTimezoneEnumWindows" })
        @GET("timezone/enumWindows/{format}")
        Observable<Response<ResponseBody>> getTimezoneEnumWindows(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey);

        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Timezones getTimezoneEnumIANA" })
        @GET("timezone/enumIana/{format}")
        Observable<Response<ResponseBody>> getTimezoneEnumIANA(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey);

        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Timezones getTimezoneIANAVersion" })
        @GET("timezone/ianaVersion/{format}")
        Observable<Response<ResponseBody>> getTimezoneIANAVersion(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey);

        @Headers({ "Content-Type: application/json; charset=utf-8", "x-ms-logging-context: .Timezones getTimezoneWindowsToIANA" })
        @GET("timezone/windowsToIana/{format}")
        Observable<Response<ResponseBody>> getTimezoneWindowsToIANA(@Path("format") String format, @Query("api-version") String apiVersion, @Query("subscription-key") String subscriptionKey, @Query("query") String query);

    }

    /**
     * Returns the timezone info for an IANA ID.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getTimezoneByID(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneByIDWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Returns the timezone info for an IANA ID.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getTimezoneByIDAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getTimezoneByIDWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Returns the timezone info for an IANA ID.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getTimezoneByIDAsync(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneByIDWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the timezone info for an IANA ID.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getTimezoneByIDWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        return service.getTimezoneByID(format, apiVersion, subscriptionKey, this.client.query())
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getTimezoneByIDDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getTimezoneByIDDelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Timezonebyid200>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

    /**
     * Returns the timezone info for a coordinates.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getTimezoneByCoordinates(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneByCoordinatesWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Returns the timezone info for a coordinates.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getTimezoneByCoordinatesAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getTimezoneByCoordinatesWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Returns the timezone info for a coordinates.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getTimezoneByCoordinatesAsync(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneByCoordinatesWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the timezone info for a coordinates.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getTimezoneByCoordinatesWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        return service.getTimezoneByCoordinates(format, apiVersion, subscriptionKey, this.client.query())
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getTimezoneByCoordinatesDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getTimezoneByCoordinatesDelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Timezonebycoordinates200>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

    /**
     * Returns all the Windows timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getTimezoneEnumWindows(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneEnumWindowsWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Returns all the Windows timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getTimezoneEnumWindowsAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getTimezoneEnumWindowsWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Returns all the Windows timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getTimezoneEnumWindowsAsync(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneEnumWindowsWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns all the Windows timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getTimezoneEnumWindowsWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        return service.getTimezoneEnumWindows(format, apiVersion, subscriptionKey)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getTimezoneEnumWindowsDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getTimezoneEnumWindowsDelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Object>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

    /**
     * Returns all the IANA timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getTimezoneEnumIANA(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneEnumIANAWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Returns all the IANA timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getTimezoneEnumIANAAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getTimezoneEnumIANAWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Returns all the IANA timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getTimezoneEnumIANAAsync(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneEnumIANAWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns all the IANA timezones.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getTimezoneEnumIANAWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        return service.getTimezoneEnumIANA(format, apiVersion, subscriptionKey)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getTimezoneEnumIANADelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getTimezoneEnumIANADelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Object>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

    /**
     * Returns the current IANA version.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getTimezoneIANAVersion(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneIANAVersionWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Returns the current IANA version.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getTimezoneIANAVersionAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getTimezoneIANAVersionWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Returns the current IANA version.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getTimezoneIANAVersionAsync(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneIANAVersionWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Returns the current IANA version.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getTimezoneIANAVersionWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        return service.getTimezoneIANAVersion(format, apiVersion, subscriptionKey)
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getTimezoneIANAVersionDelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getTimezoneIANAVersionDelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Timezoneianaversion200>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

    /**
     * Get the IANA timezone from a Windows timezone.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @throws RestException thrown if the request is rejected by server
     * @throws RuntimeException all other wrapped checked exceptions if the request fails to be sent
     * @return the Object object if successful.
     */
    public Object getTimezoneWindowsToIANA(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneWindowsToIANAWithServiceResponseAsync(format, apiVersion, subscriptionKey).toBlocking().single().body();
    }

    /**
     * Get the IANA timezone from a Windows timezone.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the {@link ServiceFuture} object
     */
    public ServiceFuture<Object> getTimezoneWindowsToIANAAsync(String format, String apiVersion, String subscriptionKey, final ServiceCallback<Object> serviceCallback) {
        return ServiceFuture.fromResponse(getTimezoneWindowsToIANAWithServiceResponseAsync(format, apiVersion, subscriptionKey), serviceCallback);
    }

    /**
     * Get the IANA timezone from a Windows timezone.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<Object> getTimezoneWindowsToIANAAsync(String format, String apiVersion, String subscriptionKey) {
        return getTimezoneWindowsToIANAWithServiceResponseAsync(format, apiVersion, subscriptionKey).map(new Func1<ServiceResponse<Object>, Object>() {
            @Override
            public Object call(ServiceResponse<Object> response) {
                return response.body();
            }
        });
    }

    /**
     * Get the IANA timezone from a Windows timezone.
     *
     * @param format Desired format of the response. Possible values include: 'json', 'png', 'pbf'
     * @param apiVersion Version number of Azure LBS API.  Current version is 1.0
     * @param subscriptionKey Azure LBS subscription key
     * @throws IllegalArgumentException thrown if parameters fail the validation
     * @return the observable to the Object object
     */
    public Observable<ServiceResponse<Object>> getTimezoneWindowsToIANAWithServiceResponseAsync(String format, String apiVersion, String subscriptionKey) {
        if (format == null) {
            throw new IllegalArgumentException("Parameter format is required and cannot be null.");
        }
        if (apiVersion == null) {
            throw new IllegalArgumentException("Parameter apiVersion is required and cannot be null.");
        }
        if (subscriptionKey == null) {
            throw new IllegalArgumentException("Parameter subscriptionKey is required and cannot be null.");
        }
        if (this.client.query() == null) {
            throw new IllegalArgumentException("Parameter this.client.query() is required and cannot be null.");
        }
        return service.getTimezoneWindowsToIANA(format, apiVersion, subscriptionKey, this.client.query())
            .flatMap(new Func1<Response<ResponseBody>, Observable<ServiceResponse<Object>>>() {
                @Override
                public Observable<ServiceResponse<Object>> call(Response<ResponseBody> response) {
                    try {
                        ServiceResponse<Object> clientResponse = getTimezoneWindowsToIANADelegate(response);
                        return Observable.just(clientResponse);
                    } catch (Throwable t) {
                        return Observable.error(t);
                    }
                }
            });
    }

    private ServiceResponse<Object> getTimezoneWindowsToIANADelegate(Response<ResponseBody> response) throws RestException, IOException, IllegalArgumentException {
        return this.client.restClient().responseBuilderFactory().<Object, RestException>newInstance(this.client.serializerAdapter())
                .register(200, new TypeToken<Object>() { }.getType())
                .register(400, new TypeToken<Error>() { }.getType())
                .register(401, new TypeToken<Error>() { }.getType())
                .register(403, new TypeToken<Error>() { }.getType())
                .register(404, new TypeToken<Error>() { }.getType())
                .register(500, new TypeToken<Error>() { }.getType())
                .build(response);
    }

}
