import { Options } from "../../helpers/Options";
import { ControlStyle } from "../ControlStyle";

/**
 * The options for a CompassControl object.
 * @module Object Definitions
 */
export class CompassControlOptions extends Options {

    /**
     * The angle that the map will rotate with each click of the control.
     */
    public rotationDegreesDelta: number = 15;

    /**
     * The style of the control.
     */
    public style: ControlStyle = ControlStyle.light;
}
