import { Map } from "../../map/Map";
import { ControlPosition } from "../../map/options/ControlOptions";
import { Control } from "../Control";

/**
 * @private
 */
export class CopyrightControl implements Control {
    private container: HTMLElement;
    private copyrightMessage: string;

    constructor(copyrightMessage: string = "") {
        this.copyrightMessage = copyrightMessage;
    }

    public onAdd(map: Map): HTMLElement {
        this.container = document.createElement("div");
        this.container.className = "map-copyright";
        this.container.innerText = this.copyrightMessage;
        return this.container;
    }

    public onRemove() {
        this.container.remove();
    }

    public update(copyright: string) {
        this.copyrightMessage = copyright;
        this.container.innerText = this.copyrightMessage;
    }
}
