import { Options } from "../../helpers/Options";
import { ControlStyle } from "../ControlStyle";

/**
 * The options for a PitchControl object.
 * @module Object Definitions
 */
export class PitchControlOptions extends Options {

    /**
     * The angle that the map will tilt with each click of the control.
     */
    public pitchDegreesDelta: number = 10;

    /**
     * The style of the control.
     */
    public style: ControlStyle = ControlStyle.light;
}
