import { Options } from "../../helpers/Options";
import { ControlStyle } from "../ControlStyle";

/**
 * The options for a ZoomControl object.
 * @module Object Definitions
 */
export class ZoomControlOptions extends Options {

    /**
     * The extent to which the map will zoom with each click of the control.
     */
    public zoomDelta: number = 1;

    /**
     * The style of the control.
     */
    public style: ControlStyle = ControlStyle.light;
}
