/**
 * A GeoJSON Position object - an array that specifies the longitude and latitude of a location. The
 * full description is detailed in [RFC 7946]{@link https://tools.ietf.org/html/rfc7946#section-3.1.1}.
 * @module atlas.data
 */
export class Position extends Array<number> {

    /**
     * Constructs a Position.
     * @param longitude The position's longitude.
     * @param latitude The position's latitude.
     * @param elevation The position's elevation.
     */
    constructor(longitude: number, latitude: number, elevation?: number) {
        if (elevation) {
            super(longitude, latitude, elevation);
        } else {
            super(longitude, latitude);
        }
    }

}
