// Polyfills
import { Promise } from "es6-promise";
import "whatwg-fetch";
import { env, majorVersion, minorVersion } from "../variables.json";

window["Promise"] = window["Promise"] || Promise;

// Set the mapbox Right-To-Left Text Plugin
import * as mapboxgl from "mapbox-gl";

mapboxgl.setRTLTextPlugin(`https://${env.staticAssetsDomain}/sdk/js/mapbox-gl-rtl-text.js?api-version=${majorVersion}.${minorVersion}`, (e) => {
    // If right to left text plugin fails to load, ignore error and continue
});

// Build the structure of the SDK
import * as control from "./controls";
import * as data from "./data";
import { Map } from "./map/Map";
import { Popup } from "./map/Popup";

export {
    data,
    control,
    Map,
    Popup
};
