/**
 * Individual properties that can be specified for a circle feature.
 * @module Object Definitions
 */
export interface CircleProperties {
    /**
     * The fill color of the circle.
     */
    color?: string;

    /**
     * The outline color of the circle.
     */
    outlineColor?: string;

    /**
     * The radius in pixels of the circle.
     */
    radius?: number;

    /**
     * The outline stroke width of the circle.
     */
    outlineWidth?: number;

    /**
     * Additional properties of the entity.
     */
    [others: string]: any;
}
