/**
 * Individual properties that can be specified for a linstring feature.
 * @module Object Definitions
 */
export interface LinestringProperties {
    /**
     * The color of the linestring.
     */
    color?: string;

    /**
     * The width of the linestring.
     */
    width?: number;

    /**
     * Additional properties of the entity.
     */
    [others: string]: any;
}
