/**
 * Individual properties that can be specified for a point feature.
 * @module Object Definitions
 */
export interface PinProperties {
    /**
     * The icon to display for the point.
     */
    icon?: "pin-darkblue" | "pin-blue" | "pin-red" | "pin-round-darkblue" | "pin-round-blue" | "pin-round-red"
    | "none" | string;

    /**
     * The title to display for the point.
     */
    title?: string;

    /**
     * Additional properties of the entity.
     */
    [others: string]: any;
}
