/**
 * Individual properties that can be specified for a polygon feature.
 * @module Object Definitions
 */
export interface PolygonProperties {
    /**
     * The fill color of the polygon.
     */
    color?: string;

    /**
     * The outline color of the polygon.
     */
    outlineColor?: string;

    /**
     * Additional properties of the entity.
     */
    [others: string]: any;
}
