import { Options } from "../../helpers/Options";

/**
 * The options for animating changes to the map control's camera.
 * @module Object Definitions
 */
export class AnimationOptions extends Options {
    /**
     * The duration of the animation in milliseconds.
     */
    public duration?: number = 1000;

    /**
     * The type of animation.
     * <p>"jump" is an immediate change.</p>
     * <p>"ease" is a gradual change of the camera's settings.</p>
     * <p>"fly" is a gradual change of the camera's settings following an arc resembling flight.</p>
     */
    public type?: "jump" | "ease" | "fly" = "jump";
}
