import { BoundingBox } from "../../data";
import { Options } from "../../helpers/Options";

/**
 * The options for setting the bounds of the map control's camera.
 * @module Object Definitions
 */
export class CameraBoundsOptions extends Options {
    /**
     * The bounds of the map control's camera.
     */
    public bounds?: BoundingBox = [-180, -89, 180, 90];

    /**
     * Padding in pixels for the given bounds. Either specify a number for the padding of all sides of the map or
     * specify each side as an array of [top, right, bottom, left].
     */
    public padding?: number | number[] = 0;
}
