import { Position } from "../../data";
import { Options } from "../../helpers/Options";

/**
 * The options for setting the map control's camera.
 * @module Object Definitions
 */
export class CameraOptions extends Options {
    /**
     * The zoom of the camera.
     */
    public zoom?: number = 1;

    /**
     * The center of the camera.
     */
    public center?: Position = new Position(0, 0);

    /**
     * The bearing of the camera.
     */
    public bearing?: number = 0;

    /**
     * The pitch of the camera.
     */
    public pitch?: number = 0;

    /**
     * The minimum possible zoom of the camera.
     */
    public minZoom?: number = 1;

    /**
     * The maximum possible zoom of the camera.
     */
    public maxZoom?: number = 20;
}
