import { CircleProperties } from "../data_properties/CircleProperties";
import { LayerOptions } from "./LayerOptions";

/**
 * The options for a circle layer.
 * @module Object Definitions
 */
export class CircleLayerOptions extends LayerOptions implements CircleProperties {
    /**
     * The fill color of the circles for the layer. Is used as the default if a fill color is not specified for a
     * circle.
     */
    public color?: string = "rgba(0,0,0,.5)";

    /**
     * The outline color of the circles for the layer. Is used as the default if an outline color is not specified for
     * a circle.
     */
    public outlineColor?: string = "#000";

    /**
     * The radius in pixels of the circles for the layer. Is used as the default if a radius is not specified for a
     * circle.
     */
    public radius?: number = 1;

    /**
     * The outline stroke width of the circles for the layer. Is used as the default if outline width is not specified
     * for a circle.
     */
    public outlineWidth?: number = 5;

    /**
     * The name of the layer.
     */
    public name?: string = "default-circles";
}
