import { Options } from "../../helpers/Options";

/**
 * Positions where the control can be placed on the map.
 * @module Object Definitions
 */
export enum ControlPosition {
    TopLeft = "top-left",
    TopRight = "top-right",
    BottomLeft = "bottom-left",
    BottomRight = "bottom-right",
    NonFixed = "non-fixed"
}

/**
 * The options for adding a control to the map.
 * @module Object Definitions
 */
export class ControlOptions extends Options {

    /**
     * The position the control will be placed on the map. If not specified, the control will be located at the
     * default position it defines.
     */
    public position?: ControlPosition = ControlPosition.NonFixed;

}
