import { PolygonProperties } from "../data_properties/PolygonProperties";
import { LayerOptions } from "./LayerOptions";

/**
 * The options for a polygon layer.
 * @module Object Definitions
 */
export class PolygonLayerOptions extends LayerOptions implements PolygonProperties {
    /**
     * The fill color of the polygons for the layer. Is used as the default if a fill color is not specified for a
     * polygon.
     */
    public color?: string = "rgba(0,0,0,.5)";

    /**
     * The outline color of the polygons for the layer. Is used as the default if an outline color is not specified for
     * a polygon.
     */
    public outlineColor?: string = "#000";

    /**
     * The name of the layer.
     */
    public name?: string = "default-polygons";
}
