import { Position } from "../../data/Position";
import { Options } from "../../helpers/Options";

/**
 * The options for a popup.
 * @module Object Definitions
 */
export class PopupOptions extends Options {
    /**
     * The position on the map where the popup should be anchored.
     */
    public position?: Position = new Position(0, 0);

    /**
     * The content to display within the popup.
     */
    public content?: HTMLElement = document.createElement("span");

    /**
     * An array of [pixelsRight, pixelsDown] for how many pixels to the right and down the anchor of the popup should be
     * offset. Negative numbers can be used to offset the popup left and up.
     */
    public pixelOffset?: number[] = [0, 0];
}
