import { Options } from "../../helpers/Options";

/**
 * The options for the map's style.
 * @module Object Definitions
 */
export class StyleOptions extends Options {
    /**
     * The style of the map tiles.
     */
    public style?: string = "road";

    /**
     * The language of the map labels.
     */
    public language?: string = "NGT";

    /**
     * The geopolitical view of the map.
     * <p>Unified: The unified view of the world.</p>
     */
    public view?: "Unified" = "Unified";
}
