import { Options } from "../../helpers/Options";

/**
 * The options for setting traffic on the map.
 * @module Object Definitions
 */
export class TrafficOptions extends Options {
    /**
     * The type of traffic flow to display:
     * <p>"none" is to display no traffic flow data</p>
     * <p>"relative" is the speed of the road relative to free-flow</p>
     * <p>"absolute" is the absolute speed of the road</p>
     * <p>"relative-delay" displays relative speed only where they differ from free-flow;
     * false to stop displaying the traffic flow.</p>
     */
    public flow?: "none" | "relative" | "absolute" | "relative-delay" = "none";

    /**
     * Whether to display incidents on the map.
     */
    public incidents?: boolean = false;
}
