import { Options } from "../../helpers/Options";
import { UUID } from "../../helpers/UUID";

/**
 * Global properties used in all atlas service requests.
 * @module Object Definitions
 */
export class ServiceOptions extends Options {

  /**
   * The customer subscription key used to authorize requests.
   */
  public "subscription-key": string = undefined;

  /**
   * The session id to pass with requests.
   */
  public "session-id"?: string = UUID.generate();

  /**
   * Disable telemetry collection
   */
  public "disable-telemetry": boolean = false;

}
