/*
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

import * as msRest from "ms-rest-js";
import * as Models from "./models";
import * as Mappers from "./models/mappers";
import * as operations from "./operations";
import { MapsClientContext } from "./mapsClientContext";

class MapsClient extends MapsClientContext {
  serializer = new msRest.Serializer(Mappers);

  // Operation groups
  search: operations.Search;
  route: operations.Route;

  /**
   * @class
   * Initializes a new instance of the MapsClient class.
   * @constructor
   *
   * @param {string} [baseUri] - The base URI of the service.
   *
   * @param {object} [options] - The parameter options
   *
   * @param {Array} [options.filters] - Filters to be added to the request pipeline
   *
   * @param {object} [options.requestOptions] - The request options. Detailed info can be found at
   * {@link https://github.github.io/fetch/#Request Options doc}
   *
   * @param {boolean} [options.noRetryPolicy] - If set to true, turn off default retry policy
   *
   * @param {string} [options.apiVersion] - Version number of Azure Maps API. Current version is 1.0
   *
   * @param {routeInstructionsType} [options.instructionsType] - If specified, guidance instructions will be returned. Note that the instructionsType parameter cannot be used in conjunction with routeRepresentation=none. Possible values include: 'coded', 'text', 'tagged'
   *
   */
  constructor(subscriptionKey: string, baseUri?: string, options?: Models.MapsClientOptions) {
    super(subscriptionKey, baseUri, options);
    this.search = new operations.Search(this);
    this.route = new operations.Route(this);
  }
}

export { MapsClient, Models as MapsModels, Mappers as MapsMappers };
