/*
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

import * as msRest from "ms-rest-js";
import * as Models from "./models";

const packageName = "";
const packageVersion = "";

export class MapsClientContext extends msRest.ServiceClient {
  subscriptionKey: string;
  apiVersion?: string;
  instructionsType?: Models.RouteInstructionsType;
  baseUri: string;

  /**
   * @class
   * Initializes a new instance of the MapsClientContext class.
   * @constructor
   *
   * @param {string} subscriptionKey - Azure Maps subscription key
   *
   * @param {string} [baseUri] - The base URI of the service.
   *
   * @param {object} [options] - The parameter options
   *
   * @param {Array} [options.filters] - Filters to be added to the request pipeline
   *
   * @param {object} [options.requestOptions] - The request options. Detailed info can be found at
   * {@link https://github.github.io/fetch/#Request Options doc}
   *
   * @param {boolean} [options.noRetryPolicy] - If set to true, turn off default retry policy
   *
   * @param {string} [options.apiVersion] - Version number of Azure Maps API. Current version is 1.0
   *
   * @param {routeInstructionsType} [options.instructionsType] - If specified, guidance instructions will be returned. Note that the instructionsType parameter cannot be used in conjunction with routeRepresentation=none. Possible values include: 'coded', 'text', 'tagged'
   *
   */
  constructor(subscriptionKey: string, baseUri?: string, options?: Models.MapsClientOptions) {
    if (subscriptionKey === null || subscriptionKey === undefined) {
      throw new Error('\'subscriptionKey\' cannot be null.');
    }

    if (!options) {
      options = {};
    }

    super(undefined, options);

    this.apiVersion = '1.0';
    this.baseUri = baseUri as string;
    if (!this.baseUri) {
      this.baseUri = "https://atlas.microsoft.com";
    }
    this.subscriptionKey = subscriptionKey;

    this.addUserAgentInfo(`${packageName}/${packageVersion}`);
    if(options.apiVersion !== null && options.apiVersion !== undefined) {
      this.apiVersion = options.apiVersion;
    }
    if(options.instructionsType !== null && options.instructionsType !== undefined) {
      this.instructionsType = options.instructionsType;
    }
  }
}
