/*
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

import { ServiceClientOptions } from "ms-rest-js";
import * as msRest from "ms-rest-js";


/**
 * @interface
 * An interface representing ErrorModel.
 * This object is returned when an error occurs in the Maps API
 *
 */
export interface ErrorModel {
  /**
   * @member {string} [code] The HTTP status code.
   */
  readonly code?: string;
  /**
   * @member {string} [message] If available, a human readable description of
   * the error.
   */
  readonly message?: string;
}

/**
 * @interface
 * An interface representing ErrorResponse.
 * This response object is returned when an error occurs in the Maps API
 *
 */
export interface ErrorResponse {
  /**
   * @member {ErrorModel} [error]
   */
  error?: ErrorModel;
}

/**
 * @interface
 * An interface representing Geometry.
 * This represents the geometry for one or more geographical features (parks,
 * state boundary etc.) and should be a `GeoJSON` compliant type. Please refer
 * to [RFC 7946](https://tools.ietf.org/html/rfc7946) for details.
 *
 */
export interface Geometry {
  /**
   * @member {string} type Polymorphic Discriminator
   */
  type: string;
}

/**
 * @interface
 * An interface representing SearchPolygonResult.
 */
export interface SearchPolygonResult {
  /**
   * @member {string} [providerID] ID of the returned entity
   */
  readonly providerID?: string;
  /**
   * @member {string} [error] Reason for the failure to obtain data for this
   * provider.
   */
  readonly error?: string;
  /**
   * @member {Geometry} [geometryData] Geometry data in GeoJSON format. Please
   * refer to [RFC 7946](https://tools.ietf.org/html/rfc7946) for details.
   * Present only if "error" is not present.
   */
  geometryData?: Geometry;
}

/**
 * @interface
 * An interface representing SearchPolygonResponse.
 * This object is returned from a successful Search Polygon call
 *
 */
export interface SearchPolygonResponse {
  /**
   * @member {SearchPolygonResult[]} [additionalData] Results array
   */
  readonly additionalData?: SearchPolygonResult[];
}

/**
 * @interface
 * An interface representing SearchFuzzyResponseSummary.
 * Summary object
 *
 */
export interface SearchFuzzyResponseSummary {
  /**
   * @member {string} [query] Query property
   */
  readonly query?: string;
  /**
   * @member {string} [queryType] QueryType property
   */
  readonly queryType?: string;
  /**
   * @member {number} [queryTime] QueryTime property
   */
  readonly queryTime?: number;
  /**
   * @member {number} [numResults] NumResults property
   */
  readonly numResults?: number;
  /**
   * @member {number} [offset] Offset property
   */
  readonly offset?: number;
  /**
   * @member {number} [totalResults] TotalResults property
   */
  readonly totalResults?: number;
  /**
   * @member {number} [fuzzyLevel] FuzzyLevel property
   */
  readonly fuzzyLevel?: number;
}

/**
 * @interface
 * An interface representing SearchResultPoiClassificationNamesItem.
 * Name for the classification
 *
 */
export interface SearchResultPoiClassificationNamesItem {
  /**
   * @member {string} [nameLocale] Name Locale property
   */
  readonly nameLocale?: string;
  /**
   * @member {string} [name] Name property
   */
  readonly name?: string;
}

/**
 * @interface
 * An interface representing SearchResultPoiClassification.
 * The classification for the POI being returned
 *
 */
export interface SearchResultPoiClassification {
  /**
   * @member {string} [code] Code property
   */
  readonly code?: string;
  /**
   * @member {SearchResultPoiClassificationNamesItem[]} [names] Names array
   */
  readonly names?: SearchResultPoiClassificationNamesItem[];
}

/**
 * @interface
 * An interface representing SearchResultPoi.
 * Details of the poi including the name, phone, url, and categories.
 *
 */
export interface SearchResultPoi {
  /**
   * @member {string} [name] Name property
   */
  readonly name?: string;
  /**
   * @member {string} [phone] Phone property
   */
  readonly phone?: string;
  /**
   * @member {string} [url] URL property
   */
  readonly url?: string;
  /**
   * @member {string[]} [categories] Categories array
   */
  readonly categories?: string[];
  /**
   * @member {SearchResultPoiClassification[]} [classifications] Classification
   * array
   */
  readonly classifications?: SearchResultPoiClassification[];
}

/**
 * @interface
 * An interface representing SearchResultAddress.
 * The address of the result
 *
 */
export interface SearchResultAddress {
  /**
   * @member {string} [buildingNumber] Building Number property
   */
  readonly buildingNumber?: string;
  /**
   * @member {string} [street] Street property
   */
  readonly street?: string;
  /**
   * @member {string} [crossStreet] Cross Street property
   */
  readonly crossStreet?: string;
  /**
   * @member {string} [streetNumber] Street Number property
   */
  readonly streetNumber?: string;
  /**
   * @member {number[]} [routeNumbers] number of routes
   */
  readonly routeNumbers?: number[];
  /**
   * @member {string} [streetName] Street Name property
   */
  readonly streetName?: string;
  /**
   * @member {string} [streetNameAndNumber] Street Name and Number property
   */
  readonly streetNameAndNumber?: string;
  /**
   * @member {string} [municipality] Municipality property
   */
  readonly municipality?: string;
  /**
   * @member {string} [municipalitySubdivision] Municipality Subdivision
   * property
   */
  readonly municipalitySubdivision?: string;
  /**
   * @member {string} [countryTertiarySubdivision] Country Tertiary Subdivision
   * property
   */
  readonly countryTertiarySubdivision?: string;
  /**
   * @member {string} [countrySecondarySubdivision] Country Secondary
   * Subdivision property
   */
  readonly countrySecondarySubdivision?: string;
  /**
   * @member {string} [countrySubdivision] Country Subdivision property
   */
  readonly countrySubdivision?: string;
  /**
   * @member {string} [postalCode] Postal Code property
   */
  readonly postalCode?: string;
  /**
   * @member {string} [extendedPostalCode] Extended Postal Code property
   */
  readonly extendedPostalCode?: string;
  /**
   * @member {string} [countryCode] Country Code property
   */
  readonly countryCode?: string;
  /**
   * @member {string} [country] Country property
   */
  readonly country?: string;
  /**
   * @member {string} [countryCodeISO3] Country Code ISO3 property
   */
  readonly countryCodeISO3?: string;
  /**
   * @member {string} [freeformAddress] Free form Address property
   */
  readonly freeformAddress?: string;
  /**
   * @member {string} [countrySubdivisionName] Country Subdividion Name
   * property
   */
  readonly countrySubdivisionName?: string;
}

/**
 * @interface
 * An interface representing SearchResultPosition.
 * Coordinates of the result
 *
 */
export interface SearchResultPosition {
  /**
   * @member {number} [lat] Latitude property
   */
  readonly lat?: number;
  /**
   * @member {number} [lon] Longitude property
   */
  readonly lon?: number;
}

/**
 * @interface
 * An interface representing SearchResultViewportTopLeftPoint.
 * Top left of the viewport
 *
 */
export interface SearchResultViewportTopLeftPoint {
  /**
   * @member {number} [lat] Latitude
   */
  readonly lat?: number;
  /**
   * @member {number} [lon] Longitude
   */
  readonly lon?: number;
}

/**
 * @interface
 * An interface representing SearchResultViewportBtmRightPoint.
 * Bottom right of the viewport
 *
 */
export interface SearchResultViewportBtmRightPoint {
  /**
   * @member {number} [lat] Latitude
   */
  readonly lat?: number;
  /**
   * @member {number} [lon] Longitude
   */
  readonly lon?: number;
}

/**
 * @interface
 * An interface representing SearchResultViewport.
 * The viewport that covers the result
 *
 */
export interface SearchResultViewport {
  /**
   * @member {SearchResultViewportTopLeftPoint} [topLeftPoint] Top left of the
   * viewport
   */
  topLeftPoint?: SearchResultViewportTopLeftPoint;
  /**
   * @member {SearchResultViewportBtmRightPoint} [btmRightPoint] Bottom right
   * of the viewport
   */
  btmRightPoint?: SearchResultViewportBtmRightPoint;
}

/**
 * @interface
 * An interface representing SearchResultEntryPointPosition.
 * Name property
 *
 */
export interface SearchResultEntryPointPosition {
  /**
   * @member {number} [lat] Latitude property
   */
  readonly lat?: number;
  /**
   * @member {number} [lon] Longitude property
   */
  readonly lon?: number;
}

/**
 * @interface
 * An interface representing SearchResultEntryPoint.
 * The entry point for the POI being returned.
 *
 */
export interface SearchResultEntryPoint {
  /**
   * @member {Type} [type] The type of entry point. Value can be either _main_
   * or _minor_. Possible values include: 'main', 'minor'
   */
  readonly type?: Type;
  /**
   * @member {SearchResultEntryPointPosition} [position] Name property
   */
  readonly position?: SearchResultEntryPointPosition;
}

/**
 * @interface
 * An interface representing SearchResultAddressRangesFrom.
 * A postion of start point
 *
 */
export interface SearchResultAddressRangesFrom {
  /**
   * @member {number} [lon] longitude of start point
   */
  lon?: number;
  /**
   * @member {number} [lat] latitude of start point
   */
  lat?: number;
}

/**
 * @interface
 * An interface representing SearchResultAddressRangesTo.
 * A postion of destination
 *
 */
export interface SearchResultAddressRangesTo {
  /**
   * @member {number} [lon] longitude of destination
   */
  lon?: number;
  /**
   * @member {number} [lat] latitude of destination
   */
  lat?: number;
}

/**
 * @interface
 * An interface representing SearchResultAddressRanges.
 */
export interface SearchResultAddressRanges {
  /**
   * @member {string} [rangeLeft]
   */
  rangeLeft?: string;
  /**
   * @member {string} [rangeRight]
   */
  rangeRight?: string;
  /**
   * @member {SearchResultAddressRangesFrom} [from] A postion of start point
   */
  from?: SearchResultAddressRangesFrom;
  /**
   * @member {SearchResultAddressRangesTo} [to] A postion of destination
   */
  to?: SearchResultAddressRangesTo;
}

/**
 * @interface
 * An interface representing SearchFuzzyResult.
 */
export interface SearchFuzzyResult {
  /**
   * @member {string} [type] Type property
   */
  readonly type?: string;
  /**
   * @member {string} [id] Id property
   */
  readonly id?: string;
  /**
   * @member {number} [score] Score property
   */
  readonly score?: number;
  /**
   * @member {string} [info] Info property
   */
  readonly info?: string;
  /**
   * @member {string} [entityType] Entity Type property
   */
  readonly entityType?: string;
  /**
   * @member {SearchResultPoi} [poi]
   */
  poi?: SearchResultPoi;
  /**
   * @member {SearchResultAddress} [address]
   */
  address?: SearchResultAddress;
  /**
   * @member {SearchResultPosition} [position]
   */
  position?: SearchResultPosition;
  /**
   * @member {SearchResultViewport} [viewport]
   */
  viewport?: SearchResultViewport;
  /**
   * @member {SearchResultEntryPoint[]} [entryPoints] Entry Points array
   */
  entryPoints?: SearchResultEntryPoint[];
  /**
   * @member {SearchResultAddressRanges} [addressRanges]
   */
  addressRanges?: SearchResultAddressRanges;
}

/**
 * @interface
 * An interface representing SearchFuzzyResponse.
 * This object is returned from a successful Search Fuzzy call
 *
 */
export interface SearchFuzzyResponse {
  /**
   * @member {SearchFuzzyResponseSummary} [summary] Summary object
   */
  readonly summary?: SearchFuzzyResponseSummary;
  /**
   * @member {SearchFuzzyResult[]} [results] Results array
   */
  readonly results?: SearchFuzzyResult[];
}

/**
 * @interface
 * An interface representing SearchPoiResponseSummary.
 * Summary object
 *
 */
export interface SearchPoiResponseSummary {
  /**
   * @member {string} [query] Query property
   */
  readonly query?: string;
  /**
   * @member {string} [queryType] QueryType property
   */
  readonly queryType?: string;
  /**
   * @member {number} [queryTime] QueryTime property
   */
  readonly queryTime?: number;
  /**
   * @member {number} [numResults] NumResults property
   */
  readonly numResults?: number;
  /**
   * @member {number} [offset] Offset property
   */
  readonly offset?: number;
  /**
   * @member {number} [totalResults] TotalResults property
   */
  readonly totalResults?: number;
  /**
   * @member {number} [fuzzyLevel] FuzzyLevel property
   */
  readonly fuzzyLevel?: number;
}

/**
 * @interface
 * An interface representing SearchPoiResult.
 */
export interface SearchPoiResult {
  /**
   * @member {string} [type] Type property
   */
  readonly type?: string;
  /**
   * @member {string} [id] Id property
   */
  readonly id?: string;
  /**
   * @member {number} [score] Score property
   */
  readonly score?: number;
  /**
   * @member {number} [dist] Distance property
   */
  readonly dist?: number;
  /**
   * @member {string} [info] Info property
   */
  readonly info?: string;
  /**
   * @member {string} [entityType] Entity Type property
   */
  readonly entityType?: string;
  /**
   * @member {SearchResultPoi} [poi]
   */
  poi?: SearchResultPoi;
  /**
   * @member {SearchResultAddress} [address]
   */
  address?: SearchResultAddress;
  /**
   * @member {SearchResultPosition} [position]
   */
  position?: SearchResultPosition;
  /**
   * @member {SearchResultViewport} [viewport]
   */
  viewport?: SearchResultViewport;
  /**
   * @member {SearchResultEntryPoint[]} [entryPoints] Entry Points array
   */
  entryPoints?: SearchResultEntryPoint[];
}

/**
 * @interface
 * An interface representing SearchPoiResponse.
 * This object is returned from a successful Search POI call
 *
 */
export interface SearchPoiResponse {
  /**
   * @member {SearchPoiResponseSummary} [summary] Summary object
   */
  readonly summary?: SearchPoiResponseSummary;
  /**
   * @member {SearchPoiResult[]} [results] Results array
   */
  readonly results?: SearchPoiResult[];
}

/**
 * @interface
 * An interface representing SearchNearbyResponseSummaryGeoBias.
 * GeoBias property
 *
 */
export interface SearchNearbyResponseSummaryGeoBias {
  /**
   * @member {number} [lat] Latitude property
   */
  readonly lat?: number;
  /**
   * @member {number} [lon] Longitude property
   */
  readonly lon?: number;
}

/**
 * @interface
 * An interface representing SearchNearbyResponseSummary.
 * Summary object
 *
 */
export interface SearchNearbyResponseSummary {
  /**
   * @member {string} [queryType] QueryType property
   */
  readonly queryType?: string;
  /**
   * @member {number} [queryTime] QueryTime property
   */
  readonly queryTime?: number;
  /**
   * @member {number} [numResults] NumResults property
   */
  readonly numResults?: number;
  /**
   * @member {number} [offset] Offset property
   */
  readonly offset?: number;
  /**
   * @member {number} [totalResults] TotalResults property
   */
  readonly totalResults?: number;
  /**
   * @member {number} [fuzzyLevel] FuzzyLevel property
   */
  readonly fuzzyLevel?: number;
  /**
   * @member {SearchNearbyResponseSummaryGeoBias} [geoBias] GeoBias property
   */
  readonly geoBias?: SearchNearbyResponseSummaryGeoBias;
}

/**
 * @interface
 * An interface representing SearchNearbyResult.
 */
export interface SearchNearbyResult {
  /**
   * @member {string} [type] Type property
   */
  readonly type?: string;
  /**
   * @member {string} [id] Id property
   */
  readonly id?: string;
  /**
   * @member {number} [score] Score property
   */
  readonly score?: number;
  /**
   * @member {number} [dist] Distance property
   */
  readonly dist?: number;
  /**
   * @member {string} [info] Info property
   */
  readonly info?: string;
  /**
   * @member {SearchResultPoi} [poi]
   */
  poi?: SearchResultPoi;
  /**
   * @member {SearchResultAddress} [address]
   */
  address?: SearchResultAddress;
  /**
   * @member {SearchResultPosition} [position]
   */
  position?: SearchResultPosition;
  /**
   * @member {SearchResultViewport} [viewport]
   */
  viewport?: SearchResultViewport;
  /**
   * @member {SearchResultEntryPoint[]} [entryPoints] Entry Points array
   */
  entryPoints?: SearchResultEntryPoint[];
}

/**
 * @interface
 * An interface representing SearchNearbyResponse.
 * This object is returned from a successful Search Nearby call
 *
 */
export interface SearchNearbyResponse {
  /**
   * @member {SearchNearbyResponseSummary} [summary] Summary object
   */
  readonly summary?: SearchNearbyResponseSummary;
  /**
   * @member {SearchNearbyResult[]} [results] Results array
   */
  readonly results?: SearchNearbyResult[];
}

/**
 * @interface
 * An interface representing SearchPoiCategoryResponseSummary.
 * Summary object
 *
 */
export interface SearchPoiCategoryResponseSummary {
  /**
   * @member {string} [query] Query property
   */
  readonly query?: string;
  /**
   * @member {string} [queryType] QueryType property
   */
  readonly queryType?: string;
  /**
   * @member {number} [queryTime] QueryTime property
   */
  readonly queryTime?: number;
  /**
   * @member {number} [numResults] NumResults property
   */
  readonly numResults?: number;
  /**
   * @member {number} [offset] Offset property
   */
  readonly offset?: number;
  /**
   * @member {number} [totalResults] TotalResults property
   */
  readonly totalResults?: number;
  /**
   * @member {number} [fuzzyLevel] FuzzyLevel property
   */
  readonly fuzzyLevel?: number;
}

/**
 * @interface
 * An interface representing SearchPoiCategoryResult.
 */
export interface SearchPoiCategoryResult {
  /**
   * @member {string} [type] Type property
   */
  readonly type?: string;
  /**
   * @member {string} [id] Id property
   */
  readonly id?: string;
  /**
   * @member {number} [score] Score property
   */
  readonly score?: number;
  /**
   * @member {number} [dist] Distance in meters
   */
  readonly dist?: number;
  /**
   * @member {string} [info] Info property
   */
  readonly info?: string;
  /**
   * @member {string} [entityType] Entity Type property
   */
  readonly entityType?: string;
  /**
   * @member {SearchResultPoi} [poi]
   */
  poi?: SearchResultPoi;
  /**
   * @member {SearchResultAddress} [address]
   */
  address?: SearchResultAddress;
  /**
   * @member {SearchResultPosition} [position]
   */
  position?: SearchResultPosition;
  /**
   * @member {SearchResultViewport} [viewport]
   */
  viewport?: SearchResultViewport;
  /**
   * @member {SearchResultEntryPoint[]} [entryPoints] Entry Points array
   */
  entryPoints?: SearchResultEntryPoint[];
}

/**
 * @interface
 * An interface representing SearchPoiCategoryResponse.
 * This object is returned from a successful Search POI Category call
 *
 */
export interface SearchPoiCategoryResponse {
  /**
   * @member {SearchPoiCategoryResponseSummary} [summary] Summary object
   */
  readonly summary?: SearchPoiCategoryResponseSummary;
  /**
   * @member {SearchPoiCategoryResult[]} [results] Results array
   */
  readonly results?: SearchPoiCategoryResult[];
}

/**
 * @interface
 * An interface representing SearchAddressResponseSummary.
 * Summary object
 *
 */
export interface SearchAddressResponseSummary {
  /**
   * @member {string} [query] Query property
   */
  readonly query?: string;
  /**
   * @member {string} [queryType] QueryType property
   */
  readonly queryType?: string;
  /**
   * @member {number} [queryTime] QueryTime property
   */
  readonly queryTime?: number;
  /**
   * @member {number} [numResults] NumResults property
   */
  readonly numResults?: number;
  /**
   * @member {number} [offset] Offset property
   */
  readonly offset?: number;
  /**
   * @member {number} [totalResults] TotalResults property
   */
  readonly totalResults?: number;
  /**
   * @member {number} [fuzzyLevel] FuzzyLevel property
   */
  readonly fuzzyLevel?: number;
}

/**
 * @interface
 * An interface representing SearchAddressResult.
 */
export interface SearchAddressResult {
  /**
   * @member {string} [type] Type property
   */
  readonly type?: string;
  /**
   * @member {string} [id] Id property
   */
  readonly id?: string;
  /**
   * @member {number} [score] Score property
   */
  readonly score?: number;
  /**
   * @member {SearchResultAddress} [address]
   */
  address?: SearchResultAddress;
  /**
   * @member {SearchResultPosition} [position]
   */
  position?: SearchResultPosition;
  /**
   * @member {SearchResultViewport} [viewport]
   */
  viewport?: SearchResultViewport;
  /**
   * @member {SearchResultEntryPoint[]} [entryPoints] Entry Points array
   */
  entryPoints?: SearchResultEntryPoint[];
}

/**
 * @interface
 * An interface representing SearchAddressResponse.
 * This object is returned from a successful Search Address call
 *
 */
export interface SearchAddressResponse {
  /**
   * @member {SearchAddressResponseSummary} [summary] Summary object
   */
  readonly summary?: SearchAddressResponseSummary;
  /**
   * @member {SearchAddressResult[]} [results] Results array
   */
  readonly results?: SearchAddressResult[];
}

/**
 * @interface
 * An interface representing SearchAddressReverseResponseSummary.
 * Summary object
 *
 */
export interface SearchAddressReverseResponseSummary {
  /**
   * @member {number} [queryTime] QueryTime property
   */
  readonly queryTime?: number;
  /**
   * @member {number} [numResults] NumResults property
   */
  readonly numResults?: number;
}

/**
 * @interface
 * An interface representing SearchAddressReverseResult.
 */
export interface SearchAddressReverseResult {
  /**
   * @member {SearchResultAddress} [address]
   */
  address?: SearchResultAddress;
  /**
   * @member {string} [position] Position property in the form of
   * "{latitude},{longitude}"
   */
  readonly position?: string;
}

/**
 * @interface
 * An interface representing SearchAddressReverseResponse.
 * This object is returned from a successful Search Address Reverse call
 *
 */
export interface SearchAddressReverseResponse {
  /**
   * @member {SearchAddressReverseResponseSummary} [summary] Summary object
   */
  readonly summary?: SearchAddressReverseResponseSummary;
  /**
   * @member {SearchAddressReverseResult[]} [addresses] Addresses array
   */
  readonly addresses?: SearchAddressReverseResult[];
}

/**
 * @interface
 * An interface representing SearchAddressReverseCrossStreetResponseSummary.
 * Summary object
 *
 */
export interface SearchAddressReverseCrossStreetResponseSummary {
  /**
   * @member {number} [queryTime] QueryTime property
   */
  readonly queryTime?: number;
  /**
   * @member {number} [numResults] NumResults property
   */
  readonly numResults?: number;
}

/**
 * @interface
 * An interface representing SearchAddressReverseCrossStreetResult.
 */
export interface SearchAddressReverseCrossStreetResult {
  /**
   * @member {SearchResultAddress} [address]
   */
  address?: SearchResultAddress;
  /**
   * @member {string} [position] Position property in the form of
   * "{latitude},{longitude}"
   */
  readonly position?: string;
}

/**
 * @interface
 * An interface representing SearchAddressReverseCrossStreetResponse.
 * This object is returned from a successful Search Address Reverse CrossStreet
 * call
 *
 */
export interface SearchAddressReverseCrossStreetResponse {
  /**
   * @member {SearchAddressReverseCrossStreetResponseSummary} [summary] Summary
   * object
   */
  readonly summary?: SearchAddressReverseCrossStreetResponseSummary;
  /**
   * @member {SearchAddressReverseCrossStreetResult[]} [addresses] Addresses
   * array
   */
  readonly addresses?: SearchAddressReverseCrossStreetResult[];
}

/**
 * @interface
 * An interface representing SearchAddressStructuredResponseSummaryGeoBias.
 * Geo Bias of the result
 *
 */
export interface SearchAddressStructuredResponseSummaryGeoBias {
  /**
   * @member {number} [lat] Latitude property
   */
  readonly lat?: number;
  /**
   * @member {number} [lon] Longitude property
   */
  readonly lon?: number;
}

/**
 * @interface
 * An interface representing SearchAddressStructuredResponseSummary.
 * Summary object
 *
 */
export interface SearchAddressStructuredResponseSummary {
  /**
   * @member {string} [query] Query property
   */
  readonly query?: string;
  /**
   * @member {string} [queryType] QueryType property
   */
  readonly queryType?: string;
  /**
   * @member {number} [queryTime] QueryTime property
   */
  readonly queryTime?: number;
  /**
   * @member {number} [numResults] NumResults property
   */
  readonly numResults?: number;
  /**
   * @member {number} [limit] Maximum number of responses that will be returned
   */
  readonly limit?: number;
  /**
   * @member {number} [offset] Offset property
   */
  readonly offset?: number;
  /**
   * @member {number} [totalResults] TotalResults property
   */
  readonly totalResults?: number;
  /**
   * @member {number} [fuzzyLevel] FuzzyLevel property
   */
  readonly fuzzyLevel?: number;
  /**
   * @member {SearchAddressStructuredResponseSummaryGeoBias} [geoBias] Geo Bias
   * of the result
   */
  geoBias?: SearchAddressStructuredResponseSummaryGeoBias;
}

/**
 * @interface
 * An interface representing SearchAddressStructuredResult.
 */
export interface SearchAddressStructuredResult {
  /**
   * @member {string} [type] Type property
   */
  readonly type?: string;
  /**
   * @member {string} [id] Id property
   */
  readonly id?: string;
  /**
   * @member {number} [score] Score property
   */
  readonly score?: number;
  /**
   * @member {number} [dist] Dist property
   */
  readonly dist?: number;
  /**
   * @member {SearchResultAddress} [address]
   */
  address?: SearchResultAddress;
  /**
   * @member {SearchResultPosition} [position]
   */
  position?: SearchResultPosition;
  /**
   * @member {SearchResultViewport} [viewport]
   */
  viewport?: SearchResultViewport;
  /**
   * @member {SearchResultEntryPoint[]} [entryPoints] Entry Points array
   */
  entryPoints?: SearchResultEntryPoint[];
  /**
   * @member {SearchResultAddressRanges} [addressRanges]
   */
  addressRanges?: SearchResultAddressRanges;
}

/**
 * @interface
 * An interface representing SearchAddressStructuredResponse.
 * This object is returned from a successful Search Address Structured call
 *
 */
export interface SearchAddressStructuredResponse {
  /**
   * @member {SearchAddressStructuredResponseSummary} [summary] Summary object
   */
  readonly summary?: SearchAddressStructuredResponseSummary;
  /**
   * @member {SearchAddressStructuredResult[]} [results] Results array
   */
  readonly results?: SearchAddressStructuredResult[];
}

/**
 * @interface
 * An interface representing SearchGeometryResponseSummary.
 * Summary object
 *
 */
export interface SearchGeometryResponseSummary {
  /**
   * @member {string} [query] Query property
   */
  readonly query?: string;
  /**
   * @member {string} [queryType] QueryType property
   */
  readonly queryType?: string;
  /**
   * @member {number} [queryTime] QueryTime property
   */
  readonly queryTime?: number;
  /**
   * @member {number} [numResults] NumResults property
   */
  readonly numResults?: number;
  /**
   * @member {number} [offset] Offset property
   */
  readonly offset?: number;
  /**
   * @member {number} [totalResults] TotalResults property
   */
  readonly totalResults?: number;
  /**
   * @member {number} [fuzzyLevel] FuzzyLevel property
   */
  readonly fuzzyLevel?: number;
}

/**
 * @interface
 * An interface representing SearchGeometryResult.
 * This type represents the Search Inside Geometry result object.
 *
 */
export interface SearchGeometryResult {
  /**
   * @member {string} [type] Type property
   */
  readonly type?: string;
  /**
   * @member {string} [id] Id property
   */
  readonly id?: string;
  /**
   * @member {number} [score] Score property
   */
  readonly score?: number;
  /**
   * @member {string} [info] Info property
   */
  readonly info?: string;
  /**
   * @member {string} [entityType] Entity Type property
   */
  readonly entityType?: string;
  /**
   * @member {SearchResultPoi} [poi]
   */
  poi?: SearchResultPoi;
  /**
   * @member {SearchResultAddress} [address]
   */
  address?: SearchResultAddress;
  /**
   * @member {SearchResultPosition} [position]
   */
  position?: SearchResultPosition;
  /**
   * @member {SearchResultViewport} [viewport]
   */
  viewport?: SearchResultViewport;
  /**
   * @member {SearchResultEntryPoint[]} [entryPoints] Entry Points array
   */
  entryPoints?: SearchResultEntryPoint[];
}

/**
 * @interface
 * An interface representing SearchGeometryResponse.
 * This object is returned from a successful Search By Geometry call
 *
 */
export interface SearchGeometryResponse {
  /**
   * @member {SearchGeometryResponseSummary} [summary] Summary object
   */
  readonly summary?: SearchGeometryResponseSummary;
  /**
   * @member {SearchGeometryResult[]} [results] A list of Search Inside
   * Geometry results.
   */
  readonly results?: SearchGeometryResult[];
}

/**
 * @interface
 * An interface representing SearchAlongRouteResponseSummary.
 * Summary object
 *
 */
export interface SearchAlongRouteResponseSummary {
  /**
   * @member {string} [query] Query property
   */
  readonly query?: string;
  /**
   * @member {string} [queryType] QueryType property
   */
  readonly queryType?: string;
  /**
   * @member {number} [queryTime] QueryTime property
   */
  readonly queryTime?: number;
  /**
   * @member {number} [numResults] NumResults property
   */
  readonly numResults?: number;
  /**
   * @member {number} [offset] Offset property
   */
  readonly offset?: number;
  /**
   * @member {number} [totalResults] TotalResults property
   */
  readonly totalResults?: number;
  /**
   * @member {number} [fuzzyLevel] FuzzyLevel property
   */
  readonly fuzzyLevel?: number;
}

/**
 * @interface
 * An interface representing SearchAlongRouteResult.
 * This type represents the Search Along Route result object.
 *
 */
export interface SearchAlongRouteResult {
  /**
   * @member {string} [type] Type property
   */
  readonly type?: string;
  /**
   * @member {string} [id] Id property
   */
  readonly id?: string;
  /**
   * @member {number} [score] Score property
   */
  readonly score?: number;
  /**
   * @member {string} [info] Info property
   */
  readonly info?: string;
  /**
   * @member {string} [entityType] Entity Type property
   */
  readonly entityType?: string;
  /**
   * @member {SearchResultPoi} [poi]
   */
  poi?: SearchResultPoi;
  /**
   * @member {SearchResultAddress} [address]
   */
  address?: SearchResultAddress;
  /**
   * @member {SearchResultPosition} [position]
   */
  position?: SearchResultPosition;
  /**
   * @member {SearchResultViewport} [viewport]
   */
  viewport?: SearchResultViewport;
  /**
   * @member {SearchResultEntryPoint[]} [entryPoints] Entry Points array
   */
  entryPoints?: SearchResultEntryPoint[];
  /**
   * @member {number} [dist] Distance in meters
   */
  readonly dist?: number;
  /**
   * @member {number} [detourTime] Detour time in seconds
   */
  readonly detourTime?: number;
}

/**
 * @interface
 * An interface representing SearchAlongRouteResponse.
 * This object is returned from a successful Search Along Route call.
 *
 */
export interface SearchAlongRouteResponse {
  /**
   * @member {SearchAlongRouteResponseSummary} [summary] Summary object
   */
  readonly summary?: SearchAlongRouteResponseSummary;
  /**
   * @member {SearchAlongRouteResult[]} [results] A list of Search Along Route
   * results.
   */
  readonly results?: SearchAlongRouteResult[];
}

/**
 * @interface
 * An interface representing SearchInsideGeometryRequestBody.
 * This type represents the request body for the Search Inside Geometry
 * service.
 *
 */
export interface SearchInsideGeometryRequestBody {
  /**
   * @member {Geometry} [geometry]
   */
  geometry?: Geometry;
}

/**
 * @interface
 * An interface representing SearchAlongRouteRequestBodyRoute.
 * A valid `GeoJSON LineString` geometry type. Please refer to [RFC
 * 7946](https://tools.ietf.org/html/rfc7946#section-3.1.4) for details.
 *
 */
export interface SearchAlongRouteRequestBodyRoute {
  /**
   * @member {string} [type] Specifies the `type` for the geometry. Value
   * should always be equal to "LineString".
   */
  type?: string;
  /**
   * @member {number[][]} [coordinates] Coordinates for the `LineString`
   * geometry.
   */
  coordinates?: number[][];
}

/**
 * @interface
 * An interface representing SearchAlongRouteRequestBody.
 * This type represents the request body for the Search Along Route service.
 *
 */
export interface SearchAlongRouteRequestBody {
  /**
   * @member {SearchAlongRouteRequestBodyRoute} [route] A valid `GeoJSON
   * LineString` geometry type. Please refer to [RFC
   * 7946](https://tools.ietf.org/html/rfc7946#section-3.1.4) for details.
   */
  route?: SearchAlongRouteRequestBodyRoute;
}

/**
 * @interface
 * An interface representing GeoJSONFeatureCollectionFeaturesItemGeometry.
 * A valid `GeoJSON` geometry object. Please refer to [RFC
 * 7946](https://tools.ietf.org/html/rfc7946#section-3.1) for details.
 *
 */
export interface GeoJSONFeatureCollectionFeaturesItemGeometry {
  /**
   * @member {GeoJSONGeometryType} [type] Specifies the `GeoJSON` geometry
   * type. Must be one of the seven valid GeoJSON geometry types - Point,
   * MultiPoint, LineString, MultiLineString, Polygon, MultiPolygon and
   * GeometryCollection. Possible values include: 'Point', 'MultiPoint',
   * 'LineString', 'MultiLineString', 'Polygon', 'MultiPolygon',
   * 'GeometryCollection'
   */
  type?: GeoJSONGeometryType;
  /**
   * @member {number[][]} [coordinates] Coordinates for the geometry type.
   * Depending on the geometry type, this might be a 1D, 2D or a 3D array.
   */
  coordinates?: number[][];
}

/**
 * @interface
 * An interface representing GeoJSONFeatureCollectionFeaturesItem.
 * A valid `GeoJSON Feature` object type. Please refer to [RFC
 * 7946](https://tools.ietf.org/html/rfc7946#section-3.2) for details.
 *
 */
export interface GeoJSONFeatureCollectionFeaturesItem {
  /**
   * @member {string} [type] Specifies the `type` for the object. Value should
   * always be equal to "Feature".
   */
  type?: string;
  /**
   * @member {GeoJSONFeatureCollectionFeaturesItemGeometry} [geometry] A valid
   * `GeoJSON` geometry object. Please refer to [RFC
   * 7946](https://tools.ietf.org/html/rfc7946#section-3.1) for details.
   */
  geometry?: GeoJSONFeatureCollectionFeaturesItemGeometry;
  /**
   * @member {any} [properties] Properties can contain any additional metadata
   * about the `Feature`. Value can be any JSON object or a JSON null value
   */
  properties?: any;
}

/**
 * @interface
 * An interface representing GeoJSONFeatureCollection.
 * A valid `GeoJSON FeatureCollection` object type. Please refer to [RFC
 * 7946](https://tools.ietf.org/html/rfc7946#section-3.3) for details.
 *
 */
export interface GeoJSONFeatureCollection {
  /**
   * @member {Type1} [type] Specifies the `type` for the geometry object. This
   * value must be one of: `FeatureCollection`, `GeometryCollection` and
   * `Polygon`. Possible values include: 'FeatureCollection',
   * 'GeometryCollection', 'Polygon'
   */
  type?: Type1;
  /**
   * @member {GeoJSONFeatureCollectionFeaturesItem[]} [features] Contains a
   * list of valid `GeoJSON Feature` objects.
   */
  features?: GeoJSONFeatureCollectionFeaturesItem[];
}

/**
 * @interface
 * An interface representing GeoJSONMultiPoint.
 * A valid `GeoJSON MultiPoint` geometry type. Please refer to [RFC
 * 7946](https://tools.ietf.org/html/rfc7946#section-3.1.3) for details.
 *
 */
export interface GeoJSONMultiPoint {
  /**
   * @member {string} [type] Specifies the `type` for the geometry. Value
   * should always be equal to "MultiPoint".
   */
  type?: string;
  /**
   * @member {number[][]} [coordinates] Coordinates for the `MultiPoint`
   * geometry.
   */
  coordinates?: number[][];
}

/**
 * @interface
 * An interface representing BatchRequestBody.
 * This type represents the request body for the Batch service.
 *
 */
export interface BatchRequestBody {
  /**
   * @member {string[]} [queries] The list of queries/requests to process
   */
  queries?: string[];
}

/**
 * @interface
 * An interface representing Coordinate.
 */
export interface Coordinate {
  /**
   * @member {number} [latitude] Latitude property
   */
  readonly latitude?: number;
  /**
   * @member {number} [longitude] Longitude property
   */
  readonly longitude?: number;
}

/**
 * @interface
 * An interface representing RouteDirectionsResultSummary.
 * Summary object
 *
 */
export interface RouteDirectionsResultSummary {
  /**
   * @member {number} [lengthInMeters] Length In Meters property
   */
  readonly lengthInMeters?: number;
  /**
   * @member {number} [travelTimeInSeconds] Travel Time In Seconds property
   */
  readonly travelTimeInSeconds?: number;
  /**
   * @member {number} [trafficDelayInSeconds] Traffic Delay In Seconds property
   */
  readonly trafficDelayInSeconds?: number;
  /**
   * @member {string} [departureTime] Departure Time property
   */
  readonly departureTime?: string;
  /**
   * @member {string} [arrivalTime] Arrival Time property
   */
  readonly arrivalTime?: string;
}

/**
 * @interface
 * An interface representing RouteResultLegSummary.
 * Summary object
 *
 */
export interface RouteResultLegSummary {
  /**
   * @member {number} [lengthInMeters] Length In Meters property
   */
  readonly lengthInMeters?: number;
  /**
   * @member {number} [travelTimeInSeconds] Estimated travel Time In Seconds
   * property
   */
  readonly travelTimeInSeconds?: number;
  /**
   * @member {number} [trafficDelayInSeconds] Traffic Delay In Seconds property
   */
  readonly trafficDelayInSeconds?: number;
  /**
   * @member {string} [departureTime] Departure Time property
   */
  readonly departureTime?: string;
  /**
   * @member {string} [arrivalTime] Arrival Time property
   */
  readonly arrivalTime?: string;
  /**
   * @member {number} [noTrafficTravelTimeInSeconds] Estimated travel time
   * calculated as if there are no delays on the route due to traffic
   * conditions (e.g. congestion). Included only if computeTravelTimeFor = all
   * is used in the query.
   */
  readonly noTrafficTravelTimeInSeconds?: number;
  /**
   * @member {number} [historicTrafficTravelTimeInSeconds] Estimated travel
   * time calculated using time-dependent historic traffic data. Included only
   * if computeTravelTimeFor = all is used in the query.
   */
  readonly historicTrafficTravelTimeInSeconds?: number;
  /**
   * @member {number} [liveTrafficIncidentsTravelTimeInSeconds] Estimated
   * travel time calculated using real-time speed data. Included only if
   * computeTravelTimeFor = all is used in the query.
   */
  readonly liveTrafficIncidentsTravelTimeInSeconds?: number;
  /**
   * @member {number} [fuelConsumptionInLiters] Estimated fuel consumption in
   * liters using the Combustion Consumption Model. Included if
   * vehicleEngineType is set to _combustion_ and
   * constantSpeedConsumptionInLitersPerHundredkm is specified. The value will
   * be non-negative.
   */
  readonly fuelConsumptionInLiters?: number;
  /**
   * @member {number} [batteryConsumptionInkWh] Estimated electric energy
   * consumption in kilowatt hours (kWh) using the Electric Consumption Model.
   * Included if vehicleEngineType is set to electric and
   * constantSpeedConsumptionInkWhPerHundredkm is specified. The value of
   * batteryConsumptionInkWh includes the recuperated electric energy and can
   * therefore be negative (which indicates gaining energy). If both
   * maxChargeInkWh and currentChargeInkWh are specified, recuperation will be
   * capped to ensure that the battery charge level never exceeds
   * maxChargeInkWh. If neither maxChargeInkWh nor currentChargeInkWh are
   * specified, unconstrained recuperation is assumed in the consumption
   * calculation.
   */
  readonly batteryConsumptionInkWh?: number;
}

/**
 * @interface
 * An interface representing RouteResultLeg.
 */
export interface RouteResultLeg {
  /**
   * @member {RouteResultLegSummary} [summary] Summary object
   */
  readonly summary?: RouteResultLegSummary;
  /**
   * @member {Coordinate[]} [points] Points array
   */
  readonly points?: Coordinate[];
}

/**
 * @interface
 * An interface representing RouteResultSectionTecCausesItem.
 * The cause of the traffic event. Can contain <mainCauseCode> and
 * <subCauseCode> elements. Can be used to define iconography and descriptions.
 *
 */
export interface RouteResultSectionTecCausesItem {
  /**
   * @member {number} [mainCauseCode] The main cause of the traffic event.
   * Contains a value in the tec002:CauseCode table, as defined in the
   * TPEG2-TEC standard.
   */
  readonly mainCauseCode?: number;
  /**
   * @member {number} [subCauseCode] The subcause of the traffic event.
   * Contains a value in the sub cause table defined by the mainCauseCode, as
   * defined in the TPEG2-TEC standard.
   */
  readonly subCauseCode?: number;
}

/**
 * @interface
 * An interface representing RouteResultSectionTec.
 * Details of the traffic event, using definitions in the TPEG2-TEC standard.
 * Can contain <effectCode> and <causes> elements.
 *
 */
export interface RouteResultSectionTec {
  /**
   * @member {number} [effectCode] The effect on the traffic flow. Contains a
   * value in the tec001:EffectCode table, as defined in the TPEG2-TEC
   * standard. Can be used to color-code traffic events according to severity.
   */
  readonly effectCode?: number;
  /**
   * @member {RouteResultSectionTecCausesItem[]} [causes] List of <cause>
   * elements.
   */
  causes?: RouteResultSectionTecCausesItem[];
}

/**
 * @interface
 * An interface representing RouteResultSection.
 */
export interface RouteResultSection {
  /**
   * @member {number} [startPointIndex] Start Point Index property
   */
  readonly startPointIndex?: number;
  /**
   * @member {number} [endPointIndex] End Point Index property
   */
  readonly endPointIndex?: number;
  /**
   * @member {string} [sectionType] Section Type property
   */
  readonly sectionType?: string;
  /**
   * @member {string} [travelMode] Travel Mode property
   */
  readonly travelMode?: string;
  /**
   * @member {string} [simpleCategory] Type of the incident. Can currently be
   * JAM, ROAD_WORK, ROAD_CLOSURE, or OTHER. See "tec" for detailed
   * information.
   */
  readonly simpleCategory?: string;
  /**
   * @member {number} [effectiveSpeedInKmh] Effective speed of the incident in
   * km/h, averaged over its entire length.
   */
  readonly effectiveSpeedInKmh?: number;
  /**
   * @member {number} [delayInSeconds] Delay in seconds caused by the incident.
   */
  readonly delayInSeconds?: number;
  /**
   * @member {MagnitudeOfDelay} [magnitudeOfDelay] The magnitude of delay
   * caused by the incident. These values correspond to the values of the
   * response field <ty> of the Get Traffic Incident Detail API. Possible
   * values include: '0', '1', '2', '3', '4'
   */
  readonly magnitudeOfDelay?: MagnitudeOfDelay;
  /**
   * @member {RouteResultSectionTec} [tec]
   */
  tec?: RouteResultSectionTec;
}

/**
 * @interface
 * An interface representing RouteResultInstruction.
 * A set of attributes describing a maneuver, e.g. 'Turn right', 'Keep left',
 * 'Take the ferry', 'Take the motorway', 'Arrive'.
 *
 */
export interface RouteResultInstruction {
  /**
   * @member {number} [routeOffsetInMeters] Distance from the start of the
   * route to the point of the instruction.
   */
  readonly routeOffsetInMeters?: number;
  /**
   * @member {number} [travelTimeInSeconds] Estimated travel time up to the
   * point corresponding to routeOffsetInMeters.
   */
  readonly travelTimeInSeconds?: number;
  /**
   * @member {Coordinate} [point]
   */
  point?: Coordinate;
  /**
   * @member {GuidanceInstructionType} [instructionType] Type of the
   * instruction, e.g., turn or change of road form. Possible values include:
   * 'TURN', 'ROAD_CHANGE', 'LOCATION_DEPARTURE', 'LOCATION_ARRIVAL',
   * 'DIRECTION_INFO', 'LOCATION_WAYPOINT'
   */
  instructionType?: GuidanceInstructionType;
  /**
   * @member {string} [street] Street name of the next significant road segment
   * after the maneuver, or of the street that should be followed.
   */
  readonly street?: string;
  /**
   * @member {string} [countryCode] 3-character ISO 3166-1 alpha-3 country
   * code.
   */
  readonly countryCode?: string;
  /**
   * @member {boolean} [possibleCombineWithNext] It is possible to optionally
   * combine the instruction with the next one. This can be used to build
   * messages like "Turn left and then turn right".
   */
  readonly possibleCombineWithNext?: boolean;
  /**
   * @member {DrivingSide} [drivingSide] Indicates left-hand vs. right-hand
   * side driving at the point of the maneuver. Possible values include:
   * 'LEFT', 'RIGHT'
   */
  readonly drivingSide?: DrivingSide;
  /**
   * @member {GuidanceManeuver} [maneuver] A code identifying the maneuver.
   * Possible values include: 'ARRIVE', 'ARRIVE_LEFT', 'ARRIVE_RIGHT',
   * 'DEPART', 'STRAIGHT', 'KEEP_RIGHT', 'BEAR_RIGHT', 'TURN_RIGHT',
   * 'SHARP_RIGHT', 'KEEP_LEFT', 'BEAR_LEFT', 'TURN_LEFT', 'SHARP_LEFT',
   * 'MAKE_UTURN', 'ENTER_MOTORWAY', 'ENTER_FREEWAY', 'ENTER_HIGHWAY',
   * 'TAKE_EXIT', 'MOTORWAY_EXIT_LEFT', 'MOTORWAY_EXIT_RIGHT', 'TAKE_FERRY',
   * 'ROUNDABOUT_CROSS', 'ROUNDABOUT_RIGHT', 'ROUNDABOUT_LEFT',
   * 'ROUNDABOUT_BACK', 'TRY_MAKE_UTURN', 'FOLLOW', 'SWITCH_PARALLEL_ROAD',
   * 'SWITCH_MAIN_ROAD', 'ENTRANCE_RAMP', 'WAYPOINT_LEFT', 'WAYPOINT_RIGHT',
   * 'WAYPOINT_REACHED'
   */
  readonly maneuver?: GuidanceManeuver;
  /**
   * @member {string} [message] A human-readable message for the maneuver.
   */
  readonly message?: string;
}

/**
 * @interface
 * An interface representing RouteResultInstructionGroup.
 * Groups a sequence of instruction elements which are related to each other.
 * The sequence range is constrained with firstInstructionIndex and
 * lastInstructionIndex. When human-readable text messages are requested for
 * guidance (instructionType=text or tagged), then the instructionGroup has a
 * summary message returned when available.
 *
 */
export interface RouteResultInstructionGroup {
  /**
   * @member {number} [firstInstructionIndex] Index of the first instruction.
   */
  readonly firstInstructionIndex?: number;
  /**
   * @member {number} [lastInstructionIndex] Index of the last instruction.
   */
  readonly lastInstructionIndex?: number;
  /**
   * @member {number} [groupLengthInMeters] Length of the group.
   */
  readonly groupLengthInMeters?: number;
  /**
   * @member {string} [groupMessage] Summary message when human-readable text
   * messages are requested for guidance (instructionType=text or tagged).
   */
  readonly groupMessage?: string;
}

/**
 * @interface
 * An interface representing RouteDirectionsResultGuidance.
 * Contains guidance related elements. This field is present only when guidance
 * was requested and is available.
 *
 */
export interface RouteDirectionsResultGuidance {
  /**
   * @member {RouteResultInstruction[]} [instructions] A list of instructions
   * describing maneuvers.
   */
  readonly instructions?: RouteResultInstruction[];
  /**
   * @member {RouteResultInstructionGroup[]} [instructionGroups] Groups a
   * sequence of instruction elements which are related to each other.
   */
  readonly instructionGroups?: RouteResultInstructionGroup[];
}

/**
 * @interface
 * An interface representing RouteDirectionsResult.
 */
export interface RouteDirectionsResult {
  /**
   * @member {RouteDirectionsResultSummary} [summary] Summary object
   */
  readonly summary?: RouteDirectionsResultSummary;
  /**
   * @member {RouteResultLeg[]} [legs] Legs array
   */
  readonly legs?: RouteResultLeg[];
  /**
   * @member {RouteResultSection[]} [sections] Sections array
   */
  readonly sections?: RouteResultSection[];
  /**
   * @member {RouteDirectionsResultGuidance} [guidance] Contains guidance
   * related elements. This field is present only when guidance was requested
   * and is available.
   */
  readonly guidance?: RouteDirectionsResultGuidance;
}

/**
 * @interface
 * An interface representing RouteOptimizedWaypoint.
 * Optimized way point object.
 *
 */
export interface RouteOptimizedWaypoint {
  /**
   * @member {number} [providedIndex] Way point index provided by the user.
   */
  readonly providedIndex?: number;
  /**
   * @member {number} [optimizedIndex] Optimized way point index from the
   * system.
   */
  readonly optimizedIndex?: number;
}

/**
 * @interface
 * An interface representing RouteResponseReportEffectiveSettingsItem.
 * Effective parameter or data used when calling this Route API.
 *
 */
export interface RouteResponseReportEffectiveSettingsItem {
  /**
   * @member {string} [key] Name of the parameter used.
   */
  readonly key?: string;
  /**
   * @member {string} [value] Value of the parameter used.
   */
  readonly value?: string;
}

/**
 * @interface
 * An interface representing RouteResponseReport.
 * Reports the effective settings used in the current call.
 *
 */
export interface RouteResponseReport {
  /**
   * @member {RouteResponseReportEffectiveSettingsItem[]} [effectiveSettings]
   * Effective parameters or data used when calling this Route API.
   */
  readonly effectiveSettings?: RouteResponseReportEffectiveSettingsItem[];
}

/**
 * @interface
 * An interface representing RouteDirectionsResponse.
 * This object is returned from a successful Route Directions call
 *
 */
export interface RouteDirectionsResponse {
  /**
   * @member {string} [formatVersion] Format Version property
   */
  readonly formatVersion?: string;
  /**
   * @member {string} [copyright] Copyright property
   */
  readonly copyright?: string;
  /**
   * @member {string} [privacy] Privacy property
   */
  readonly privacy?: string;
  /**
   * @member {RouteDirectionsResult[]} [routes] Routes array
   */
  readonly routes?: RouteDirectionsResult[];
  /**
   * @member {RouteOptimizedWaypoint[]} [optimizedWaypoints] Optimized way
   * points array
   */
  readonly optimizedWaypoints?: RouteOptimizedWaypoint[];
  /**
   * @member {RouteResponseReport} [report]
   */
  report?: RouteResponseReport;
}

/**
 * @interface
 * An interface representing RouteRangeResponseReachableRange.
 * Reachable Ranges
 *
 */
export interface RouteRangeResponseReachableRange {
  /**
   * @member {Coordinate} [center] Center point of the reachable range
   */
  center?: Coordinate;
  /**
   * @member {Coordinate[]} [boundary] Polygon boundary of the reachable range
   * represented as a list of points.
   */
  readonly boundary?: Coordinate[];
}

/**
 * @interface
 * An interface representing RouteRangeResponse.
 * This object is returned from a successful Route Reachable Range call
 *
 */
export interface RouteRangeResponse {
  /**
   * @member {string} [formatVersion] Format Version property
   */
  readonly formatVersion?: string;
  /**
   * @member {string} [copyright] Copyright property
   */
  readonly copyright?: string;
  /**
   * @member {string} [privacy] Privacy property
   */
  readonly privacy?: string;
  /**
   * @member {RouteRangeResponseReachableRange} [reachableRange] Reachable
   * Ranges
   */
  reachableRange?: RouteRangeResponseReachableRange;
  /**
   * @member {RouteResponseReport} [report]
   */
  report?: RouteResponseReport;
}

/**
 * @interface
 * An interface representing RouteMatrixResultResponseRouteSummary.
 * RouteSummary object for the current cell in the input matrix.
 *
 */
export interface RouteMatrixResultResponseRouteSummary {
  /**
   * @member {number} [lengthInMeters] Length of the route In Meters.
   */
  readonly lengthInMeters?: number;
  /**
   * @member {number} [travelTimeInSeconds] Estimated travel Time In Seconds.
   */
  readonly travelTimeInSeconds?: number;
  /**
   * @member {number} [trafficDelayInSeconds] Delay based on real-time traffic
   * Vs free-flow conditions.
   */
  readonly trafficDelayInSeconds?: number;
  /**
   * @member {string} [departureTime] Estimated Departure Time.
   */
  readonly departureTime?: string;
  /**
   * @member {string} [arrivalTime] Estimated Arrival Time.
   */
  readonly arrivalTime?: string;
  /**
   * @member {number} [noTrafficTravelTimeInSeconds] Estimated travel time
   * calculated as if there are no delays on the route due to traffic
   * conditions (e.g. congestion). Included only if computeTravelTimeFor = all
   * is used in the query.
   */
  readonly noTrafficTravelTimeInSeconds?: number;
  /**
   * @member {number} [historicTrafficTravelTimeInSeconds] Estimated travel
   * time calculated using time-dependent historic traffic data. Included only
   * if computeTravelTimeFor = all is used in the query.
   */
  readonly historicTrafficTravelTimeInSeconds?: number;
  /**
   * @member {number} [liveTrafficIncidentsTravelTimeInSeconds] Estimated
   * travel time calculated using real-time speed data. Included only if
   * computeTravelTimeFor = all is used in the query.
   */
  readonly liveTrafficIncidentsTravelTimeInSeconds?: number;
}

/**
 * @interface
 * An interface representing RouteMatrixResultResponse.
 * Response object of the current cell in the input matrix.
 *
 */
export interface RouteMatrixResultResponse {
  /**
   * @member {RouteMatrixResultResponseRouteSummary} [routeSummary]
   * RouteSummary object for the current cell in the input matrix.
   */
  readonly routeSummary?: RouteMatrixResultResponseRouteSummary;
}

/**
 * @interface
 * An interface representing RouteMatrixResult.
 * Matrix result object
 *
 */
export interface RouteMatrixResult {
  /**
   * @member {number} [statusCode] StatusCode property for the current cell in
   * the input matrix.
   */
  readonly statusCode?: number;
  /**
   * @member {RouteMatrixResultResponse} [response] Response object of the
   * current cell in the input matrix.
   */
  readonly response?: RouteMatrixResultResponse;
}

/**
 * @interface
 * An interface representing RouteMatrixResponseSummary.
 * Summary object
 *
 */
export interface RouteMatrixResponseSummary {
  /**
   * @member {number} [successfulRoutes] Number of successful routes in the
   * response.
   */
  readonly successfulRoutes?: number;
  /**
   * @member {number} [totalRoutes] Total number of routes requested. Number of
   * cells in the input matrix.
   */
  readonly totalRoutes?: number;
}

/**
 * @interface
 * An interface representing RouteMatrixResponse.
 * This object is returned from a successful Route Matrix call. For ex, if 2
 * origins and 3 destinations are provided, there are going to 2 arrays with 3
 * elements in each. Each element's content depends on the options provided in
 * the query.
 *
 */
export interface RouteMatrixResponse {
  /**
   * @member {string} [formatVersion] Format Version property
   */
  readonly formatVersion?: string;
  /**
   * @member {RouteMatrixResult[][]} [matrix] Results as a 2 dimensional array
   * of route summaries.
   */
  readonly matrix?: RouteMatrixResult[][];
  /**
   * @member {RouteMatrixResponseSummary} [summary] Summary object
   */
  readonly summary?: RouteMatrixResponseSummary;
}

/**
 * @interface
 * An interface representing RouteMatrixRequestBody.
 * An object with a matrix of coordinates.
 *
 */
export interface RouteMatrixRequestBody {
  /**
   * @member {GeoJSONMultiPoint} [origins]
   */
  origins?: GeoJSONMultiPoint;
  /**
   * @member {GeoJSONMultiPoint} [destinations]
   */
  destinations?: GeoJSONMultiPoint;
}

/**
 * @interface
 * An interface representing PostSearchFuzzyBatchAcceptedResponse.
 * This object is returned when the request is accepted but the processing has
 * not been completed. The location header in the response contains the new URL
 * to retry.
 *
 */
export interface PostSearchFuzzyBatchAcceptedResponse {
  /**
   * @member {string} [location] New URL to check for the results of the long
   * running process.
   */
  readonly location?: string;
}

/**
 * @interface
 * An interface representing PostSearchAddressBatchAcceptedResponse.
 * This object is returned when the request is accepted but the processing has
 * not been completed. The location header in the response contains the new URL
 * to retry.
 *
 */
export interface PostSearchAddressBatchAcceptedResponse {
  /**
   * @member {string} [location] New URL to check for the results of the long
   * running process.
   */
  readonly location?: string;
}

/**
 * @interface
 * An interface representing PostSearchAddressReverseBatchAcceptedResponse.
 * This object is returned when the request is accepted but the processing has
 * not been completed. The location header in the response contains the new URL
 * to retry.
 *
 */
export interface PostSearchAddressReverseBatchAcceptedResponse {
  /**
   * @member {string} [location] New URL to check for the results of the long
   * running process.
   */
  readonly location?: string;
}

/**
 * @interface
 * An interface representing PostRouteDirectionsBatchAcceptedResponse.
 * This object is returned when the request is accepted but the processing has
 * not been completed. The location header in the response contains the new URL
 * to retry.
 *
 */
export interface PostRouteDirectionsBatchAcceptedResponse {
  /**
   * @member {string} [location] New URL to check for the results of the long
   * running process.
   */
  readonly location?: string;
}

/**
 * @interface
 * An interface representing MapsClientOptions.
 * @extends ServiceClientOptions
 */
export interface MapsClientOptions extends ServiceClientOptions {
  /**
   * @member {string} [apiVersion] Version number of Azure Maps API. Current
   * version is 1.0. Default value: '1.0' .
   */
  apiVersion?: string;
  /**
   * @member {RouteInstructionsType} [instructionsType] If specified, guidance
   * instructions will be returned. Note that the instructionsType parameter
   * cannot be used in conjunction with routeRepresentation=none. Possible
   * values include: 'coded', 'text', 'tagged'
   */
  instructionsType?: RouteInstructionsType;
}

/**
 * @interface
 * An interface representing SearchGetSearchFuzzyOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface SearchGetSearchFuzzyOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {boolean} [typeahead] Boolean. If the typeahead flag is set, the
   * query will be interpreted as a partial input and the search will enter
   * predictive mode. Default value: false .
   */
  typeahead?: boolean;
  /**
   * @member {number} [limit] Maximum number of responses that will be
   * returned. Default: 10, minimum: 1 and maximum: 100. Default value: 10 .
   */
  limit?: number;
  /**
   * @member {number} [ofs] Starting offset of the returned results within the
   * full result set. Default: 0, minimum: 0 and maximum: 1900. Default value:
   * 0 .
   */
  ofs?: number;
  /**
   * @member {string[]} [countrySet] Comma separated string of country codes,
   * e.g. FR, ES. This will limit the search to the specified countries
   */
  countrySet?: string[];
  /**
   * @member {number} [lat] Latitude where results should be biased. E.g.
   * 37.337
   */
  lat?: number;
  /**
   * @member {number} [lon] Longitude where results should be biased. E.g.
   * -121.89
   */
  lon?: number;
  /**
   * @member {number} [radius] The radius in meters to for the results to be
   * constrained to the defined area
   */
  radius?: number;
  /**
   * @member {string} [topLeft] Top left position of the bounding box. E.g.
   * 37.553,-122.453
   */
  topLeft?: string;
  /**
   * @member {string} [btmRight] Bottom right position of the bounding box.
   * E.g. 37.553,-122.453
   */
  btmRight?: string;
  /**
   * @member {string} [language] Language in which search results should be
   * returned. Should be one of supported IETF language tags, case insensitive.
   * When data in specified language is not available for a specific field,
   * default language is used. Please refer to [Supported
   * Languages](https://docs.microsoft.com/en-us/azure/azure-maps/supported-languages)
   * for details.
   */
  language?: string;
  /**
   * @member {string} [extendedPostalCodesFor] Indexes for which extended
   * postal codes should be included in the results.
   *
   * Available indexes are:
   *
   * **Addr** = Address ranges
   *
   * **Geo** = Geographies
   *
   * **PAD** = Point Addresses
   *
   * **POI** = Points of Interest
   *
   * **Str** = Streets
   *
   * **XStr** = Cross Streets (intersections)
   *
   * Value should be a comma separated list of index types (in any order) or
   * **None** for no indexes.
   *
   * By default extended postal codes are included for all indexes except Geo.
   * Extended postal code lists for geographies can be quite long so they have
   * to be explicitly requested when needed.
   *
   * Usage examples:
   *
   * extendedPostalCodesFor=POI
   *
   * extendedPostalCodesFor=PAD,Addr,POI
   *
   * extendedPostalCodesFor=None
   *
   * Extended postal code is returned as an **extendedPostalCode** property of
   * an address. Availability is region-dependent.
   */
  extendedPostalCodesFor?: string;
  /**
   * @member {number} [minFuzzyLevel] Maximum fuzzyness level to be used.
   * Default: 2, minimum: 1 and maximum: 4
   *
   * * Level 1 has no spell checking.
   *
   * * Level 2 uses normal n-gram spell checking. For example, query "restrant"
   * can be matched to "restaurant."
   *
   * * Level 3 uses sound-like spell checking, and shingle spell checking.
   * Sound-like spell checking is for "rstrnt" to "restaurant" matching.
   * Shingle spell checking is for "mountainview" to "mountain view" matching.
   *
   * * Level 4 doesn’t add any more spell checking functions.
   *
   *
   *
   * The search engine will start looking for a match on the level defined by
   * minFuzzyLevel, and will stop searching at the level specified by
   * maxFuzzyLevel. . Default value: 1 .
   */
  minFuzzyLevel?: number;
  /**
   * @member {number} [maxFuzzyLevel] Maximum fuzzyness level to be used.
   * Default: 2, minimum: 1 and maximum: 4
   *
   * * Level 1 has no spell checking.
   *
   * * Level 2 uses normal n-gram spell checking. For example, query "restrant"
   * can be matched to "restaurant."
   *
   * * Level 3 uses sound-like spell checking, and shingle spell checking.
   * Sound-like spell checking is for "rstrnt" to "restaurant" matching.
   * Shingle spell checking is for "mountainview" to "mountain view" matching.
   *
   * * Level 4 doesn’t add any more spell checking functions.
   *
   *
   *
   * The search engine will start looking for a match on the level defined by
   * minFuzzyLevel, and will stop searching at the level specified by
   * maxFuzzyLevel. Default value: 2 .
   */
  maxFuzzyLevel?: number;
  /**
   * @member {SearchIndexSet[]} [idxSet] A comma separated list of indexes
   * which should be utilized for the search. Item order does not matter.
   * Available indexes are: Addr = Address range interpolation, Geo =
   * Geographies, PAD = Point Addresses, POI = Points of interest, Str =
   * Streets, Xstr = Cross Streets (intersections)
   */
  idxSet?: SearchIndexSet[];
}

/**
 * @interface
 * An interface representing SearchGetSearchPOIOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface SearchGetSearchPOIOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {boolean} [typeahead] Boolean. If the typeahead flag is set, the
   * query will be interpreted as a partial input and the search will enter
   * predictive mode. Default value: false .
   */
  typeahead?: boolean;
  /**
   * @member {number} [limit] Maximum number of responses that will be
   * returned. Default: 10, minimum: 1 and maximum: 100. Default value: 10 .
   */
  limit?: number;
  /**
   * @member {number} [ofs] Starting offset of the returned results within the
   * full result set. Default: 0, minimum: 0 and maximum: 1900. Default value:
   * 0 .
   */
  ofs?: number;
  /**
   * @member {string[]} [countrySet] Comma separated string of country codes,
   * e.g. FR, ES. This will limit the search to the specified countries
   */
  countrySet?: string[];
  /**
   * @member {number} [lat] Latitude where results should be biased. E.g.
   * 37.337
   */
  lat?: number;
  /**
   * @member {number} [lon] Longitude where results should be biased. E.g.
   * -121.89
   */
  lon?: number;
  /**
   * @member {number} [radius] The radius in meters to for the results to be
   * constrained to the defined area
   */
  radius?: number;
  /**
   * @member {string} [topLeft] Top left position of the bounding box. E.g.
   * 37.553,-122.453
   */
  topLeft?: string;
  /**
   * @member {string} [btmRight] Bottom right position of the bounding box.
   * E.g. 37.553,-122.453
   */
  btmRight?: string;
  /**
   * @member {string} [language] Language in which search results should be
   * returned. Should be one of supported IETF language tags, case insensitive.
   * When data in specified language is not available for a specific field,
   * default language is used. Please refer to [Supported
   * Languages](https://docs.microsoft.com/en-us/azure/azure-maps/supported-languages)
   * for details.
   */
  language?: string;
  /**
   * @member {string} [extendedPostalCodesFor] Indexes for which extended
   * postal codes should be included in the results.
   *
   * Available indexes are:
   *
   * **POI** = Points of Interest
   *
   * Value should be **POI** or **None** to disable extended postal codes.
   *
   * By default extended postal codes are included.
   *
   * Usage examples:
   *
   * extendedPostalCodesFor=POI
   *
   * extendedPostalCodesFor=None
   *
   * Extended postal code is returned as an **extendedPostalCode** property of
   * an address. Availability is region-dependent.
   */
  extendedPostalCodesFor?: string;
}

/**
 * @interface
 * An interface representing SearchGetSearchNearbyOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface SearchGetSearchNearbyOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {number} [limit] Maximum number of responses that will be
   * returned. Default: 10, minimum: 1 and maximum: 100. Default value: 10 .
   */
  limit?: number;
  /**
   * @member {number} [ofs] Starting offset of returned results. Max value is
   * 1900. Default value: 0 .
   */
  ofs?: number;
  /**
   * @member {string[]} [countrySet] Comma separated string of country codes,
   * e.g. FR, ES. This will limit the search to the specified countries
   */
  countrySet?: string[];
  /**
   * @member {number} [radius] The radius in meters to for the results to be
   * constrained to the defined area, Min value is 1, Max Value is 50000.
   */
  radius?: number;
  /**
   * @member {string} [language] Language in which search results should be
   * returned. Should be one of supported IETF language tags, case insensitive.
   * When data in specified language is not available for a specific field,
   * default language is used. Please refer to [Supported
   * Languages](https://docs.microsoft.com/en-us/azure/azure-maps/supported-languages)
   * for details.
   */
  language?: string;
  /**
   * @member {string} [extendedPostalCodesFor] Indexes for which extended
   * postal codes should be included in the results.
   *
   * Available indexes are:
   *
   * **Addr** = Address ranges
   *
   * **Geo** = Geographies
   *
   * **PAD** = Point Addresses
   *
   * **POI** = Points of Interest
   *
   * **Str** = Streets
   *
   * **XStr** = Cross Streets (intersections)
   *
   * Value should be a comma separated list of index types (in any order) or
   * **None** for no indexes.
   *
   * By default extended postal codes are included for all indexes except Geo.
   * Extended postal code lists for geographies can be quite long so they have
   * to be explicitly requested when needed.
   *
   * Usage examples:
   *
   * extendedPostalCodesFor=POI
   *
   * extendedPostalCodesFor=PAD,Addr,POI
   *
   * extendedPostalCodesFor=None
   *
   * Extended postal code is returned as an **extendedPostalCode** property of
   * an address. Availability is region-dependent.
   */
  extendedPostalCodesFor?: string;
}

/**
 * @interface
 * An interface representing SearchGetSearchPOICategoryOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface SearchGetSearchPOICategoryOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {boolean} [typeahead] Boolean. If the typeahead flag is set, the
   * query will be interpreted as a partial input and the search will enter
   * predictive mode. Default value: false .
   */
  typeahead?: boolean;
  /**
   * @member {number} [limit] Maximum number of responses that will be
   * returned. Default: 10, minimum: 1 and maximum: 100. Default value: 10 .
   */
  limit?: number;
  /**
   * @member {number} [multiplier] Multiplies the limit by this value to gather
   * more candidate POIs, which will then be sorted by drive distance,
   * returning only the top candidates according to the limit. Default value: 2
   * .
   */
  multiplier?: number;
  /**
   * @member {number} [routingTimeout] Number of milliseconds routing engine
   * can take to give the results. Default value: 4000 .
   */
  routingTimeout?: number;
  /**
   * @member {string[]} [countrySet] Comma separated string of country codes,
   * e.g. FR, ES. This will limit the search to the specified countries
   */
  countrySet?: string[];
  /**
   * @member {number} [lat] Latitude where results should be biased. E.g.
   * 37.337
   */
  lat?: number;
  /**
   * @member {number} [lon] Longitude where results should be biased. E.g.
   * -121.89
   */
  lon?: number;
  /**
   * @member {number} [radius] The radius in meters to for the results to be
   * constrained to the defined area
   */
  radius?: number;
  /**
   * @member {string} [topLeft] Top left position of the bounding box. E.g.
   * 37.553,-122.453
   */
  topLeft?: string;
  /**
   * @member {string} [btmRight] Bottom right position of the bounding box.
   * E.g. 37.553,-122.453
   */
  btmRight?: string;
  /**
   * @member {string} [language] Language in which search results should be
   * returned. Should be one of supported IETF language tags, case insensitive.
   * When data in specified language is not available for a specific field,
   * default language is used. Please refer to [Supported
   * Languages](https://docs.microsoft.com/en-us/azure/azure-maps/supported-languages)
   * for details.
   */
  language?: string;
  /**
   * @member {string} [extendedPostalCodesFor] Indexes for which extended
   * postal codes should be included in the results.
   *
   * Available indexes are:
   *
   * **Addr** = Address ranges
   *
   * **Geo** = Geographies
   *
   * **PAD** = Point Addresses
   *
   * **POI** = Points of Interest
   *
   * **Str** = Streets
   *
   * **XStr** = Cross Streets (intersections)
   *
   * Value should be a comma separated list of index types (in any order) or
   * **None** for no indexes.
   *
   * By default extended postal codes are included for all indexes except Geo.
   * Extended postal code lists for geographies can be quite long so they have
   * to be explicitly requested when needed.
   *
   * Usage examples:
   *
   * extendedPostalCodesFor=POI
   *
   * extendedPostalCodesFor=PAD,Addr,POI
   *
   * extendedPostalCodesFor=None
   *
   * Extended postal code is returned as an **extendedPostalCode** property of
   * an address. Availability is region-dependent.
   */
  extendedPostalCodesFor?: string;
}

/**
 * @interface
 * An interface representing SearchGetSearchAddressOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface SearchGetSearchAddressOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {boolean} [typeahead] Boolean. If the typeahead flag is set, the
   * query will be interpreted as a partial input and the search will enter
   * predictive mode. Default value: false .
   */
  typeahead?: boolean;
  /**
   * @member {number} [limit] Maximum number of responses that will be
   * returned. Default: 10, minimum: 1 and maximum: 100. Default value: 10 .
   */
  limit?: number;
  /**
   * @member {number} [ofs] Starting offset of the returned results within the
   * full result set. Default value: 0 .
   */
  ofs?: number;
  /**
   * @member {string[]} [countrySet] Comma separated string of country codes,
   * e.g. FR, ES. This will limit the search to the specified countries
   */
  countrySet?: string[];
  /**
   * @member {number} [lat] Latitude where results should be biased. E.g.
   * 37.337
   */
  lat?: number;
  /**
   * @member {number} [lon] Longitude where results should be biased. E.g.
   * -121.89
   */
  lon?: number;
  /**
   * @member {number} [radius] The radius in meters to for the results to be
   * constrained to the defined area
   */
  radius?: number;
  /**
   * @member {string} [topLeft] Top left position of the bounding box. E.g.
   * 37.553,-122.453
   */
  topLeft?: string;
  /**
   * @member {string} [btmRight] Bottom right position of the bounding box.
   * E.g. 37.553,-122.453
   */
  btmRight?: string;
  /**
   * @member {string} [language] Language in which search results should be
   * returned. Should be one of supported IETF language tags, case insensitive.
   * When data in specified language is not available for a specific field,
   * default language is used. Please refer to [Supported
   * Languages](https://docs.microsoft.com/en-us/azure/azure-maps/supported-languages)
   * for details.
   */
  language?: string;
  /**
   * @member {string} [extendedPostalCodesFor] Indexes for which extended
   * postal codes should be included in the results.
   *
   * Available indexes are:
   *
   * **Addr** = Address ranges
   *
   * **Geo** = Geographies
   *
   * **PAD** = Point Addresses
   *
   * **POI** = Points of Interest
   *
   * **Str** = Streets
   *
   * **XStr** = Cross Streets (intersections)
   *
   * Value should be a comma separated list of index types (in any order) or
   * **None** for no indexes.
   *
   * By default extended postal codes are included for all indexes except Geo.
   * Extended postal code lists for geographies can be quite long so they have
   * to be explicitly requested when needed.
   *
   * Usage examples:
   *
   * extendedPostalCodesFor=POI
   *
   * extendedPostalCodesFor=PAD,Addr,POI
   *
   * extendedPostalCodesFor=None
   *
   * Extended postal code is returned as an **extendedPostalCode** property of
   * an address. Availability is region-dependent.
   */
  extendedPostalCodesFor?: string;
}

/**
 * @interface
 * An interface representing SearchGetSearchAddressReverseOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface SearchGetSearchAddressReverseOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {string} [language] Language in which search results should be
   * returned. Should be one of supported IETF language tags, case insensitive.
   * When data in specified language is not available for a specific field,
   * default language is used. Please refer to [Supported
   * Languages](https://docs.microsoft.com/en-us/azure/azure-maps/supported-languages)
   * for details.
   */
  language?: string;
  /**
   * @member {boolean} [returnSpeedLimit] Boolean. To enable return of the
   * posted speedlimit. Default value: false .
   */
  returnSpeedLimit?: boolean;
  /**
   * @member {number} [heading] The directional heading of the vehicle in
   * degrees, for travel along a segment of roadway. 0 is North, 90 is East and
   * so on, values range from -360 to 360. The precision can include upto one
   * decimal place
   */
  heading?: number;
  /**
   * @member {number} [radius] The radius in meters to for the results to be
   * constrained to the defined area
   */
  radius?: number;
  /**
   * @member {string} [number] If a number is sent in along with the request,
   * the response may include the side of the street (Left/Right) and also an
   * offset position for that number
   */
  number?: string;
  /**
   * @member {boolean} [returnRoadUse] Boolean. To enable return of the road
   * use array for reversegeocodes at street level. Default value: false .
   */
  returnRoadUse?: boolean;
  /**
   * @member {string} [roadUse] To restrict reversegeocodes to a certain type
   * of roaduse. The road use array for reversegeocodes can be one or more of
   * LimitedAccess, Arterial, Terminal, Ramp, Rotary, LocalStreet
   */
  roadUse?: string;
  /**
   * @member {boolean} [allowFreeformNewline] Format of newlines in the
   * formatted address.
   *
   * If true, the address will contain newlines.
   * If false, newlines will be converted to commas.
   */
  allowFreeformNewline?: boolean;
  /**
   * @member {Date} [dateTime] The date and time to return time zone
   * information for. It allows  the service to decide whether Daylight Saving
   * Time time zone should  be used or not. It must conform to
   * [RFC-3339](https://www.ietf.org/rfc/rfc3339.txt).
   *
   * Examples:
   * * 2017-12-19T16:39:57
   * * 2017-12-19T16:39:57-08:00
   */
  dateTime?: Date;
  /**
   * @member {boolean} [returnMatchType] Include information on the type of
   * match the geocoder achieved in the response.
   */
  returnMatchType?: boolean;
}

/**
 * @interface
 * An interface representing SearchGetSearchAddressReverseCrossStreetOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface SearchGetSearchAddressReverseCrossStreetOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {number} [heading] The directional heading of the vehicle in
   * degrees, for travel along a segment of roadway. 0 is North, 90 is East and
   * so on, values range from -360 to 360. The precision can include upto one
   * decimal place
   */
  heading?: number;
  /**
   * @member {number} [radius] The radius in meters to for the results to be
   * constrained to the defined area
   */
  radius?: number;
  /**
   * @member {string} [language] Language in which search results should be
   * returned. Should be one of supported IETF language tags, case insensitive.
   * When data in specified language is not available for a specific field,
   * default language is used. Please refer to [Supported
   * Languages](https://docs.microsoft.com/en-us/azure/azure-maps/supported-languages)
   * for details.
   */
  language?: string;
}

/**
 * @interface
 * An interface representing SearchGetSearchAddressStructuredOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface SearchGetSearchAddressStructuredOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {string} [language] Language in which search results should be
   * returned. Should be one of supported IETF language tags, case insensitive.
   * When data in specified language is not available for a specific field,
   * default language is used. Please refer to [Supported
   * Languages](https://docs.microsoft.com/en-us/azure/azure-maps/supported-languages)
   * for details.
   */
  language?: string;
  /**
   * @member {number} [limit] Maximum number of responses that will be
   * returned. Default value: 10 .
   */
  limit?: number;
  /**
   * @member {number} [ofs] Starting offset of the returned results within the
   * full result set. Default value: 0 .
   */
  ofs?: number;
  /**
   * @member {string} [streetNumber] The street number portion of an address
   */
  streetNumber?: string;
  /**
   * @member {string} [streetName] The street name portion of an address
   */
  streetName?: string;
  /**
   * @member {string} [crossStreet] The cross street name for the structured
   * address
   */
  crossStreet?: string;
  /**
   * @member {string} [municipality] The municipality portion of an address
   */
  municipality?: string;
  /**
   * @member {string} [municipalitySubdivision] The municipality subdivision
   * (sub/super city) for the structured address
   */
  municipalitySubdivision?: string;
  /**
   * @member {string} [countryTertiarySubdivision] The named area for the
   * structured address
   */
  countryTertiarySubdivision?: string;
  /**
   * @member {string} [countrySecondarySubdivision] The county for the
   * structured address
   */
  countrySecondarySubdivision?: string;
  /**
   * @member {string} [countrySubdivision] The country subdividion portion of
   * an address
   */
  countrySubdivision?: string;
  /**
   * @member {string} [postalCode] The postal code portion of an address
   */
  postalCode?: string;
  /**
   * @member {string} [extendedPostalCodesFor] Indexes for which extended
   * postal codes should be included in the results.
   *
   * Available indexes are:
   *
   * **Addr** = Address ranges
   *
   * **Geo** = Geographies
   *
   * **PAD** = Point Addresses
   *
   * **POI** = Points of Interest
   *
   * **Str** = Streets
   *
   * **XStr** = Cross Streets (intersections)
   *
   * Value should be a comma separated list of index types (in any order) or
   * **None** for no indexes.
   *
   * By default extended postal codes are included for all indexes except Geo.
   * Extended postal code lists for geographies can be quite long so they have
   * to be explicitly requested when needed.
   *
   * Usage examples:
   *
   * extendedPostalCodesFor=POI
   *
   * extendedPostalCodesFor=PAD,Addr,POI
   *
   * extendedPostalCodesFor=None
   *
   * Extended postal code is returned as an **extendedPostalCode** property of
   * an address. Availability is region-dependent.
   */
  extendedPostalCodesFor?: string;
}

/**
 * @interface
 * An interface representing SearchPostSearchInsideGeometryOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface SearchPostSearchInsideGeometryOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {number} [limit] Maximum number of responses that will be
   * returned. Default: 10, minimum: 1 and maximum: 100. Default value: 10 .
   */
  limit?: number;
  /**
   * @member {string} [language] Language in which search results should be
   * returned. Should be one of supported IETF language tags, case insensitive.
   * When data in specified language is not available for a specific field,
   * default language is used. Please refer to [Supported
   * Languages](https://docs.microsoft.com/en-us/azure/azure-maps/supported-languages)
   * for details.
   */
  language?: string;
  /**
   * @member {string} [extendedPostalCodesFor] Indexes for which extended
   * postal codes should be included in the results.
   *
   * Available indexes are:
   *
   * **Addr** = Address ranges
   *
   * **Geo** = Geographies
   *
   * **PAD** = Point Addresses
   *
   * **POI** = Points of Interest
   *
   * **Str** = Streets
   *
   * **XStr** = Cross Streets (intersections)
   *
   * Value should be a comma separated list of index types (in any order) or
   * **None** for no indexes.
   *
   * By default extended postal codes are included for all indexes except Geo.
   * Extended postal code lists for geographies can be quite long so they have
   * to be explicitly requested when needed.
   *
   * Usage examples:
   *
   * extendedPostalCodesFor=POI
   *
   * extendedPostalCodesFor=PAD,Addr,POI
   *
   * extendedPostalCodesFor=None
   *
   * Extended postal code is returned as an **extendedPostalCode** property of
   * an address. Availability is region-dependent.
   */
  extendedPostalCodesFor?: string;
  /**
   * @member {SearchIndexSet[]} [idxSet] A comma separated list of indexes
   * which should be utilized for the search. Item order does not matter.
   * Available indexes are: Addr = Address range interpolation, Geo =
   * Geographies, PAD = Point Addresses, POI = Points of interest, Str =
   * Streets, Xstr = Cross Streets (intersections)
   */
  idxSet?: SearchIndexSet[];
}

/**
 * @interface
 * An interface representing SearchPostSearchAlongRouteOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface SearchPostSearchAlongRouteOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {number} [limit] Maximum number of responses that will be
   * returned. Default value is 10. Max value is 20. Default value: 10 .
   */
  limit?: number;
}

/**
 * @interface
 * An interface representing RouteGetRouteDirectionsOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface RouteGetRouteDirectionsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {number} [maxAlternatives] Number of desired alternative routes to
   * be calculated. Default: 0, minimum: 0 and maximum: 5. Default value: 0 .
   */
  maxAlternatives?: number;
  /**
   * @member {AlternativeRouteType} [alternativeType] Controls the optimality,
   * with respect to the given planning criteria, of the calculated
   * alternatives compared to the reference route. Possible values include:
   * 'anyRoute', 'betterRoute'. Default value: 'anyRoute' .
   */
  alternativeType?: AlternativeRouteType;
  /**
   * @member {number} [minDeviationDistance] All alternative routes returned
   * will follow the reference route (see section POST Requests) from the
   * origin point of the calculateRoute request for at least this number of
   * meters. Can only be used when reconstructing a route. The
   * minDeviationDistance parameter cannot be used in conjunction with
   * arriveAt. Default value: 0 .
   */
  minDeviationDistance?: number;
  /**
   * @member {Date} [arriveAt] The date and time of arrival at the destination
   * point. It must be specified as a dateTime. When a time zone offset is not
   * specified it will be assumed to be that of the destination point. The
   * arriveAt value must be in the future. The arriveAt parameter cannot be
   * used in conjunction with departAt, minDeviationDistance or
   * minDeviationTime.
   */
  arriveAt?: Date;
  /**
   * @member {Date} [departAt] The date and time of departure from the origin
   * point. Departure times apart from now must be specified as a dateTime.
   * When a time zone offset is not specified, it will be assumed to be that of
   * the origin point. The departAt value must be in the future in the
   * date-time format (1996-12-19T16:39:57-08:00).
   */
  departAt?: Date;
  /**
   * @member {number} [minDeviationTime] All alternative routes returned will
   * follow the reference route (see section POST Requests) from the origin
   * point of the calculateRoute request for at least this number of seconds.
   * Can only be used when reconstructing a route. The minDeviationTime
   * parameter cannot be used in conjunction with arriveAt. Default value: 0 .
   */
  minDeviationTime?: number;
  /**
   * @member {string} [language] The language parameter determines the language
   * of the guidance messages. It does not affect proper nouns (the names of
   * streets, plazas, etc.) It has no effect when instructionsType=coded.
   * Allowed values are (a subset of) the IETF language tags described
   */
  language?: string;
  /**
   * @member {boolean} [computeBestOrder] Re-order the route waypoints to
   * reduce the route length. Yields best results when used in conjunction with
   * routeType _shortest_. Possible values are true or false. True computes a
   * better order if possible, but is not allowed to be used in conjunction
   * with maxAlternatives value greater than 0 or in conjunction with circle
   * waypoints. The response will include the optimized waypoint indices and
   * can be used with a maximum of 20 route waypoints. False will use the
   * locations in the given order and not allowed to be used in conjunction
   * with routeRepresentation _none_. Default value: false .
   */
  computeBestOrder?: boolean;
  /**
   * @member {RouteRepresentation} [routeRepresentation] Specifies the
   * representation of the set of routes provided as response. This parameter
   * value can only be used in conjunction with computeBestOrder=true. Possible
   * values include: 'polyline', 'none'. Default value: 'polyline' .
   */
  routeRepresentation?: RouteRepresentation;
  /**
   * @member {ComputeTravelTimeFor} [computeTravelTimeFor] Specifies whether to
   * return additional travel times using different types of traffic
   * information (none, historic, live) as well as the default best-estimate
   * travel time. Possible values include: 'none', 'all'. Default value: 'none'
   * .
   */
  computeTravelTimeFor?: ComputeTravelTimeFor;
  /**
   * @member {number} [vehicleHeading] The directional heading of the vehicle
   * in degrees starting at true North and continuing in clockwise direction.
   * North is 0 degrees, east is 90 degrees, south is 180 degrees, west is 270
   * degrees. Possible values 0-359
   */
  vehicleHeading?: number;
  /**
   * @member {string} [report] Specifies which data should be reported for
   * diagnosis purposes. The only possible value is _effectiveSettings_.
   * Reports the effective parameters or data used when calling the API. In the
   * case of defaulted parameters the default will be reflected where the
   * parameter was not specified by the caller.
   */
  report?: string;
  /**
   * @member {SectionType} [sectionType] Specifies which of the section types
   * is reported in the route response. <br><br>For example if sectionType =
   * pedestrian the sections which are suited for pedestrians only are
   * returned. Multiple types can be used. The default sectionType refers to
   * the travelMode input. By default travelMode is set to car. Possible values
   * include: 'carTrain', 'country', 'ferry', 'motorway', 'pedestrian',
   * 'tollRoad', 'tollVignette', 'traffic', 'travelMode', 'tunnel'. Default
   * value: 'travelMode' .
   */
  sectionType?: SectionType;
  /**
   * @member {number} [vehicleAxleWeight] Weight per axle of the vehicle in kg.
   * A value of 0 means that weight restrictions per axle are not considered.
   * Default value: 0 .
   */
  vehicleAxleWeight?: number;
  /**
   * @member {number} [vehicleWidth] Width of the vehicle in meters. A value of
   * 0 means that width restrictions are not considered. Default value: 0 .
   */
  vehicleWidth?: number;
  /**
   * @member {number} [vehicleHeight] Height of the vehicle in meters. A value
   * of 0 means that height restrictions are not considered. Default value: 0 .
   */
  vehicleHeight?: number;
  /**
   * @member {number} [vehicleLength] Length of the vehicle in meters. A value
   * of 0 means that length restrictions are not considered. Default value: 0 .
   */
  vehicleLength?: number;
  /**
   * @member {number} [vehicleMaxSpeed] Maximum speed of the vehicle in
   * km/hour. A value of 0 means that an appropriate value for the vehicle will
   * be determined and applied during route planning. A non-zero value may be
   * overridden during route planning. Default value: 0 .
   */
  vehicleMaxSpeed?: number;
  /**
   * @member {number} [vehicleWeight] Weight of the vehicle in kilograms.
   *
   * * It is mandatory if any of the *Efficiency parameters are set.
   *
   * * It must be strictly positive when used in the context of the Consumption
   * Model. Weight restrictions are considered.
   *
   * * If no detailed **Consumption Model** is specified and the value of
   * **vehicleWeight** is non-zero, then weight restrictions are considered.
   *
   * * In all other cases, this parameter is ignored.
   *
   * Sensible Values : for **Combustion Model** : 1600, for **Electric Model**
   * : 1900. Default value: 0 .
   */
  vehicleWeight?: number;
  /**
   * @member {Windingness} [windingness] Level of turns for thrilling route.
   * This parameter can only be used in conjunction with routeType=thrilling.
   * Possible values include: 'low', 'normal', 'high'. Default value: 'normal'
   * .
   */
  windingness?: Windingness;
  /**
   * @member {Hilliness} [hilliness] Degree of hilliness for thrilling route.
   * This parameter can only be used in conjunction with `routeType`=thrilling.
   * Possible values include: 'low', 'normal', 'high'. Default value: 'normal'
   * .
   */
  hilliness?: Hilliness;
  /**
   * @member {TravelMode} [travelMode] The mode of travel for the requested
   * route. Note that the requested travelMode may not be available for the
   * entire route. Where the requested travelMode is not available for a
   * particular section, the travelMode element of the response for that
   * section will be other. Note that travel modes bus, motorcycle, taxi and
   * van are BETA functionality. Full restriction data is not available in all
   * areas. In calculateReachableRange requests, the values bicycle and
   * pedestrian must not be used. Possible values include: 'car', 'truck',
   * 'taxi', 'bus', 'van', 'motorcycle', 'bicycle', 'pedestrian'. Default
   * value: 'car' .
   */
  travelMode?: TravelMode;
  /**
   * @member {Avoid} [avoid] Specifies something that the route calculation
   * should try to avoid when determining the route. Can be specified multiple
   * times. Possible values: (tollRoads avoids toll roads), (motorways avoids
   * motorways), (ferries avoids ferries), (unpavedRoads avoids unpaved roads),
   * (carpools avoids routes that require use of carpool (HOV/ High Occupancy
   * Vehicle) lanes), (alreadyUsedRoads avoids using the same road multiple
   * times. Most useful in conjunction with routeType=thrilling). In
   * calculateReachableRange requests, the value alreadyUsedRoads must not be
   * used. Possible values include: 'tollRoads', 'motorways', 'ferries',
   * 'unpavedRoads', 'carpools', 'alreadyUsedRoads'
   */
  avoid?: Avoid;
  /**
   * @member {boolean} [traffic] Possible values:
   * * true - Do consider all available traffic information during routing
   * * false - Ignore current traffic data during routing. Note that although
   * the current traffic data is ignored during routing, the
   * effect of historic traffic on effective road speeds is still incorporated.
   * Default value: true .
   */
  traffic?: boolean;
  /**
   * @member {RouteType} [routeType] The type of route requested. Possible
   * values include: 'fastest', 'shortest', 'eco', 'thrilling'. Default value:
   * 'fastest' .
   */
  routeType?: RouteType;
  /**
   * @member {VehicleLoadType} [vehicleLoadType] Types of cargo that may be
   * classified as hazardous materials and restricted from some roads.
   * Available vehicleLoadType values are US Hazmat classes 1 through 9, plus
   * generic classifications for use in other countries. Values beginning with
   * USHazmat are for US routing while otherHazmat should be used for all other
   * countries. vehicleLoadType can be specified multiple times. This parameter
   * is currently only considered for travelMode=truck. Possible values
   * include: 'USHazmatClass1', 'USHazmatClass2', 'USHazmatClass3',
   * 'USHazmatClass4', 'USHazmatClass5', 'USHazmatClass6', 'USHazmatClass7',
   * 'USHazmatClass8', 'USHazmatClass9', 'otherHazmatExplosive',
   * 'otherHazmatGeneral', 'otherHazmatHarmfulToWater'
   */
  vehicleLoadType?: VehicleLoadType;
  /**
   * @member {VehicleEngineType} [vehicleEngineType] Engine type of the
   * vehicle. When a detailed Consumption Model is specified, it must be
   * consistent with the value of **vehicleEngineType**. Possible values
   * include: 'combustion', 'electric'. Default value: 'combustion' .
   */
  vehicleEngineType?: VehicleEngineType;
  /**
   * @member {number} [constantSpeedConsumptionInLitersPerHundredkm] Specifies
   * the speed-dependent component of consumption.
   *
   * Provided as an unordered list of colon-delimited speed & consumption-rate
   * pairs. The list defines points on a consumption curve. Consumption rates
   * for speeds not in the list are found as follows:
   *
   * * by linear interpolation, if the given speed lies in between two speeds
   * in the list
   *
   * * by linear extrapolation otherwise, assuming a constant
   * (ΔConsumption/ΔSpeed) determined by the nearest two points in the list
   *
   * The list must contain between 1 and 25 points (inclusive), and may not
   * contain duplicate points for the same speed. If it only contains a single
   * point, then the consumption rate of that point is used without further
   * processing.
   *
   * Consumption specified for the largest speed must be greater than or equal
   * to that of the penultimate largest speed. This ensures that extrapolation
   * does not lead to negative consumption rates.
   *
   * Similarly, consumption values specified for the two smallest speeds in the
   * list cannot lead to a negative consumption rate for any smaller speed.
   *
   * The valid range for the consumption values(expressed in l/100km) is
   * between 0.01 and 100000.0.
   *
   * Sensible Values : 50,6.3:130,11.5
   *
   * **Note** : This parameter is required for **The Combustion Consumption
   * Model**.
   */
  constantSpeedConsumptionInLitersPerHundredkm?: number;
  /**
   * @member {number} [currentFuelInLiters] Specifies the current supply of
   * fuel in liters.
   *
   * Sensible Values : 55
   */
  currentFuelInLiters?: number;
  /**
   * @member {number} [auxiliaryPowerInLitersPerHour] Specifies the amount of
   * fuel consumed for sustaining auxiliary systems of the vehicle, in liters
   * per hour.
   *
   * It can be used to specify consumption due to devices and systems such as
   * AC systems, radio, heating, etc.
   *
   * Sensible Values : 0.2
   */
  auxiliaryPowerInLitersPerHour?: number;
  /**
   * @member {number} [fuelEnergyDensityInMJoulesPerLiter] Specifies the amount
   * of chemical energy stored in one liter of fuel in megajoules (MJ). It is
   * used in conjunction with the ***Efficiency** parameters for conversions
   * between saved or consumed energy and fuel. For example, energy density is
   * 34.2 MJ/l for gasoline, and 35.8 MJ/l for Diesel fuel.
   *
   * This parameter is required if any ***Efficiency** parameter is set.
   *
   * Sensible Values : 34.2
   */
  fuelEnergyDensityInMJoulesPerLiter?: number;
  /**
   * @member {number} [accelerationEfficiency] Specifies the efficiency of
   * converting chemical energy stored in fuel to kinetic energy when the
   * vehicle accelerates _(i.e. KineticEnergyGained/ChemicalEnergyConsumed).
   * ChemicalEnergyConsumed_ is obtained by converting consumed fuel to
   * chemical energy using **fuelEnergyDensityInMJoulesPerLiter**.
   *
   * Must be paired with **decelerationEfficiency**.
   *
   * The range of values allowed are 0.0 to 1/**decelerationEfficiency**.
   *
   * Sensible Values : for **Combustion Model** : 0.33, for **Electric Model**
   * : 0.66
   */
  accelerationEfficiency?: number;
  /**
   * @member {number} [decelerationEfficiency] Specifies the efficiency of
   * converting kinetic energy to saved (not consumed) fuel when the vehicle
   * decelerates _(i.e. ChemicalEnergySaved/KineticEnergyLost).
   * ChemicalEnergySaved_ is obtained by converting saved (not consumed) fuel
   * to energy using **fuelEnergyDensityInMJoulesPerLiter**.
   *
   * Must be paired with **accelerationEfficiency**.
   *
   * The range of values allowed are 0.0 to 1/**accelerationEfficiency**.
   *
   * Sensible Values : for **Combustion Model** : 0.83, for **Electric Model**
   * : 0.91
   */
  decelerationEfficiency?: number;
  /**
   * @member {number} [uphillEfficiency] Specifies the efficiency of converting
   * chemical energy stored in fuel to potential energy when the vehicle gains
   * elevation _(i.e. PotentialEnergyGained/ChemicalEnergyConsumed).
   * ChemicalEnergyConsumed_ is obtained by converting consumed fuel to
   * chemical energy using **fuelEnergyDensityInMJoulesPerLiter**.
   *
   * Must be paired with **downhillEfficiency**.
   *
   * The range of values allowed are 0.0 to 1/**downhillEfficiency**.
   *
   * Sensible Values : for **Combustion Model** : 0.27, for **Electric Model**
   * : 0.74
   */
  uphillEfficiency?: number;
  /**
   * @member {number} [downhillEfficiency] Specifies the efficiency of
   * converting potential energy to saved (not consumed) fuel when the vehicle
   * loses elevation _(i.e.
   * ChemicalEnergySaved/PotentialEnergyLost).ChemicalEnergySaved_ is obtained
   * by converting saved (not consumed) fuel to energy using
   * **fuelEnergyDensityInMJoulesPerLiter**.
   *
   * Must be paired with **uphillEfficiency**.
   *
   * The range of values allowed are 0.0 to 1/**uphillEfficiency**.
   *
   * Sensible Values : for **Combustion Model** : 0.51, for **Electric Model**
   * : 0.73
   */
  downhillEfficiency?: number;
  /**
   * @member {number} [constantSpeedConsumptionInkWhPerHundredkm] Specifies the
   * speed-dependent component of consumption.
   *
   * Provided as an unordered list of speed/consumption-rate pairs. The list
   * defines points on a consumption curve. Consumption rates for speeds not in
   * the list are found as follows:
   *
   * * by linear interpolation, if the given speed lies in between two speeds
   * in the list
   *
   * * by linear extrapolation otherwise, assuming a constant
   * (ΔConsumption/ΔSpeed) determined by the nearest two points in the list
   *
   * The list must contain between 1 and 25 points (inclusive), and may not
   * contain duplicate points for the same speed. If it only contains a single
   * point, then the consumption rate of that point is used without further
   * processing.
   *
   * Consumption specified for the largest speed must be greater than or equal
   * to that of the penultimate largest speed. This ensures that extrapolation
   * does not lead to negative consumption rates.
   *
   * Similarly, consumption values specified for the two smallest speeds in the
   * list cannot lead to a negative consumption rate for any smaller  speed.
   *
   * The valid range for the consumption values(expressed in kWh/100km) is
   * between 0.01 and 100000.0.
   *
   * Sensible Values : 50,8.2:130,21.3
   *
   * This parameter is required for **Electric consumption model**.
   */
  constantSpeedConsumptionInkWhPerHundredkm?: number;
  /**
   * @member {string} [currentChargeInkWh] Specifies the current electric
   * energy supply in kilowatt hours (kWh).
   *
   * This parameter co-exists with **maxChargeInkWh** parameter.
   *
   * The range of values allowed are 0.0 to **maxChargeInkWh**.
   *
   * Sensible Values : 43
   */
  currentChargeInkWh?: string;
  /**
   * @member {string} [maxChargeInkWh] Specifies the maximum electric energy
   * supply in kilowatt hours (kWh) that may be stored in the vehicle's
   * battery.
   *
   * This parameter co-exists with **currentChargeInkWh** parameter.
   *
   * Minimum value has to be greater than or equal to **currentChargeInkWh**.
   *
   * Sensible Values : 85
   */
  maxChargeInkWh?: string;
  /**
   * @member {string} [auxiliaryPowerInkW] Specifies the amount of power
   * consumed for sustaining auxiliary systems, in kilowatts (kW).
   *
   * It can be used to specify consumption due to devices and systems such as
   * AC systems, radio, heating, etc.
   *
   * Sensible Values : 1.7
   */
  auxiliaryPowerInkW?: string;
}

/**
 * @interface
 * An interface representing RoutePostRouteDirectionsOptionalParams.
 * Optional Parameters.
 *
 * @extends RequestOptionsBase
 */
export interface RoutePostRouteDirectionsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * @member {number} [maxAlternatives] Number of desired alternative routes to
   * be calculated. Default: 0, minimum: 0 and maximum: 5. Default value: 0 .
   */
  maxAlternatives?: number;
  /**
   * @member {AlternativeRouteType} [alternativeType] Controls the optimality,
   * with respect to the given planning criteria, of the calculated
   * alternatives compared to the reference route. Possible values include:
   * 'anyRoute', 'betterRoute'. Default value: 'anyRoute' .
   */
  alternativeType?: AlternativeRouteType;
  /**
   * @member {number} [minDeviationDistance] All alternative routes returned
   * will follow the reference route (see section POST Requests) from the
   * origin point of the calculateRoute request for at least this number of
   * meters. Can only be used when reconstructing a route. The
   * minDeviationDistance parameter cannot be used in conjunction with
   * arriveAt. Default value: 0 .
   */
  minDeviationDistance?: number;
  /**
   * @member {number} [minDeviationTime] All alternative routes returned will
   * follow the reference route (see section POST Requests) from the origin
   * point of the calculateRoute request for at least this number of seconds.
   * Can only be used when reconstructing a route. The minDeviationTime
   * parameter cannot be used in conjunction with arriveAt. Default value: 0 .
   */
  minDeviationTime?: number;
  /**
   * @member {string} [language] The language parameter determines the language
   * of the guidance messages. It does not affect proper nouns (the names of
   * streets, plazas, etc.) It has no effect when instructionsType=coded.
   * Allowed values are (a subset of) the IETF language tags described
   */
  language?: string;
  /**
   * @member {boolean} [computeBestOrder] Re-order the route waypoints to
   * reduce the route length. Yields best results when used in conjunction with
   * routeType _shortest_. Possible values are true or false. True computes a
   * better order if possible, but is not allowed to be used in conjunction
   * with maxAlternatives value greater than 0 or in conjunction with circle
   * waypoints. The response will include the optimized waypoint indices and
   * can be used with a maximum of 20 route waypoints. False will use the
   * locations in the given order and not allowed to be used in conjunction
   * with routeRepresentation _none_. Default value: false .
   */
  computeBestOrder?: boolean;
  /**
   * @member {RouteRepresentation} [routeRepresentation] Specifies the
   * representation of the set of routes provided as response. This parameter
   * value can only be used in conjunction with computeBestOrder=true. Possible
   * values include: 'polyline', 'none'. Default value: 'polyline' .
   */
  routeRepresentation?: RouteRepresentation;
  /**
   * @member {ComputeTravelTimeFor} [computeTravelTimeFor] Specifies whether to
   * return additional travel times using different types of traffic
   * information (none, historic, live) as well as the default best-estimate
   * travel time. Possible values include: 'none', 'all'. Default value: 'none'
   * .
   */
  computeTravelTimeFor?: ComputeTravelTimeFor;
  /**
   * @member {number} [vehicleHeading] The directional heading of the vehicle
   * in degrees starting at true North and continuing in clockwise direction.
   * North is 0 degrees, east is 90 degrees, south is 180 degrees, west is 270
   * degrees. Possible values 0-359
   */
  vehicleHeading?: number;
  /**
   * @member {string} [report] Specifies which data should be reported for
   * diagnosis purposes. The only possible value is _effectiveSettings_.
   * Reports the effective parameters or data used when calling the API. In the
   * case of defaulted parameters the default will be reflected where the
   * parameter was not specified by the caller.
   */
  report?: string;
  /**
   * @member {SectionType} [sectionType] Specifies which of the section types
   * is reported in the route response. <br><br>For example if sectionType =
   * pedestrian the sections which are suited for pedestrians only are
   * returned. Multiple types can be used. The default sectionType refers to
   * the travelMode input. By default travelMode is set to car. Possible values
   * include: 'carTrain', 'country', 'ferry', 'motorway', 'pedestrian',
   * 'tollRoad', 'tollVignette', 'traffic', 'travelMode', 'tunnel'. Default
   * value: 'travelMode' .
   */
  sectionType?: SectionType;
  /**
   * @member {Date} [arriveAt] The date and time of arrival at the destination
   * point. It must be specified as a dateTime. When a time zone offset is not
   * specified it will be assumed to be that of the destination point. The
   * arriveAt value must be in the future. The arriveAt parameter cannot be
   * used in conjunction with departAt, minDeviationDistance or
   * minDeviationTime.
   */
  arriveAt?: Date;
  /**
   * @member {Date} [departAt] The date and time of departure from the origin
   * point. Departure times apart from now must be specified as a dateTime.
   * When a time zone offset is not specified, it will be assumed to be that of
   * the origin point. The departAt value must be in the future in the
   * date-time format (1996-12-19T16:39:57-08:00).
   */
  departAt?: Date;
  /**
   * @member {number} [vehicleAxleWeight] Weight per axle of the vehicle in kg.
   * A value of 0 means that weight restrictions per axle are not considered.
   * Default value: 0 .
   */
  vehicleAxleWeight?: number;
  /**
   * @member {number} [vehicleLength] Length of the vehicle in meters. A value
   * of 0 means that length restrictions are not considered. Default value: 0 .
   */
  vehicleLength?: number;
  /**
   * @member {number} [vehicleHeight] Height of the vehicle in meters. A value
   * of 0 means that height restrictions are not considered. Default value: 0 .
   */
  vehicleHeight?: number;
  /**
   * @member {number} [vehicleWidth] Width of the vehicle in meters. A value of
   * 0 means that width restrictions are not considered. Default value: 0 .
   */
  vehicleWidth?: number;
  /**
   * @member {number} [vehicleMaxSpeed] Maximum speed of the vehicle in
   * km/hour. A value of 0 means that an appropriate value for the vehicle will
   * be determined and applied during route planning. A non-zero value may be
   * overridden during route planning. Default value: 0 .
   */
  vehicleMaxSpeed?: number;
  /**
   * @member {number} [vehicleWeight] Weight of the vehicle in kilograms.
   *
   * * It is mandatory if any of the *Efficiency parameters are set.
   *
   * * It must be strictly positive when used in the context of the Consumption
   * Model. Weight restrictions are considered.
   *
   * * If no detailed **Consumption Model** is specified and the value of
   * **vehicleWeight** is non-zero, then weight restrictions are considered.
   *
   * * In all other cases, this parameter is ignored.
   *
   * Sensible Values : for **Combustion Model** : 1600, for **Electric Model**
   * : 1900. Default value: 0 .
   */
  vehicleWeight?: number;
  /**
   * @member {Windingness} [windingness] Level of turns for thrilling route.
   * This parameter can only be used in conjunction with routeType=thrilling.
   * Possible values include: 'low', 'normal', 'high'. Default value: 'normal'
   * .
   */
  windingness?: Windingness;
  /**
   * @member {Hilliness} [hilliness] Degree of hilliness for thrilling route.
   * This parameter can only be used in conjunction with `routeType`=thrilling.
   * Possible values include: 'low', 'normal', 'high'. Default value: 'normal'
   * .
   */
  hilliness?: Hilliness;
  /**
   * @member {TravelMode} [travelMode] The mode of travel for the requested
   * route. Note that the requested travelMode may not be available for the
   * entire route. Where the requested travelMode is not available for a
   * particular section, the travelMode element of the response for that
   * section will be other. Note that travel modes bus, motorcycle, taxi and
   * van are BETA functionality. Full restriction data is not available in all
   * areas. In calculateReachableRange requests, the values bicycle and
   * pedestrian must not be used. Possible values include: 'car', 'truck',
   * 'taxi', 'bus', 'van', 'motorcycle', 'bicycle', 'pedestrian'. Default
   * value: 'car' .
   */
  travelMode?: TravelMode;
  /**
   * @member {Avoid} [avoid] Specifies something that the route calculation
   * should try to avoid when determining the route. Can be specified multiple
   * times. Possible values: (tollRoads avoids toll roads), (motorways avoids
   * motorways), (ferries avoids ferries), (unpavedRoads avoids unpaved roads),
   * (carpools avoids routes that require use of carpool (HOV/ High Occupancy
   * Vehicle) lanes), (alreadyUsedRoads avoids using the same road multiple
   * times. Most useful in conjunction with routeType=thrilling). In
   * calculateReachableRange requests, the value alreadyUsedRoads must not be
   * used. Possible values include: 'tollRoads', 'motorways', 'ferries',
   * 'unpavedRoads', 'carpools', 'alreadyUsedRoads'
   */
  avoid?: Avoid;
  /**
   * @member {boolean} [traffic] Possible values:
   * * true - Do consider all available traffic information during routing
   * * false - Ignore current traffic data during routing. Note that although
   * the current traffic data is ignored during routing, the
   * effect of historic traffic on effective road speeds is still incorporated.
   * Default value: true .
   */
  traffic?: boolean;
  /**
   * @member {RouteType} [routeType] The type of route requested. Possible
   * values include: 'fastest', 'shortest', 'eco', 'thrilling'. Default value:
   * 'fastest' .
   */
  routeType?: RouteType;
  /**
   * @member {VehicleLoadType} [vehicleLoadType] Types of cargo that may be
   * classified as hazardous materials and restricted from some roads.
   * Available vehicleLoadType values are US Hazmat classes 1 through 9, plus
   * generic classifications for use in other countries. Values beginning with
   * USHazmat are for US routing while otherHazmat should be used for all other
   * countries. vehicleLoadType can be specified multiple times. This parameter
   * is currently only considered for travelMode=truck. Possible values
   * include: 'USHazmatClass1', 'USHazmatClass2', 'USHazmatClass3',
   * 'USHazmatClass4', 'USHazmatClass5', 'USHazmatClass6', 'USHazmatClass7',
   * 'USHazmatClass8', 'USHazmatClass9', 'otherHazmatExplosive',
   * 'otherHazmatGeneral', 'otherHazmatHarmfulToWater'
   */
  vehicleLoadType?: VehicleLoadType;
  /**
   * @member {VehicleEngineType} [vehicleEngineType] Engine type of the
   * vehicle. When a detailed Consumption Model is specified, it must be
   * consistent with the value of **vehicleEngineType**. Possible values
   * include: 'combustion', 'electric'. Default value: 'combustion' .
   */
  vehicleEngineType?: VehicleEngineType;
  /**
   * @member {number} [constantSpeedConsumptionInLitersPerHundredkm] Specifies
   * the speed-dependent component of consumption.
   *
   * Provided as an unordered list of colon-delimited speed & consumption-rate
   * pairs. The list defines points on a consumption curve. Consumption rates
   * for speeds not in the list are found as follows:
   *
   * * by linear interpolation, if the given speed lies in between two speeds
   * in the list
   *
   * * by linear extrapolation otherwise, assuming a constant
   * (ΔConsumption/ΔSpeed) determined by the nearest two points in the list
   *
   * The list must contain between 1 and 25 points (inclusive), and may not
   * contain duplicate points for the same speed. If it only contains a single
   * point, then the consumption rate of that point is used without further
   * processing.
   *
   * Consumption specified for the largest speed must be greater than or equal
   * to that of the penultimate largest speed. This ensures that extrapolation
   * does not lead to negative consumption rates.
   *
   * Similarly, consumption values specified for the two smallest speeds in the
   * list cannot lead to a negative consumption rate for any smaller speed.
   *
   * The valid range for the consumption values(expressed in l/100km) is
   * between 0.01 and 100000.0.
   *
   * Sensible Values : 50,6.3:130,11.5
   *
   * **Note** : This parameter is required for **The Combustion Consumption
   * Model**.
   */
  constantSpeedConsumptionInLitersPerHundredkm?: number;
  /**
   * @member {number} [currentFuelInLiters] Specifies the current supply of
   * fuel in liters.
   *
   * Sensible Values : 55
   */
  currentFuelInLiters?: number;
  /**
   * @member {number} [auxiliaryPowerInLitersPerHour] Specifies the amount of
   * fuel consumed for sustaining auxiliary systems of the vehicle, in liters
   * per hour.
   *
   * It can be used to specify consumption due to devices and systems such as
   * AC systems, radio, heating, etc.
   *
   * Sensible Values : 0.2
   */
  auxiliaryPowerInLitersPerHour?: number;
  /**
   * @member {number} [fuelEnergyDensityInMJoulesPerLiter] Specifies the amount
   * of chemical energy stored in one liter of fuel in megajoules (MJ). It is
   * used in conjunction with the ***Efficiency** parameters for conversions
   * between saved or consumed energy and fuel. For example, energy density is
   * 34.2 MJ/l for gasoline, and 35.8 MJ/l for Diesel fuel.
   *
   * This parameter is required if any ***Efficiency** parameter is set.
   *
   * Sensible Values : 34.2
   */
  fuelEnergyDensityInMJoulesPerLiter?: number;
  /**
   * @member {number} [accelerationEfficiency] Specifies the efficiency of
   * converting chemical energy stored in fuel to kinetic energy when the
   * vehicle accelerates _(i.e. KineticEnergyGained/ChemicalEnergyConsumed).
   * ChemicalEnergyConsumed_ is obtained by converting consumed fuel to
   * chemical energy using **fuelEnergyDensityInMJoulesPerLiter**.
   *
   * Must be paired with **decelerationEfficiency**.
   *
   * The range of values allowed are 0.0 to 1/**decelerationEfficiency**.
   *
   * Sensible Values : for **Combustion Model** : 0.33, for **Electric Model**
   * : 0.66
   */
  accelerationEfficiency?: number;
  /**
   * @member {number} [decelerationEfficiency] Specifies the efficiency of
   * converting kinetic energy to saved (not consumed) fuel when the vehicle
   * decelerates _(i.e. ChemicalEnergySaved/KineticEnergyLost).
   * ChemicalEnergySaved_ is obtained by converting saved (not consumed) fuel
   * to energy using **fuelEnergyDensityInMJoulesPerLiter**.
   *
   * Must be paired with **accelerationEfficiency**.
   *
   * The range of values allowed are 0.0 to 1/**accelerationEfficiency**.
   *
   * Sensible Values : for **Combustion Model** : 0.83, for **Electric Model**
   * : 0.91
   */
  decelerationEfficiency?: number;
  /**
   * @member {number} [uphillEfficiency] Specifies the efficiency of converting
   * chemical energy stored in fuel to potential energy when the vehicle gains
   * elevation _(i.e. PotentialEnergyGained/ChemicalEnergyConsumed).
   * ChemicalEnergyConsumed_ is obtained by converting consumed fuel to
   * chemical energy using **fuelEnergyDensityInMJoulesPerLiter**.
   *
   * Must be paired with **downhillEfficiency**.
   *
   * The range of values allowed are 0.0 to 1/**downhillEfficiency**.
   *
   * Sensible Values : for **Combustion Model** : 0.27, for **Electric Model**
   * : 0.74
   */
  uphillEfficiency?: number;
  /**
   * @member {number} [downhillEfficiency] Specifies the efficiency of
   * converting potential energy to saved (not consumed) fuel when the vehicle
   * loses elevation _(i.e.
   * ChemicalEnergySaved/PotentialEnergyLost).ChemicalEnergySaved_ is obtained
   * by converting saved (not consumed) fuel to energy using
   * **fuelEnergyDensityInMJoulesPerLiter**.
   *
   * Must be paired with **uphillEfficiency**.
   *
   * The range of values allowed are 0.0 to 1/**uphillEfficiency**.
   *
   * Sensible Values : for **Combustion Model** : 0.51, for **Electric Model**
   * : 0.73
   */
  downhillEfficiency?: number;
  /**
   * @member {number} [constantSpeedConsumptionInkWhPerHundredkm] Specifies the
   * speed-dependent component of consumption.
   *
   * Provided as an unordered list of speed/consumption-rate pairs. The list
   * defines points on a consumption curve. Consumption rates for speeds not in
   * the list are found as follows:
   *
   * * by linear interpolation, if the given speed lies in between two speeds
   * in the list
   *
   * * by linear extrapolation otherwise, assuming a constant
   * (ΔConsumption/ΔSpeed) determined by the nearest two points in the list
   *
   * The list must contain between 1 and 25 points (inclusive), and may not
   * contain duplicate points for the same speed. If it only contains a single
   * point, then the consumption rate of that point is used without further
   * processing.
   *
   * Consumption specified for the largest speed must be greater than or equal
   * to that of the penultimate largest speed. This ensures that extrapolation
   * does not lead to negative consumption rates.
   *
   * Similarly, consumption values specified for the two smallest speeds in the
   * list cannot lead to a negative consumption rate for any smaller  speed.
   *
   * The valid range for the consumption values(expressed in kWh/100km) is
   * between 0.01 and 100000.0.
   *
   * Sensible Values : 50,8.2:130,21.3
   *
   * This parameter is required for **Electric consumption model**.
   */
  constantSpeedConsumptionInkWhPerHundredkm?: number;
  /**
   * @member {string} [currentChargeInkWh] Specifies the current electric
   * energy supply in kilowatt hours (kWh).
   *
   * This parameter co-exists with **maxChargeInkWh** parameter.
   *
   * The range of values allowed are 0.0 to **maxChargeInkWh**.
   *
   * Sensible Values : 43
   */
  currentChargeInkWh?: string;
  /**
   * @member {string} [maxChargeInkWh] Specifies the maximum electric energy
   * supply in kilowatt hours (kWh) that may be stored in the vehicle's
   * battery.
   *
   * This parameter co-exists with **currentChargeInkWh** parameter.
   *
   * Minimum value has to be greater than or equal to **currentChargeInkWh**.
   *
   * Sensible Values : 85
   */
  maxChargeInkWh?: string;
  /**
   * @member {string} [auxiliaryPowerInkW] Specifies the amount of power
   * consumed for sustaining auxiliary systems, in kilowatts (kW).
   *
   * It can be used to specify consumption due to devices and systems such as
   * AC systems, radio, heating, etc.
   *
   * Sensible Values : 1.7
   */
  auxiliaryPowerInkW?: string;
  /**
   * @member {GeoJSONFeatureCollection} [coordinateList] The Coordinates
   * through which the route is calculated. Needs two coordinates at least.
   * First one is the origin and the last is the destination of the route.
   * Optional coordinates in between act as WayPoints in the route.
   */
  coordinateList?: GeoJSONFeatureCollection;
}

/**
 * Defines values for GeoJSONGeometryType.
 * Possible values include: 'Point', 'MultiPoint', 'LineString',
 * 'MultiLineString', 'Polygon', 'MultiPolygon', 'GeometryCollection'
 * @readonly
 * @enum {string}
 */
export enum GeoJSONGeometryType {
  /**
   * `GeoJSON Point` geometry.
   */
  Point = 'Point',
  /**
   * `GeoJSON MultiPoint` geometry.
   */
  MultiPoint = 'MultiPoint',
  /**
   * `GeoJSON LineString` geometry.
   */
  LineString = 'LineString',
  /**
   * `GeoJSON MultiLineString` geometry.
   */
  MultiLineString = 'MultiLineString',
  /**
   * `GeoJSON Polygon` geometry.
   */
  Polygon = 'Polygon',
  /**
   * `GeoJSON MultiPolygon` geometry.
   */
  MultiPolygon = 'MultiPolygon',
  /**
   * `GeoJSON GeometryCollection` geometry.
   */
  GeometryCollection = 'GeometryCollection',
}

/**
 * Defines values for MagnitudeOfDelay.
 * Possible values include: '0', '1', '2', '3', '4'
 * @readonly
 * @enum {string}
 */
export enum MagnitudeOfDelay {
  /**
   * Unknown.
   */
  Zero = '0',
  /**
   * Minor.
   */
  One = '1',
  /**
   * Moderate.
   */
  Two = '2',
  /**
   * Major.
   */
  Three = '3',
  /**
   * Undefined, used for road closures and other indefinite delays.
   */
  Four = '4',
}

/**
 * Defines values for GuidanceInstructionType.
 * Possible values include: 'TURN', 'ROAD_CHANGE', 'LOCATION_DEPARTURE',
 * 'LOCATION_ARRIVAL', 'DIRECTION_INFO', 'LOCATION_WAYPOINT'
 * @readonly
 * @enum {string}
 */
export enum GuidanceInstructionType {
  /**
   * Turn.
   */
  TURN = 'TURN',
  /**
   * Road Change.
   */
  ROADCHANGE = 'ROAD_CHANGE',
  /**
   * Departure location.
   */
  LOCATIONDEPARTURE = 'LOCATION_DEPARTURE',
  /**
   * Arrival location.
   */
  LOCATIONARRIVAL = 'LOCATION_ARRIVAL',
  /**
   * Direction information.
   */
  DIRECTIONINFO = 'DIRECTION_INFO',
  /**
   * Way point location.
   */
  LOCATIONWAYPOINT = 'LOCATION_WAYPOINT',
}

/**
 * Defines values for DrivingSide.
 * Possible values include: 'LEFT', 'RIGHT'
 * @readonly
 * @enum {string}
 */
export enum DrivingSide {
  /**
   * Left side.
   */
  LEFT = 'LEFT',
  /**
   * Right side.
   */
  RIGHT = 'RIGHT',
}

/**
 * Defines values for GuidanceManeuver.
 * Possible values include: 'ARRIVE', 'ARRIVE_LEFT', 'ARRIVE_RIGHT', 'DEPART',
 * 'STRAIGHT', 'KEEP_RIGHT', 'BEAR_RIGHT', 'TURN_RIGHT', 'SHARP_RIGHT',
 * 'KEEP_LEFT', 'BEAR_LEFT', 'TURN_LEFT', 'SHARP_LEFT', 'MAKE_UTURN',
 * 'ENTER_MOTORWAY', 'ENTER_FREEWAY', 'ENTER_HIGHWAY', 'TAKE_EXIT',
 * 'MOTORWAY_EXIT_LEFT', 'MOTORWAY_EXIT_RIGHT', 'TAKE_FERRY',
 * 'ROUNDABOUT_CROSS', 'ROUNDABOUT_RIGHT', 'ROUNDABOUT_LEFT',
 * 'ROUNDABOUT_BACK', 'TRY_MAKE_UTURN', 'FOLLOW', 'SWITCH_PARALLEL_ROAD',
 * 'SWITCH_MAIN_ROAD', 'ENTRANCE_RAMP', 'WAYPOINT_LEFT', 'WAYPOINT_RIGHT',
 * 'WAYPOINT_REACHED'
 * @readonly
 * @enum {string}
 */
export enum GuidanceManeuver {
  /**
   * You have arrived.
   */
  ARRIVE = 'ARRIVE',
  /**
   * You have arrived. Your destination is on the left.
   */
  ARRIVELEFT = 'ARRIVE_LEFT',
  /**
   * You have arrived. Your destination is on the right.
   */
  ARRIVERIGHT = 'ARRIVE_RIGHT',
  /**
   * Leave.
   */
  DEPART = 'DEPART',
  /**
   * Keep straight on.
   */
  STRAIGHT = 'STRAIGHT',
  /**
   * Keep right.
   */
  KEEPRIGHT = 'KEEP_RIGHT',
  /**
   * Bear right.
   */
  BEARRIGHT = 'BEAR_RIGHT',
  /**
   * Turn right.
   */
  TURNRIGHT = 'TURN_RIGHT',
  /**
   * Turn sharp right.
   */
  SHARPRIGHT = 'SHARP_RIGHT',
  /**
   * Keep left.
   */
  KEEPLEFT = 'KEEP_LEFT',
  /**
   * Bear left.
   */
  BEARLEFT = 'BEAR_LEFT',
  /**
   * Turn left.
   */
  TURNLEFT = 'TURN_LEFT',
  /**
   * Turn sharp left.
   */
  SHARPLEFT = 'SHARP_LEFT',
  /**
   * Make a U-turn.
   */
  MAKEUTURN = 'MAKE_UTURN',
  /**
   * Take the motorway.
   */
  ENTERMOTORWAY = 'ENTER_MOTORWAY',
  /**
   * Take the freeway.
   */
  ENTERFREEWAY = 'ENTER_FREEWAY',
  /**
   * Take the highway.
   */
  ENTERHIGHWAY = 'ENTER_HIGHWAY',
  /**
   * Take the exit.
   */
  TAKEEXIT = 'TAKE_EXIT',
  /**
   * Take the left exit.
   */
  MOTORWAYEXITLEFT = 'MOTORWAY_EXIT_LEFT',
  /**
   * Take the right exit.
   */
  MOTORWAYEXITRIGHT = 'MOTORWAY_EXIT_RIGHT',
  /**
   * Take the ferry.
   */
  TAKEFERRY = 'TAKE_FERRY',
  /**
   * Cross the roundabout.
   */
  ROUNDABOUTCROSS = 'ROUNDABOUT_CROSS',
  /**
   * At the roundabout take the exit on the right.
   */
  ROUNDABOUTRIGHT = 'ROUNDABOUT_RIGHT',
  /**
   * At the roundabout take the exit on the left.
   */
  ROUNDABOUTLEFT = 'ROUNDABOUT_LEFT',
  /**
   * Go around the roundabout.
   */
  ROUNDABOUTBACK = 'ROUNDABOUT_BACK',
  /**
   * Try to make a U-turn.
   */
  TRYMAKEUTURN = 'TRY_MAKE_UTURN',
  /**
   * Follow.
   */
  FOLLOW = 'FOLLOW',
  /**
   * Switch to the parallel road.
   */
  SWITCHPARALLELROAD = 'SWITCH_PARALLEL_ROAD',
  /**
   * Switch to the main road.
   */
  SWITCHMAINROAD = 'SWITCH_MAIN_ROAD',
  /**
   * Take the ramp.
   */
  ENTRANCERAMP = 'ENTRANCE_RAMP',
  /**
   * You have reached the waypoint. It is on the left.
   */
  WAYPOINTLEFT = 'WAYPOINT_LEFT',
  /**
   * You have reached the waypoint. It is on the right.
   */
  WAYPOINTRIGHT = 'WAYPOINT_RIGHT',
  /**
   * You have reached the waypoint.
   */
  WAYPOINTREACHED = 'WAYPOINT_REACHED',
}

/**
 * Defines values for JsonFormat.
 * Possible values include: 'json'
 * @readonly
 * @enum {string}
 */
export enum JsonFormat {
  /**
   * [The JavaScript Object Notation Data Interchange
   * Format](https://tools.ietf.org/html/rfc8259)
   */
  Json = 'json',
}

/**
 * Defines values for SearchIndexSet.
 * Possible values include: 'Addr', 'Geo', 'PAD', 'POI', 'Str', 'Xstr'
 * @readonly
 * @enum {string}
 */
export enum SearchIndexSet {
  /**
   * Address range interpolation
   */
  Addr = 'Addr',
  /**
   * Geographies
   */
  Geo = 'Geo',
  /**
   * Point Addresses
   */
  PAD = 'PAD',
  /**
   * Points of interest
   */
  POI = 'POI',
  /**
   * Streets
   */
  Str = 'Str',
  /**
   * Cross Streets (Intersections)
   */
  Xstr = 'Xstr',
}

/**
 * Defines values for VehicleLoadType.
 * Possible values include: 'USHazmatClass1', 'USHazmatClass2',
 * 'USHazmatClass3', 'USHazmatClass4', 'USHazmatClass5', 'USHazmatClass6',
 * 'USHazmatClass7', 'USHazmatClass8', 'USHazmatClass9',
 * 'otherHazmatExplosive', 'otherHazmatGeneral', 'otherHazmatHarmfulToWater'
 * @readonly
 * @enum {string}
 */
export enum VehicleLoadType {
  /**
   * Explosives
   */
  USHazmatClass1 = 'USHazmatClass1',
  /**
   * Compressed gas
   */
  USHazmatClass2 = 'USHazmatClass2',
  /**
   * Flammable liquids
   */
  USHazmatClass3 = 'USHazmatClass3',
  /**
   * Flammable solids
   */
  USHazmatClass4 = 'USHazmatClass4',
  /**
   * Oxidizers
   */
  USHazmatClass5 = 'USHazmatClass5',
  /**
   * Poisons
   */
  USHazmatClass6 = 'USHazmatClass6',
  /**
   * Radioactive
   */
  USHazmatClass7 = 'USHazmatClass7',
  /**
   * Corrosives
   */
  USHazmatClass8 = 'USHazmatClass8',
  /**
   * Miscellaneous
   */
  USHazmatClass9 = 'USHazmatClass9',
  /**
   * Explosives
   */
  OtherHazmatExplosive = 'otherHazmatExplosive',
  /**
   * Miscellaneous
   */
  OtherHazmatGeneral = 'otherHazmatGeneral',
  /**
   * Harmful to water
   */
  OtherHazmatHarmfulToWater = 'otherHazmatHarmfulToWater',
}

/**
 * Defines values for RouteType.
 * Possible values include: 'fastest', 'shortest', 'eco', 'thrilling'
 * @readonly
 * @enum {string}
 */
export enum RouteType {
  /**
   * The fastest route.
   */
  Fastest = 'fastest',
  /**
   * The shortest route by distance.
   */
  Shortest = 'shortest',
  /**
   * A route balanced by economy and speed.
   */
  Eco = 'eco',
  /**
   * Includes interesting or challenging roads and uses as few motorways as
   * possible. You can choose the level of turns included and also the degree
   * of hilliness. See the hilliness and windingness parameters for how to set
   * this. There is a limit of 900 km on routes planned with
   * routeType=thrilling
   */
  Thrilling = 'thrilling',
}

/**
 * Defines values for Windingness.
 * Possible values include: 'low', 'normal', 'high'
 * @readonly
 * @enum {string}
 */
export enum Windingness {
  /**
   * low
   */
  Low = 'low',
  /**
   * normal
   */
  Normal = 'normal',
  /**
   * high
   */
  High = 'high',
}

/**
 * Defines values for Hilliness.
 * Possible values include: 'low', 'normal', 'high'
 * @readonly
 * @enum {string}
 */
export enum Hilliness {
  /**
   * low
   */
  Low = 'low',
  /**
   * normal
   */
  Normal = 'normal',
  /**
   * high
   */
  High = 'high',
}

/**
 * Defines values for TravelMode.
 * Possible values include: 'car', 'truck', 'taxi', 'bus', 'van', 'motorcycle',
 * 'bicycle', 'pedestrian'
 * @readonly
 * @enum {string}
 */
export enum TravelMode {
  /**
   * car
   */
  Car = 'car',
  /**
   * truck
   */
  Truck = 'truck',
  /**
   * taxi
   */
  Taxi = 'taxi',
  /**
   * bus
   */
  Bus = 'bus',
  /**
   * van
   */
  Van = 'van',
  /**
   * motorcycle
   */
  Motorcycle = 'motorcycle',
  /**
   * bicycle
   */
  Bicycle = 'bicycle',
  /**
   * pedestrian
   */
  Pedestrian = 'pedestrian',
}

/**
 * Defines values for Avoid.
 * Possible values include: 'tollRoads', 'motorways', 'ferries',
 * 'unpavedRoads', 'carpools', 'alreadyUsedRoads'
 * @readonly
 * @enum {string}
 */
export enum Avoid {
  /**
   * Avoids toll roads.
   */
  TollRoads = 'tollRoads',
  /**
   * Avoids motorways
   */
  Motorways = 'motorways',
  /**
   * Avoids ferries
   */
  Ferries = 'ferries',
  /**
   * Avoids unpaved roads
   */
  UnpavedRoads = 'unpavedRoads',
  /**
   * Avoids carpools
   */
  Carpools = 'carpools',
  /**
   * Avoids using the same road multiple times. Most useful in conjunction with
   * `routeType`=thrilling.
   */
  AlreadyUsedRoads = 'alreadyUsedRoads',
}

/**
 * Defines values for VehicleEngineType.
 * Possible values include: 'combustion', 'electric'
 * @readonly
 * @enum {string}
 */
export enum VehicleEngineType {
  /**
   * Internal combustion engine.
   */
  Combustion = 'combustion',
  /**
   * Electric engine.
   */
  Electric = 'electric',
}

/**
 * Defines values for SectionType.
 * Possible values include: 'carTrain', 'country', 'ferry', 'motorway',
 * 'pedestrian', 'tollRoad', 'tollVignette', 'traffic', 'travelMode', 'tunnel'
 * @readonly
 * @enum {string}
 */
export enum SectionType {
  /**
   * Get sections if the route includes car trains.
   */
  CarTrain = 'carTrain',
  /**
   * Countries the route has parts in.
   */
  Country = 'country',
  /**
   * Get sections if the route includes ferries.
   */
  Ferry = 'ferry',
  /**
   * Get sections if the route includes motorways.
   */
  Motorway = 'motorway',
  /**
   * Get sections which are suited for pedestrians.
   */
  Pedestrian = 'pedestrian',
  /**
   * Get sections which require a toll to be payed.
   */
  TollRoad = 'tollRoad',
  /**
   * Get sections which require a toll vignette to be present.
   */
  TollVignette = 'tollVignette',
  /**
   * Get sections which contain traffic information.
   */
  Traffic = 'traffic',
  /**
   * Get sections in relation to the request parameter `travelMode`.
   */
  TravelMode = 'travelMode',
  /**
   * Get sections if the route includes tunnels.
   */
  Tunnel = 'tunnel',
}

/**
 * Defines values for RouteRepresentation.
 * Possible values include: 'polyline', 'none'
 * @readonly
 * @enum {string}
 */
export enum RouteRepresentation {
  /**
   * Includes route geometry in the response.
   */
  Polyline = 'polyline',
  /**
   * Includes only the optimized waypoint indices but does not include the
   * route geometry in the response.
   */
  None = 'none',
}

/**
 * Defines values for ComputeTravelTimeFor.
 * Possible values include: 'none', 'all'
 * @readonly
 * @enum {string}
 */
export enum ComputeTravelTimeFor {
  /**
   * Does not compute additional travel times.
   */
  None = 'none',
  /**
   * Computes travel times for all types of traffic information and specifies
   * all results in the fields noTrafficTravelTimeInSeconds,
   * historicTrafficTravelTimeInSeconds and
   * liveTrafficIncidentsTravelTimeInSeconds being included in the summaries in
   * the route response.
   */
  All = 'all',
}

/**
 * Defines values for AlternativeRouteType.
 * Possible values include: 'anyRoute', 'betterRoute'
 * @readonly
 * @enum {string}
 */
export enum AlternativeRouteType {
  /**
   * Allow any alternative route to be returned irrespective of how it compares
   * to the reference route in terms of optimality.
   */
  AnyRoute = 'anyRoute',
  /**
   * Return an alternative route only if it is better than the reference route
   * according to the given planning criteria.
   */
  BetterRoute = 'betterRoute',
}

/**
 * Defines values for RouteInstructionsType.
 * Possible values include: 'coded', 'text', 'tagged'
 * @readonly
 * @enum {string}
 */
export enum RouteInstructionsType {
  /**
   * Returns raw instruction data without human-readable messages.
   */
  Coded = 'coded',
  /**
   * Returns raw instructions data with human-readable messages in plain text.
   */
  Text = 'text',
  /**
   * Returns raw instruction data with tagged human-readable messages to permit
   * formatting.
   */
  Tagged = 'tagged',
}

/**
 * Defines values for Type.
 * Possible values include: 'main', 'minor'
 * There could be more values for this enum apart from the ones defined here.If
 * you want to set a value that is not from the known values then you can do
 * the following:
 * let param: Type = <Type>"someUnknownValueThatWillStillBeValid";
 * @readonly
 * @enum {string}
 */
export enum Type {
  Main = 'main',
  Minor = 'minor',
}

/**
 * Defines values for Type1.
 * Possible values include: 'FeatureCollection', 'GeometryCollection',
 * 'Polygon'
 * There could be more values for this enum apart from the ones defined here.If
 * you want to set a value that is not from the known values then you can do
 * the following:
 * let param: Type1 = <Type1>"someUnknownValueThatWillStillBeValid";
 * @readonly
 * @enum {string}
 */
export enum Type1 {
  FeatureCollection = 'FeatureCollection',
  GeometryCollection = 'GeometryCollection',
  Polygon = 'Polygon',
}
