package com.samples.lbs.azure.microsoft.azurelbssample;

import android.content.Context;
import android.os.AsyncTask;
import android.widget.ArrayAdapter;
import android.widget.ListView;

import java.util.ArrayList;
import java.util.LinkedHashMap;

import lbs.implementation.AzureLocationBasedServicesImpl;

/**
 * Created by david on 1/24/18.
 */

public class EnumerateTimezones extends AsyncTask<String, Void, ArrayList<String>> {
    private String subscriptionKey;
    private ListView listView;
    private Context context;

    public EnumerateTimezones(String subscriptionKey, Context ctxt, ListView lv) {
        this.subscriptionKey = subscriptionKey;
        this.context = ctxt;
        this.listView = lv;
    }

    @Override
    protected ArrayList<String> doInBackground(String... strings) {
        ArrayList<String> results = new ArrayList<String>();
        try {
            AzureLocationBasedServicesImpl albs = new AzureLocationBasedServicesImpl();
            ArrayList r = (ArrayList)albs.timezones().getTimezoneEnumIANA("json", "1.0", subscriptionKey);
            if (!r.isEmpty()) {
                for (Object items : r) {
                    LinkedHashMap<Object, Object> item = (LinkedHashMap<Object, Object>) items;
                    if(((Boolean)item.get("IsAlias")) == false) {
                        results.add(item.get("Id").toString());
                    }
                }
            }
        }
        catch(Exception ex) {
            results.clear();
            results.add("Error: " + ex.toString());
        }

        if (results.isEmpty()) {
            results.add("no IANA zones returned");
        }
        return results;
    }

    @Override
    protected void onPostExecute(ArrayList<String> queryResult) {
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(this.context, android.R.layout.simple_list_item_1, queryResult);
        this.listView.setAdapter(adapter);
    }
}
