package com.samples.lbs.azure.microsoft.azurelbssample;

import android.content.Context;
import android.os.Bundle;
//import android.support.design.widget.FloatingActionButton;
//import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.KeyEvent;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

import lbs.implementation.*;


public class MainActivity extends AppCompatActivity {
    private String subscriptionKey = "8C7XgusnLSmoAGspabf1ulr39zPTng7nKGKGlJ6NgVc";
    private AzureLocationBasedServicesImpl albs = new AzureLocationBasedServicesImpl();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        EditText edt = findViewById(R.id.editTextPlaceQuery);
        edt.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView textView, int actionId, KeyEvent keyEvent) {
                boolean handled = false;
                if (actionId == EditorInfo.IME_ACTION_SEND) {
                    onButtonSearch(textView);
                    handled = true;
                }
                return handled;
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    public void onButtonGetTzInfo(View v) {
        // TimeZones Version
        TextView tv = findViewById(R.id.tvIanaVersion);
        new GetIanaVersion(subscriptionKey, tv).execute();

        // Enumerate (non-alias) IANA TimeZones
        ListView lv = findViewById(R.id.listViewTimezones);
        new EnumerateTimezones(subscriptionKey, this, lv).execute();
        lv.invalidateViews();
    }

    public void onButtonSearch(View v) {
        if (v != null) {
            InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(v.getWindowToken(), 0);
        }
        EditText edt = findViewById(R.id.editTextPlaceQuery);
        ListView lv = findViewById(R.id.listViewPlaces);
        String place = edt.getText().toString();
        if (place.length() < 3) {
            lv.setAdapter(null);
        } else {
            new Search(subscriptionKey, this, lv, place).execute();
        }
        lv.invalidateViews();
    }
}
