package com.samples.lbs.azure.microsoft.azurelbssample;

import android.content.Context;
import android.os.AsyncTask;
import android.widget.ArrayAdapter;
import android.widget.ListView;

import java.util.ArrayList;

import lbs.implementation.AzureLocationBasedServicesImpl;
import lbs.models.Searchfuzzy200;
import lbs.models.Searchfuzzy200ResultsItem;

/**
 * Created by david on 1/24/18.
 */

public class Search extends AsyncTask<String, Void, ArrayList<String>> {
    private String subscriptionKey;
    private ListView listView;
    private Context context;
    private String query;

    public Search(String subscriptionKey, Context ctxt, ListView lv, String query) {
        this.subscriptionKey = subscriptionKey;
        this.context = ctxt;
        this.listView = lv;
        this.query = query;
    }

    @Override
    protected ArrayList<String> doInBackground(String... strings) {
        ArrayList<String> results = new ArrayList<String>();
        try {
            AzureLocationBasedServicesImpl albs = new AzureLocationBasedServicesImpl();
            albs.setQuery(this.query);
            Searchfuzzy200 r = (Searchfuzzy200)albs.searchs().getSearchFuzzy("json", "1.0", subscriptionKey);

            if (r.summary().numResults() > 0) {
                for (Searchfuzzy200ResultsItem item : r.results()) {
                    results.add("[" + item.entityType() + "] " + item.address().freeformAddress() + " @ " + item.position().lat() + ", " + item.position().lon());
                }
            }
        }
        catch(Exception ex) {
            results.clear();
            results.add("Error: " + ex.toString());
        }

        if (results.isEmpty()) {
            results.add("no results for " + this.query);
        }
        return results;
    }

    @Override
    protected void onPostExecute(ArrayList<String> queryResult) {
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(this.context, android.R.layout.simple_list_item_1, queryResult);
        this.listView.setAdapter(adapter);
    }
}
