﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Common
{
    /// <summary>
    /// The purpose of this interface is the provide a mechanism to bootstrap the configuration for the common library.
    /// </summary>
    public interface IBootstrapConfiguration
    {
        /// <summary>
        /// Get the bootstrap value given a key
        /// </summary>
        /// <param name="key">the key which should exist in the bootstrap storage</param>
        /// <returns>the value which maps to the specified key</returns>
        string GetValue(string key);
    }
}
