﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Common
{
    using System;
    using Microsoft.Azure.LocationServices.Common.Validation;

    public class BlobExpirationInfo
    {
        public BlobExpirationInfo(Uri blobUri, DateTime blobExpirationDate)
        {
            Assert.ParamIsNotNull(blobUri, nameof(blobUri));

            this.BlobUri = blobUri;
            this.BlobExpirationDate = blobExpirationDate;
        }

        public Uri BlobUri { get; }

        public DateTime BlobExpirationDate { get; }
    }
}