﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------
// 

namespace Microsoft.Azure.LocationServices.Common
{
    using System;
    using System.Threading.Tasks;

    /// <summary>
    /// Implements extension method for Task type
    /// </summary>
    public static class TaskExtensions
    {
        /// <summary>
        /// Makes it look like Task object is used so that StyleCop doesn't complain.
        /// </summary>
        public static void FireAndForget(this Task task)
        {
            // ReSharper disable once IntroduceOptionalParameters.Global
            FireAndForget(task, null);
        }

        /// <summary>
        /// Makes it look like Task object is used so that StyleCop doesn't complain.
        /// </summary>
        public static async void FireAndForget(this Task task, Action<Exception> onError)
        {
            if (task != null)
            {
                try
                {
                    await task.ConfigureAwait(false);
                }
                catch (Exception e)
                {
                    onError?.Invoke(e);
                }
            }
        }
    }
}