﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.Common.Validation
{
    using System.Diagnostics;

    /// <summary>
    /// Debugging utilities
    /// </summary>
    internal class DebugUtilities
    {
        public static void Fail(string message, params object[] args)
        {
            Assert(false, message, args);
        }

        public static void Assert(bool condition, string message, params object[] args)
        {
            if (!condition)
            {
                if (Debugger.IsAttached)
                {
                    Debugger.Break();
                }
            }
        }
    }
}