class OperationFilter {

    constructor(property, value) {
        this.property = property;
        this.value = value;
    }

    filter(schema) {
        for (var pathName in schema.paths) {
            var path = schema.paths[pathName];
            for (var operationName in path) {
                var operation = path[operationName];

                if (!operation.hasOwnProperty(this.property)) {
                    delete schema.paths[pathName][operationName];
                } else if (operation[this.property] !== this.value) {
                    delete schema.paths[pathName][operationName];
                }

                if (Object.keys(path).length === 0) {
                    delete schema.paths[pathName];
                }
            }
        }

        return schema;
    }

}

module.exports = OperationFilter;