﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.TimeZoneDb
{
    using TimeZoneNames;

    public class LocalizedTimeZoneNames
    {
        public LocalizedTimeZoneNames()
        {
            ISO6391LanguageCode = "No supported language code supplied";
            Generic = string.Empty;
            Daylight = string.Empty;
            Standard = string.Empty;
        }

        public LocalizedTimeZoneNames(string iso6391LanguageCode, TimeZoneValues names)
        {
            ISO6391LanguageCode = iso6391LanguageCode;
            Generic = names.Generic;
            Standard = names.Standard;
            Daylight = names.Daylight;
        }

        public string ISO6391LanguageCode { get; set; }

        public string Generic { get; set; }

        public string Standard { get; set; }

        public string Daylight { get; set; }
    }
}
