﻿// ---------------------------------------------------------------------------------
// <copyright company="Microsoft">
//   Copyright (c) 2017 Microsoft Corporation. All rights reserved.
// </copyright>
// ---------------------------------------------------------------------------------

namespace Microsoft.Azure.LocationServices.TimeZoneDb
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// These codes are reflected in our public docs. Changes here should be accompanied by changes to the docs.
    /// </summary>
    public class SupportedLocalizationLanguages
    {
        private static readonly HashSet<string> lanaguages = new HashSet<string>(StringComparer.InvariantCultureIgnoreCase)
        {
            "en", "de", "es", "fr", "it", "ja", "ko", "pt-BR", "ru", "zh-HanS", "zh-HanT", "cs", "pl", "tr", "hu", "nl", "pt-PT",
            "sv", "da", "el", "fi", "nb", "et", "eu", "gl", "he", "hi", "hr", "id", "kk", "lt", "lv", "ms", "ro", "sk", "sl", "sr-Cyrl",
            "sr-Latn", "th", "uk", "vi", "bg", "ar", "ca-ES", "af-ZA", "nl-BE", "es-MX", "fr-CA", "es-419"
        };

        public static bool IsSupported(string langaugeCode)
        {
            return lanaguages.Contains(langaugeCode);
        }
    }
}
