"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
const amqp_common_1 = require("../amqp-common");
/**
 * @class IotSasTokenProvider
 * Defines the SasTokenProvider for IotHub.
 */
class IotSasTokenProvider extends amqp_common_1.SasTokenProvider {
    /**
     * Gets the sas token for the specified audience for IotHub.
     * @param {string} [audience] - The audience for which the token is desired. If not
     * provided then the Endpoint from the connection string will be applied.
     */
    async getToken(audience) {
        return this._createToken(Math.floor(Date.now() / 1000) + this.tokenValidTimeInSeconds, audience, Buffer.from(this.key, "base64"));
    }
}
exports.IotSasTokenProvider = IotSasTokenProvider;
//# sourceMappingURL=iotSas.js.map